// ExportKTSDlg.cpp : implementation file
//

#include "stdafx.h"
#include "apl_api.h"
#include "ExportKTSDlg.h"
#include "apl_gui.h"
#include "ReportDict.h"
#include "CommonQuery.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExportKTSDlg dialog

Template_item templates[] = { Template_item("1   2.104-68", "_1 __2.104-68.apldot"), 
								Template_item("2   2.104-68", "_2 __2.104-68.apldot"),
								Template_item(" 1", "_2.108-68__2_().apldot"),
								Template_item(" 2", "_2.108-68__2_()_2.apldot")
							};

CExportKTSDlg::CExportKTSDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExportKTSDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExportKTSDlg)
	m_sContext = _T("");
	m_sDate = _T("");
	m_sDotPath = _T("");
	m_sId = _T("");
	m_sName = _T("");
	m_sVer = _T("");
	m_sSN = _T("");
	m_sCharId = _T("");
	m_sOutFilename = _T("");
	m_preview = FALSE;
	m_bUseMFUO = FALSE;
	m_add_if_has_SubString = FALSE;
	m_add_substitutes = FALSE;
	m_AddZagotov = FALSE;
	//}}AFX_DATA_INIT

	m_api= NULL;
	m_date.SetStatus(COleDateTime::invalid);
	m_pdf= NULL;
	m_prd= NULL;
	m_context= NULL;
	m_charact= NULL;

	m_sDataPath= getenv("temp");
	m_sParamPath= "part.par";
}


void CExportKTSDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExportKTSDlg)
	DDX_Control(pDX, IDC_SUB_STRING, m_sub_str_ctrl);
	DDX_Control(pDX, IDC_TEMPLATE, m_templ_combo);
	DDX_Control(pDX, IDCANCEL, m_cancel_btn);
	DDX_Control(pDX, IDOK, m_ok_btn);
	DDX_Text(pDX, IDC_CONTEXT_EDIT, m_sContext);
	DDX_Text(pDX, IDC_DATE_EDIT, m_sDate);
	DDX_Text(pDX, IDC_KTS_PRD_ID_EDIT, m_sId);
	DDX_Text(pDX, IDC_KTS_PRD_NAME_EDIT, m_sName);
	DDX_Text(pDX, IDC_KTS_PRD_VER_EDIT, m_sVer);
	DDX_Text(pDX, IDC_SN_EDIT, m_sSN);
	DDX_Text(pDX, IDC_CHAR_ID_EDIT, m_sCharId);
	DDX_Text(pDX, IDC_OUT_FILE, m_sOutFilename);
	DDX_Check(pDX, IDC_PREVIEW, m_preview);
	DDX_Check(pDX, IDC_USE_MFUO, m_bUseMFUO);
	DDX_Check(pDX, IDC_ADD_ONLY_HAS_SUBSTRING, m_add_if_has_SubString);
	DDX_Check(pDX, IDC_ADD_SUBSTITUTES, m_add_substitutes);
	DDX_Check(pDX, IDC_ADD_ZAGOTOV, m_AddZagotov);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CExportKTSDlg, CDialog)
	//{{AFX_MSG_MAP(CExportKTSDlg)
	ON_BN_CLICKED(IDC_DOT_SELECT_BUTTON, OnDotSelectButton)
	ON_BN_CLICKED(IDC_EXE_SELECT_BUTTON, OnExeSelectButton)
	ON_BN_CLICKED(IDC_SET_FILTER_BUTTON, OnSetFilterButton)
	ON_BN_CLICKED(IDC_SELECT_CHAR_BUTTON, OnSelectCharButton)
	ON_BN_CLICKED(IDC_SEL_REPORT_FILE, OnSelReportFile)
	ON_BN_CLICKED(IDC_ADD_ONLY_HAS_SUBSTRING, OnAddOnlyHasSubstring)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExportKTSDlg message handlers

BOOL CExportKTSDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_ok_btn.SetIcon(GetAplStdIco16(APLSTDICO_OK));
	m_ok_btn.SetFlat(FALSE);
	m_cancel_btn.SetIcon(GetAplStdIco16(APLSTDICO_CANCEL));
	m_cancel_btn.SetFlat(FALSE);


	if(m_api->m_data.IsConnected() && (m_pdf || m_prd))
	{
		CString buf;

		if(m_pdf)
		{
			m_api->m_data.GetAttr(m_pdf, m_api->m_prd_mgr.a_pdf_prd, m_prd);
			m_api->m_data.GetAttr(m_pdf, m_api->m_prd_mgr.a_pdf_id, m_sVer);
		}

		if(m_prd)
		{
			CString buf;
			if(m_pdf) m_api->m_data.GetAttr(m_pdf, m_api->m_prd_mgr.a_pdf_id, buf);
			m_api->m_data.GetAttr(m_prd, m_api->m_prd_mgr.a_prd_id, m_sId);
			m_api->m_data.GetAttr(m_prd, m_api->m_prd_mgr.a_prd_name, m_sName);
			if(!buf.IsEmpty())
				m_sId+= " - " + buf;
		}

		
		
		DWORD dwPathLen= 256;
		
		char* szPath= new char[dwPathLen];

		GetPrivateProfileString("Paths", "Dictionary", "", szPath, dwPathLen,
									   "AplTransport.ini");
		
		m_sDictPath= szPath; 
		
		if(m_sDictPath.GetLength() && m_sDictPath[m_sDictPath.GetLength()-1]!='\\')
			m_sDictPath+='\\';

//		m_sDotPath= m_sDictPath+"Spec2.aplb";
//		m_sExePath= m_sDictPath+"ReportConstructor.exe";

		if(szPath) delete [] szPath;

		m_charact= m_api->m_charact_mgr.GetCharacteristicById("");
		if(m_charact)
		{
			m_api->m_data.GetAttr(m_charact, m_api->m_charact_mgr.a_apl_charact_id, m_sCharId);
			m_api->m_data.GetAttr(m_charact, m_api->m_charact_mgr.a_apl_charact_name, buf);

			if(!m_sCharId.IsEmpty()) m_sCharId+=":"; m_sCharId+=buf;			
		}
	}
	
	
	//    
	HMODULE hModule;
	char buf1[2048];
	CString t_str;
	int index;

	hModule = GetModuleHandle(NULL);
	if(hModule!=NULL)
	{
		if(GetModuleFileName(hModule,buf1,2048)>0)
		{
			//      dll
			t_str = buf1;
			index =t_str.ReverseFind('\\');
			m_sExePath = t_str.Left(index);

		}	
	}

	//   
	CStringArray arr;
	ReadDots("ExportKTS.dots", "ExportKTS_KTS", &arr);
	int i, count = arr.GetSize(), def_ind = -1;
	CFile file;
	CString buf;
	for(i =0 ; i < count; i++)
	{
		buf = arr[i];
		if(buf.IsEmpty())
			continue;
		if(buf[0]==';')
			continue;
		if(buf[0]=='&')
		{
			def_ind = i;
			buf = buf.Right(buf.GetLength()-1);
		}
		if(file.Open(m_sExePath+"\\"+buf, CFile::modeRead))
		{
			file.Close();
			m_templ_combo.AddString(buf);
		}
	}

	//     

	CString last_template;
	CWinApp * app = AfxGetApp();

	if(app!=NULL)
	{
		last_template = app->GetProfileString("ExportKTS_plugin","LastSelectedSpecTemplate");
	}
	
	//    
	if(m_templ_combo.GetCount() > 0)
	{
		if(!last_template.IsEmpty())
		{
			if(m_templ_combo.SelectString(0,last_template)==CB_ERR)
			{
				if(def_ind>-1)
					m_templ_combo.SetCurSel(def_ind);
				else
					m_templ_combo.SetCurSel(0);
			}
		}
		else
		{
			if(def_ind>-1)
				m_templ_combo.SetCurSel(def_ind);
			else
				m_templ_combo.SetCurSel(0);
		}
	}
	
	
	m_sContext= " ";
	m_sDate= " ";
	m_sSN= " ";

	//     

	CString out_path; 
	
	if(app!=NULL)
	{
		out_path = app->GetProfileString("ExportKTS_plugin","OutReportPath");
		CString m_filter_doc_by_Descr ="";
		m_filter_doc_by_Descr = app->GetProfileString("ExportKTS_plugin","DocDescriptionFiler","");
		m_add_if_has_SubString = (BOOL)app->GetProfileInt("ExportKTS_plugin","UseDocDescriptionFiler", 0);
		m_add_substitutes = (BOOL)app->GetProfileInt("ExportKTS_plugin","AddSubstitutes", 0);
		m_AddZagotov = (BOOL)app->GetProfileInt("ExportKTS_plugin","AddZagotov", 0);
		m_sub_str_ctrl.SetWindowText(m_filter_doc_by_Descr);
		m_bUseMFUO = (BOOL)app->GetProfileInt("ExportKTS_plugin","Mater-Norm", 0);
	}

	if(out_path=="")
	{
		//   
		//  Temp
		char buf[_MAX_PATH];
		
		GetTempPath(_MAX_PATH,buf);
		out_path = buf;
		m_sOutFilename.Format("%s%s.aplrep",out_path,m_sId);
		
	}
	else
	{
		m_sOutFilename.Format("%s\\%s.aplrep",out_path,m_sId);
	}
	
	m_sub_str_ctrl.EnableWindow(m_add_if_has_SubString);

	UpdateData(FALSE);
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CExportKTSDlg::OnDotSelectButton() 
{
	UpdateData();
	CFileDialog dlg(TRUE, 0, 0, OFN_FILEMUSTEXIST|OFN_HIDEREADONLY,
		"  (*.aplb)|*.aplb||");
	
	if(dlg.DoModal()==IDOK)
	{
		m_sDotPath= dlg.GetPathName();
	}
	UpdateData(FALSE);
}

void CExportKTSDlg::OnExeSelectButton() 
{
	UpdateData();
	CFileDialog dlg(TRUE, 0, 0, OFN_FILEMUSTEXIST|OFN_HIDEREADONLY,
		"  (*.exe)|*.exe||");
	
	if(dlg.DoModal()==IDOK)
	{
//		m_sExePath= dlg.GetPathName();
	}
	UpdateData(FALSE);
}

void CExportKTSDlg::OnSelectCharButton() 
{
	UpdateData();

	CaplInstance* oldChar= m_charact;

	m_charact= m_api->m_charact_mgr.SelectCharacteristic();

	if(!m_charact && oldChar)
	{
		if(IDNO==MessageBox(" \"\"  .   ?", 
			"  \"\"", MB_YESNO| MB_ICONQUESTION))
		{
			m_sCharId= "";
		}
		else m_charact= oldChar;
	}
	
	if(m_charact)
	{
		CString buf;

		m_api->m_data.GetAttr(m_charact, m_api->m_charact_mgr.a_apl_charact_id, m_sCharId);
		m_api->m_data.GetAttr(m_charact, m_api->m_charact_mgr.a_apl_charact_name, buf);

		if(!m_sCharId.IsEmpty()) m_sCharId+=":"; m_sCharId+=buf;
	}

	UpdateData(FALSE);
}

void CExportKTSDlg::OnSetFilterButton() 
{
	UpdateData();

	CaplInstance *new_cont=0;
	if(m_sSN==" ") m_sSN= "";
	if(m_sDate==" ") m_date.SetStatus(COleDateTime::invalid);
	
	if(m_api->m_prd_mgr.SelectDateSN(m_sSN, m_date, m_context, &new_cont))
	{
		if(m_sSN.IsEmpty()) m_sSN= " ";
		
		if(m_date.GetStatus()==COleDateTime::valid)
			m_sDate=m_date.Format("%d.%m.%Y  %H:%M:%S");
		else
			m_sDate= " ";
		
		m_context = new_cont;
		if(m_context)
		{
			aplExtent ext; ext.Add(m_context);
			m_api->m_prd_mgr.PrintItemContextInString(ext, m_sContext);
		}
		else
			m_sContext= " ";
		
		UpdateData(FALSE);
	}
	
	UpdateData();
}

CaplInstance* CExportKTSDlg::GetSecondLevel(CaplInstance *pAssoc)
{
	aplExtent aeSubLvls, aeItems;
	CaplInstance *cit = NULL, *ciLvl;
	if(!pAssoc) return NULL;
	
	m_api->m_data.GetAttr(pAssoc, m_api->m_classifier_mgr.a_apl_classifier_association_classifier, ciLvl);
	while(ciLvl)
	{
		m_api->m_data.GetAttr(ciLvl, m_api->m_classifier_mgr.a_apl_classifier_level_parent, cit);
		if(!cit) 
		{
			m_api->LoadItemInfo(ciLvl);
			return ciLvl;
		}

		ciLvl = cit;
	}

	return NULL;
}

void CExportKTSDlg::FillMapWithDocs(CaplMap &map, aplExtent &aePdf)
{
	CString sType, buf, sDoc;
	aplExtent aeDocs, aeDocRels;
	CaplInstance *ciPartDT = NULL, *cit = NULL, *ciAssamblyDT = NULL, *ciPdf = NULL, *ciDoc = NULL;

	ciPartDT = m_api->m_doc_mgr.GetDocumentTypeBN(" ");
	ciAssamblyDT = m_api->m_doc_mgr.GetDocumentTypeBN("");

	map.Clear();
		
	m_api->m_doc_mgr.FindAssociatedDocuments(aePdf, aeDocs, aeDocRels);
	for(int m=0; m<aeDocRels.GetSize(); m++)
	{
		m_api->m_data.GetAttr(aeDocRels[m], m_api->m_doc_mgr.a_apl_doc_ref_item, ciPdf);
		m_api->m_data.GetAttr(aeDocRels[m], m_api->m_doc_mgr.a_apl_doc_ref_doc, ciDoc);

		m_api->m_data.GetAttr(ciPdf, m_api->m_prd_mgr.a_apl_pdf_type, sType);
		sType.MakeLower();

		m_api->m_data.GetAttr(ciDoc, m_api->m_doc_mgr.a_doc_kind, cit);
		if(sType == "assembly")
		{
			if(cit!=ciAssamblyDT || !ciAssamblyDT) 
			{
				aeDocRels.Remove(m); 
				m--; 
				continue; 
			}			
		}
		else if(sType == "part")
		{			
			if(cit!=ciPartDT || !ciPartDT) 
			{
				aeDocRels.Remove(m); 
				m--; 
				continue;
			}				
		}

		map.Add(long(ciPdf), long(ciDoc));
	}
		
	map.SortIn();
}

CString CExportKTSDlg::GetFormatFromDoc(CaplMap &map, CaplInstance *ciPdf)
{
	CString sFormat;
	int nIndex = -1;
	CaplInstance *ciDrawDoc = NULL, *cit = NULL;
	
	nIndex = map.QFindByIn(long(ciPdf));
	if(nIndex != -1)
	{	
		ciDrawDoc = (CaplInstance*)map.operator [](nIndex).out;
		if(ciDrawDoc)
		{
			m_api->m_data.GetAttr(ciDrawDoc, m_api->m_doc_mgr.a_apl_doc_active, cit);
			if(cit) m_api->m_data.GetAttr(cit, m_api->m_doc_mgr.a_apl_doc_rev_format, sFormat);				
		}
	}	

	return sFormat;
}

CString CExportKTSDlg::GetType(CString type, CString stand, CString source)
{
	CString sResult;

	if(type == "komplex" && stand == "no")
	{
		return "2";
	}
	else if(type == "assembly" && stand == "no" && source != "bought")
	{
		return "3";
	}
	else if(type == "part" && stand == "no" && source != "bought")
	{
		return "4";
	}
	else if(type != "material" && stand == "yes")
	{
		return "5";
	}
	else if(stand == "no" && source == "bought" && type != "assembly" && type != "material")
	{
		return "6";
	}
	else if(type == "material")
	{
		return "7";
	}
	else if(type == "kit" && stand == "no" && source != "bought")
	{
		return "8";
	}

	return "";
}

void CExportKTSDlg::FillPdfSpec(CaplInstance *ciPdf, CDataSource *m_data_source, CString sModify)
{
	aplExtent items;
	aplExtent ext,ext1,ext_rel;
	CString m_filter_doc_by_Descr="", sFullName;
	m_sub_str_ctrl.GetWindowText(m_filter_doc_by_Descr);

	CaplInstance *doc_type, *ciRev = NULL;
	m_api->GetItemName(ciPdf, sFullName);
	
	CString format, zone, pos, s_pos, id, name, count, descr, type, buf, mater, mass, pdf_id;
	CString prd_descr;
	//  
	items.Add(ciPdf);
	m_api->m_doc_mgr.FindAssociatedDocuments(items, ext, ext_rel);
	ext.Append(ext1);
	
	int i;
	CTableRow* row;
	for(i=0; i<ext.Size; i++)
	{
		format=""; zone=""; pos=""; id=""; name=""; descr="";
		s_pos = ""; prd_descr= "";
		apidata.GetAttr(ext[i], m_api->m_doc_mgr.a_doc_id, id);
		apidata.GetAttr(ext[i], m_api->m_doc_mgr.a_doc_name, name);
		apidata.GetAttr(ext[i], m_api->m_doc_mgr.a_doc_descr, descr);
		apidata.GetAttr(ext[i], m_api->m_doc_mgr.a_doc_kind, doc_type);
		if(doc_type) apidata.GetAttrBN(doc_type, "product_data_type", type);
		CString tmp, buf, sDescr = descr;
		descr.Replace("\r", "");
		tmp = descr;
		int ind = tmp.Find("\n");
		if(ind<0)
		{
			ind = tmp.GetLength();
			descr.Empty();
		}
		else
			descr = descr.Right(descr.GetLength()-descr.Find("\n",0)-1);
		tmp = tmp.Left(ind);
		m_filter_doc_by_Descr.MakeLower();
		tmp.MakeLower();
		if(tmp.Find(m_filter_doc_by_Descr)!=0 && m_add_if_has_SubString)
			continue;
		
		ind = descr.Find("\n",0);
		if(ind<0) ind = descr.GetLength();
		format = descr.Left(ind);
		descr = descr.Right(descr.GetLength()-ind);
		descr.TrimLeft("\n");
		descr.TrimRight("\n");

		sDescr.Replace("\r\n", " ");
		m_api->m_data.GetAttr(ext[i], m_api->m_doc_mgr.a_apl_doc_active, ciRev);
		m_api->m_data.GetAttr(ciRev, m_api->m_doc_mgr.a_apl_doc_rev_format, format);		

		row = new CTableRow;
		row->AddColumn("");			//       ,
		row->AddColumn("");			//      MPSpecification.dll
		row->AddColumn(format);
		row->AddColumn(zone);
		row->AddColumn(pos);
		row->AddColumn("");//ref_des
		row->AddColumn(id);
		row->AddColumn("");			//       ,
		row->AddColumn(0);			//      MPSpecification.dll
		row->AddColumn(name);
		row->AddColumn("");
		row->AddColumn("");
		row->AddColumn(sDescr);
		row->AddColumn("");
		row->AddColumn("");
		row->AddColumn("");
		row->AddColumn("");
		row->AddColumn("");
		row->AddColumn("");
		row->AddColumn("");
		row->AddColumn("Doc");
		row->AddColumn("");
		//row->AddColumn(sModify);
		//row->AddColumn(sFullName);
		row->AddColumn(type);
		row->AddColumn("");
		row->AddColumn("");
		row->AddColumn("");
		row->AddColumn(ext[i]);
		row->AddColumn(1);
		m_data_source->AddRow(row);
	}

	//  
	bool std_pdf;
	CString id_add, sFirstUsage;

	m_api->m_prd_mgr.LoadAllSubProduct(0, m_context, ciPdf, ext, ext1);
	
	//  
	if(!m_sSN.IsEmpty() && m_sSN!=" ")
	{
		i=ext.GetSize();
		m_api->m_prd_mgr.FilterlBySN(ext, m_sSN, ext1);
		if(i!=ext1.GetSize())
		{
			id_add.Format("\n(%s)",LPCSTR(m_sSN));
			ext.Clear();
			ext.Append(ext1);
		}
	}
	if(!m_sDate.IsEmpty() && m_sDate!=" ")
	{
		i=ext.GetSize();
		m_api->m_prd_mgr.FilterlByDate(ext, m_date, ext1);
		if(i!=ext1.GetSize())
		{
			CString tmp= m_date.Format();
			id_add.Format(" (%s)",LPCSTR(tmp));
			ext.Clear();
			ext.Append(ext1);
		}
	}
	
	//  
	int m, ii;
	ext1.Clear();
	for(ii= 0; ii<ext.GetSize(); ii++)
	{
		CaplInstance* pInst1= NULL, *pInst2= NULL;
		apidata.GetAttr(ext[ii], m_api->m_prd_mgr.a_pdr_r_ted, pInst1);
		apidata.GetAttr(pInst1, m_api->m_prd_mgr.a_pdf_prd, pInst2);
		ext1.Add(pInst1); ext1.Add(pInst2);
	}
	
	aplExtent all_chars, all_gr_chars;
	m_api->m_charact_mgr.FindAssociatedCharacteristic(ext1, all_chars, all_gr_chars);

	//  ,    
	CaplInstance *inst,*i_prd,*i_pdf, *pdr;
	bool IsSubstitute = false;

	int nIndex = 0;
	CaplMap map, DocMap;;
	aplExtent aeClsf, aePdfs, aeRels, aeTmp, aeDocs, aeDocRels;
	aplExtent *aepAssoc = new aplExtent;
	CaplInstance *ciIng = NULL;
	CaplInstance *cit = NULL, *ciAssoc = NULL, *ciDrawDoc = NULL, *ciDT = NULL, *ciFirstUsage = NULL;

	/****************************************************************************************/
	/****************************************************************************************/

	for(m=0; m<ext.Size; m++)
	{
		apidata.GetAttr(ext[m], m_api->m_prd_mgr.a_pdr_r_ted, i_pdf);
		apidata.GetAttr(i_pdf, m_api->m_prd_mgr.a_pdf_prd, cit);
		apidata.GetAttr(cit, m_api->m_prd_mgr.a_prd_id, id);

		aePdfs.Add(i_pdf);
		if(id.Right(3)=="3")
			m_api->m_prd_mgr.LoadAllSubProduct(NULL, m_context, i_pdf, aeRels, aeTmp);												
	}

	// ,   
	aePdfs.Append(aeTmp);
	m_api->m_classifier_mgr.FindClassifiersContained(aePdfs, aeClsf, aepAssoc);
	for(m=0; m<aepAssoc->GetSize(); m++)
	{
		m_api->m_data.GetAttr(aepAssoc->GetAt(m), m_api->m_classifier_mgr.a_apl_classifier_association_item, cit);
		ciAssoc = aepAssoc->GetAt(m);
		map.Add(long(cit), long(ciAssoc));
	}

	map.SortIn();

	//    
	FillMapWithDocs(DocMap, aePdfs);		
	
	/****************************************************************************************/
	/****************************************************************************************/

	//  
	for(ii=0; ii<ext.Size; ii++)
	{
		format=""; zone=""; pos=""; id=""; name=""; descr="";count="";mater= "";mass= "";
		s_pos = ""; prd_descr = ""; sFirstUsage = "";pdf_id = "";
		ciFirstUsage = NULL; ciIng = NULL;

		CString stand="", e_type="", source="";
		pdr = ext[ii];
		if(m_api->m_data.IsKindOf(pdr, m_api->m_prd_mgr.e_pdf_subst) && m_add_substitutes)
		{
			GetSubstituteName(0, pdr, descr);
			apidata.GetAttr(pdr, m_api->m_prd_mgr.a_pdf_subst_pdf, i_pdf);
			apidata.GetAttr(pdr, m_api->m_prd_mgr.a_pdf_subst_id, pos);
			IsSubstitute = true;
		}
		else
		{
			apidata.GetAttr(pdr, m_api->m_prd_mgr.a_pdr_descr, descr);
			apidata.GetAttr(pdr, m_api->m_prd_mgr.a_pdr_r_ted, i_pdf);						
			apidata.GetAttr(pdr, m_api->m_prd_mgr.a_pdr_r_ting, ciIng);
			apidata.GetAttr(pdr, m_api->m_prd_mgr.a_pdr_id, pos);
		}

		if(m_api->m_data.IsKindOf(pdr, m_api->m_prd_mgr.e_acu))
			apidata.GetAttr(pdr, m_api->m_prd_mgr.a_acu_ref_des, s_pos);
		
		CStringArray csa;
		GetMaterials(i_pdf,csa);
		apidata.GetAttr(i_pdf, m_api->m_prd_mgr.a_pdf_prd, i_prd);
		apidata.GetAttr(i_pdf, m_api->m_prd_mgr.a_apl_pdf_type, type);
		apidata.GetAttr(i_pdf, m_api->m_prd_mgr.a_apl_pdf_standard, std_pdf);
		apidata.GetAttr(i_prd, m_api->m_prd_mgr.a_prd_id, id);
		apidata.GetAttr(i_prd, m_api->m_prd_mgr.a_prd_name, name);
		apidata.GetAttr(i_pdf, m_api->m_prd_mgr.a_apl_pdf_first_usage, ciFirstUsage);
		if(ciFirstUsage && ciFirstUsage!=ciIng)
		{
			m_api->LoadItemInfo(ciFirstUsage);
			m_api->m_data.GetAttr(ciFirstUsage, m_api->m_prd_mgr.a_pdf_prd, cit);
			m_api->m_data.GetAttr(cit, m_api->m_prd_mgr.a_prd_id, sFirstUsage);
			m_api->m_data.GetAttr(cit, m_api->m_prd_mgr.a_prd_name, buf);
			if(!buf.IsEmpty()) sFirstUsage += ":" + buf;
			m_api->m_data.GetAttr(ciFirstUsage, m_api->m_prd_mgr.a_pdf_id, buf);
			if(!buf.IsEmpty()) sFirstUsage += " - " + buf;
		}
		
		//      
		//apidata.GetAttr(i_prd, m_api->m_prd_mgr.a_prd_descr, prd_descr);
		cit = NULL; prd_descr.Empty(); ciAssoc = NULL;
		nIndex = map.QFindByIn((long)i_pdf);
		ciAssoc = (CaplInstance*)map.operator [](nIndex).out;
		if(nIndex != -1) cit = GetSecondLevel(ciAssoc);
		if(cit) m_api->m_data.GetAttr(cit, m_api->m_classifier_mgr.a_apl_classifier_level_name, prd_descr);
													
		apidata.GetAttr(i_pdf, m_api->m_prd_mgr.a_pdfwss_source, source);
		apidata.GetAttr(i_pdf, m_api->m_prd_mgr.a_pdf_id,pdf_id);
		double r_count;
		apidata.GetAttrBN(ext[ii], "value_component", r_count);		
		
		if(id.Right(3)=="3")
		{
			aplExtent rels, pdfs;
			m_api->m_prd_mgr.LoadAllSubProduct(NULL, m_context, i_pdf, rels, pdfs);

			//    
			if(!m_sSN.IsEmpty() && m_sSN!=" ")
			{
				m_api->m_prd_mgr.FilterlBySN(rels, m_sSN, pdfs);
				rels.Clear();
				rels.Append(pdfs);
			}
			if(!m_sDate.IsEmpty() && m_sDate!=" ")
			{
				m_api->m_prd_mgr.FilterlByDate(rels, m_date, pdfs);
				rels.Clear();
				rels.Append(pdfs);
			}
			int z;
			aplExtent chars;
			for(z= 0; z<ext.GetSize(); z++)
			{
				CaplInstance* pInst1= NULL, *pInst2= NULL;
				apidata.GetAttr(ext[z], m_api->m_prd_mgr.a_pdr_r_ted, pInst1);
				apidata.GetAttr(pInst1, m_api->m_prd_mgr.a_pdf_prd, pInst2);
				pdfs.Add(pInst1); pdfs.Add(pInst2);
			}
			m_api->m_charact_mgr.FindAssociatedCharacteristic(pdfs, chars);
			all_chars.Append(chars);
			ext.Append(rels);

			continue;
		}

		stand = std_pdf?"yes":"no";
		
		if(id.Find(name)>=0)
		{
			id.Replace(name,""); //      
			id.TrimLeft(" ");
			id.TrimRight(" ");
		}

		if(r_count==0) count=""; else count.Format("%g",r_count);
				
		if(type=="material" && !IsSubstitute)
		{
			apidata.GetAttrBN(ext[ii], "unit_component", inst);
			if(inst!=0)apidata.GetAttrBN(inst, "id", descr);
		}

		// 
		CaplInstance* char_val= NULL;
		for(int j= 0; j<all_chars.GetSize(); j++)
		{
			CaplInstance* tempInst= NULL;
			m_api->m_data.GetAttr(all_chars[j], m_api->m_charact_mgr.a_apl_charact_val_charact, tempInst);
			if(tempInst!=m_charact)
			{
				all_chars.Remove(j); j--; continue;
			}
			
			tempInst= NULL;
			m_api->m_data.GetAttr(all_chars[j], m_api->m_charact_mgr.a_apl_charact_val_item, tempInst);
			if(tempInst!=i_pdf && tempInst!=i_prd) continue;
			
			tempInst= NULL;
			m_api->m_data.GetAttr(all_chars[j], m_api->m_charact_mgr.a_apl_charact_val_type, tempInst);
			
			//      
			if(!tempInst)
			{
				char_val= all_chars[j];
				break;
			}

			if(!char_val)
			{
				char_val= all_chars[j];				
			}
		}
		
		if(char_val)
		{
			m_api->m_charact_mgr.PrintCharacteristicValue(char_val, NULL, mass);
		}
		
		if(type=="part" || type=="material")
		{
			aplExtent all_mater, all_mater_rel;
			m_api->m_prd_mgr.LoadAllZagotov(i_pdf, all_mater_rel, all_mater);
			
			CaplInstance* materPdf= NULL;
			int iRank=9999;
			
			for(int j= 0; j<all_mater.GetSize(); j++)
			{
				if(!m_api->m_data.IsKindOf(all_mater_rel[j], m_api->m_prd_mgr.e_make_from))
					continue;

				int iCurRank;
				
				m_api->m_data.GetAttr(all_mater_rel[j], m_api->m_prd_mgr.a_make_from_ranking, iCurRank);
				//  
				if(iCurRank<iRank)
				{
					materPdf= all_mater[j];
					iRank= iCurRank;
				}
			}
			if(materPdf)
			{
				CaplInstance* materPrd= NULL;
				m_api->m_data.GetAttr(materPdf, m_api->m_prd_mgr.a_pdf_prd, materPrd);
				if(materPrd)
				{
					m_api->m_data.GetAttr(materPrd, m_api->m_prd_mgr.a_prd_id, mater);				
					m_api->m_data.GetAttr(materPrd, m_api->m_prd_mgr.a_prd_name, buf);
					if(!mater.IsEmpty()) mater+=" "; mater+=buf;
				}
			}
		}

		//  
		if(m_add_substitutes)
		{
			if(m_api->m_data.IsKindOf(ext[ii], m_api->m_prd_mgr.e_pdr))
			{
				aplExtent Substitutes;
				if(GetSubstituteName(ext[ii], 0, descr, &Substitutes))
				{
					ext.Append(Substitutes);
					count = "";
				}
			}
		}
		if(IsSubstitute)
			count = "";


		//     (  )
		format.Empty();
 		if((type=="part" || type=="assembly") && source!="bought")
			format = GetFormatFromDoc(DocMap, i_pdf);
						
		e_type = "pdf";
		
		row = new CTableRow;
		row->AddColumn("");			//       ,
		row->AddColumn("");			//      MPSpecification.dll
		row->AddColumn(format);//format`
		row->AddColumn("");//zone
		row->AddColumn(pos);//pos
		row->AddColumn(s_pos);//ref_des
		row->AddColumn(id);//id
		row->AddColumn("");			//       ,
		row->AddColumn(0);			//      MPSpecification.dll
		row->AddColumn(name);//name
		row->AddColumn(prd_descr);// 
		if(count.IsEmpty())
			row->AddColumn(count);//count
		else
			row->AddColumn(atof(count));//count
		row->AddColumn(descr);//descr
		row->AddColumn(mass);//mass
		for(i=0;i<6;i++)
		{
			row->AddColumn(csa[i]);
		}
//		row->AddColumn(mater);//mater
		row->AddColumn(e_type);//e_type
		row->AddColumn(sFirstUsage);
		//row->AddColumn(sModify);
		//row->AddColumn(sFullName);

		row->AddColumn(type);//type
		row->AddColumn(stand);//stand
		row->AddColumn(source);//source
		row->AddColumn(pdf_id);//source

		row->AddColumn(i_pdf);//
		row->AddColumn(1);
		m_data_source->AddRow(row);
		
		if(type.CompareNoCase("part")==0 && m_AddZagotov)
		{
			aplExtent rels, pdfs;
			descr.Format("  %s", id);
			if(!pdf_id.IsEmpty())
				descr+=" - "+pdf_id;
			m_api->m_prd_mgr.LoadAllZagotov(i_pdf, rels, pdfs, true);

			for(int j=0; j<rels.GetSize(); j++)
			{
				if(!m_api->m_data.IsKindOf(rels[j], m_api->m_prd_mgr.e_make_from))
				format.Empty(); zone.Empty(); pos.Empty(); id.Empty(); name.Empty(); 
				count.Empty(); mater.Empty(); mass.Empty(); sFirstUsage.Empty(); pdf_id.Empty();
				ciFirstUsage = NULL; ciIng = NULL;
				
				CString stand, e_type, source;

				apidata.GetAttr(rels[j], m_api->m_prd_mgr.a_pdr_r_ted, i_pdf);
				apidata.GetAttr(rels[j], m_api->m_prd_mgr.a_pdr_r_ting, ciIng);
				apidata.GetAttr(rels[j], m_api->m_prd_mgr.a_pdr_id, pos);

				CStringArray csa;
				GetMaterials(i_pdf,csa);
				apidata.GetAttr(i_pdf, m_api->m_prd_mgr.a_pdf_prd, i_prd);
				apidata.GetAttr(i_pdf, m_api->m_prd_mgr.a_apl_pdf_type, type);
				if(type.CompareNoCase("part")!=0) continue;
				apidata.GetAttr(i_pdf, m_api->m_prd_mgr.a_apl_pdf_standard, std_pdf);
				apidata.GetAttr(i_prd, m_api->m_prd_mgr.a_prd_id, id);
				apidata.GetAttr(i_prd, m_api->m_prd_mgr.a_prd_name, name);
				apidata.GetAttr(i_pdf, m_api->m_prd_mgr.a_pdfwss_source, source);
				apidata.GetAttr(i_pdf, m_api->m_prd_mgr.a_pdf_id,pdf_id);
				apidata.GetAttr(i_pdf, m_api->m_prd_mgr.a_apl_pdf_first_usage, ciFirstUsage);
				if(ciFirstUsage && ciFirstUsage!=ciIng)
				{
					m_api->LoadItemInfo(ciFirstUsage);
					m_api->m_data.GetAttr(ciFirstUsage, m_api->m_prd_mgr.a_pdf_prd, cit);
					m_api->m_data.GetAttr(cit, m_api->m_prd_mgr.a_prd_id, sFirstUsage);
					m_api->m_data.GetAttr(cit, m_api->m_prd_mgr.a_prd_name, buf);
					sFirstUsage += ":" + buf;
					m_api->m_data.GetAttr(ciFirstUsage, m_api->m_prd_mgr.a_pdf_id, buf);
					sFirstUsage += " - " + buf;
				}
				
				//
				if(std_pdf) stand = "yes";
				else stand = "no";
				
				if(id.Find(name)>=0) id.Replace(name,""); //      
				
				if(r_count==0) count=""; else count.Format("%g",r_count);
				
				if(type=="material" && !IsSubstitute)
				{
					apidata.GetAttrBN(rels[j], "unit_component", inst);
					if(inst!=0)apidata.GetAttrBN(inst, "id", descr);
				}

				// 
				aplExtent characts, gr;
				m_api->m_charact_mgr.FindAssociatedCharacteristic(i_pdf, characts, gr);
				CaplInstance* char_val= NULL;
				for(int y= 0; y<characts.GetSize(); y++)
				{
					CaplInstance* tempInst= NULL;
					m_api->m_data.GetAttr(characts[y], m_api->m_charact_mgr.a_apl_charact_val_charact, tempInst);
					if(tempInst!=m_charact)
					{
						characts.Remove(y); y--; continue;
					}
					
					tempInst= NULL;
					m_api->m_data.GetAttr(characts[y], m_api->m_charact_mgr.a_apl_charact_val_item, tempInst);
					if(tempInst!=i_pdf && tempInst!=i_prd) continue;
					
					tempInst= NULL;
					m_api->m_data.GetAttr(characts[y], m_api->m_charact_mgr.a_apl_charact_val_type, tempInst);
					
					//      
					if(!tempInst)
					{
						char_val= characts[y];
						break;
					}
					
					if(!char_val)
					{
						char_val= characts[y];				
					}
				}
				
				if(char_val)
				{
					m_api->m_charact_mgr.PrintCharacteristicValue(char_val, NULL, mass);
				}
				
				if(type=="part" || type=="material")
				{
					aplExtent all_mater, all_mater_rel;
					m_api->m_prd_mgr.LoadAllZagotov(i_pdf, all_mater_rel, all_mater);
					
					CaplInstance* materPdf= NULL;
					int iRank=9999;
					
					for(int j= 0; j<all_mater.GetSize(); j++)
					{
						if(!m_api->m_data.IsKindOf(all_mater_rel[j], m_api->m_prd_mgr.e_make_from))
							continue;
						
						int iCurRank;
						
						m_api->m_data.GetAttr(all_mater_rel[j], m_api->m_prd_mgr.a_make_from_ranking, iCurRank);
						//  
						if(iCurRank<iRank)
						{
							materPdf= all_mater[j];
							iRank= iCurRank;
						}
					}
					if(materPdf)
					{
						CaplInstance* materPrd= NULL;
						m_api->m_data.GetAttr(materPdf, m_api->m_prd_mgr.a_pdf_prd, materPrd);
						if(materPrd)
						{
							m_api->m_data.GetAttr(materPrd, m_api->m_prd_mgr.a_prd_id, mater);				
							m_api->m_data.GetAttr(materPrd, m_api->m_prd_mgr.a_prd_name, buf);
							if(!mater.IsEmpty()) mater+=" "; mater+=buf;
						}
					}
				}
				
				//e_type = GetType(type, stand, source);
				e_type = "pdf";

				//     (  )
				format.Empty();
				if((type=="part"|| type=="assembly") && source!="bought")
					format = GetFormatFromDoc(DocMap, i_pdf);
				
				row = new CTableRow;
				row->AddColumn("");			//       ,
				row->AddColumn("");			//      MPSpecification.dll
				row->AddColumn("");//format
				row->AddColumn("");//zone
				row->AddColumn(pos);//pos
				row->AddColumn(s_pos);//ref_des
				row->AddColumn(id);//id
				row->AddColumn("");			//       ,
				row->AddColumn(0);			//      MPSpecification.dll
				row->AddColumn(name);//name
				row->AddColumn("");//count
				row->AddColumn(descr);//descr
				row->AddColumn(mass);//mass
				for(i=0;i<6;i++)
				{
					row->AddColumn(csa[i]);
				}
				//		row->AddColumn(mater);//mater
				row->AddColumn(e_type);//e_type
				row->AddColumn(sFirstUsage);
				//row->AddColumn(sModify);
				//row->AddColumn(sFullName);

				row->AddColumn(type);//type
				row->AddColumn(stand);//stand
			
				row->AddColumn(source);//source
				row->AddColumn(pdf_id);//source
				
				row->AddColumn(i_pdf);//
				row->AddColumn(1);
				m_data_source->AddRow(row);
			}

		}

	}

	map.Clear();
	delete aepAssoc;
}

void CExportKTSDlg::OnOK() 
{
	UpdateData();

	if(!m_charact && IDNO==MessageBox(" \"\"  .\n  ?", 
		" ", MB_YESNO|MB_ICONWARNING))
	{
		return;
	}

	int i,error = false;
	CString t_buf;
	
	//       

	//  

	i = m_sOutFilename.ReverseFind('\\');
	if(i!=-1)
	{
		t_buf = m_sOutFilename.Left(i);
		if(CreatePath(t_buf)==false)
		{
			error = true;
		}
	}
	else
	{
		error = true;
	}
		
	if(error==TRUE)
	{
		AfxMessageBox("    !!");
		return;
	}

	//     
	CString sModify;
	aplExtent PdfExt;
	CWinApp * app = AfxGetApp();

	CString m_filter_doc_by_Descr="";
	m_sub_str_ctrl.GetWindowText(m_filter_doc_by_Descr);
	
	if(app!=NULL)
	{
		app->WriteProfileString("ExportKTS_plugin","OutReportPath",t_buf);
		app->WriteProfileInt("ExportKTS_plugin","AddSubstitutes", m_add_substitutes);
		app->WriteProfileString("ExportKTS_plugin","DocDescriptionFiler",m_filter_doc_by_Descr);
		app->WriteProfileInt("ExportKTS_plugin","UseDocDescriptionFiler",m_add_if_has_SubString);
		app->WriteProfileInt("ExportKTS_plugin","AddZagotov", m_AddZagotov);
		app->WriteProfileInt("ExportKTS_plugin","Mater-Norm", m_bUseMFUO);
	}	

	m_api->m_data.m_IsWaitDlg = false;
	long DlgId = aplStartWaitDlg(" ...", " ");
	
	//     .
	CaplReportMgr m_dict;
	m_dict.Init();
	CDataSource *m_data_source = &m_dict.m_data_source;

	//
	CHeader* header = new CHeader(NULL);

	header->AddColumn("peremennoe",		aplSTRING);
	header->AddColumn("ispolnenine",	aplSTRING);
	header->AddColumn("format", aplSTRING);
	header->AddColumn("zone", aplSTRING);
	header->AddColumn("pos", aplSTRING);
	header->AddColumn("ref_des", aplSTRING);
	header->AddColumn("id", aplSTRING);
	header->AddColumn("dt_code",		aplSTRING);
	header->AddColumn("sort_num",		aplINTEGER);
	header->AddColumn("name", aplSTRING);
	header->AddColumn("prd_descr", aplSTRING);
	header->AddColumn("count", aplSTRING);
	header->AddColumn("descr", aplSTRING);
	header->AddColumn("mass", aplSTRING);

	header->AddColumn("prd_id", aplSTRING);
	header->AddColumn("prd_name", aplSTRING);
	header->AddColumn("pdf_id", aplSTRING);
	header->AddColumn("shape", aplSTRING);
	header->AddColumn("rel_id", aplSTRING);
	header->AddColumn("rel_name", aplSTRING);

	header->AddColumn("e_type", aplSTRING);
	header->AddColumn("zaimstv", aplSTRING);	 
	//header->AddColumn("modify", aplSTRING);
	//header->AddColumn("full_pdf_name", aplSTRING);

	header->AddColumn("type", aplSTRING);
	header->AddColumn("stand", aplSTRING);
	header->AddColumn("source", aplSTRING);
	header->AddColumn("ver",aplSTRING);

	header->AddColumn("pdf",			aplINSTANCE);
	header->AddColumn("inner_count",	aplINTEGER);
	header->AddColumn("InstId",			aplINTEGER);
	header->AddColumn("GrpName",		aplSTRING);
	header->AddColumn("SpravID",		aplSTRING);
		
	m_data_source->SetHeader(header);

	//  
	/*if(m_bGrpSpec)
		m_api->m_prd_mgr.GetAllProductVersion(m_prd, PdfExt);
	else
		PdfExt.Add(m_pdf);

	for(i=0; i<PdfExt.GetSize(); i++)
	{
		m_api->m_data.GetAttr(PdfExt[i], m_api->m_prd_mgr.a_pdf_id, sModify);		
	}*/

	//  ,     
	FillPdfSpec(m_pdf, m_data_source, "");

	// 
	//int rows, cols;
	double dCount = 0;
	double CountSumm = 0;
	//TSortParam SortParam;
	ISortArray iArr;

	// (   MPSpecification )
	SortData(header, &m_dict, "");		

	/*
	//
	SortParam.col_num = header->Find("name");
	SortParam.bSortAsString = false;
	iArr.Add(SortParam);
	SortParam.col_num = header->Find("ver");
	SortParam.bSortAsString = false;
	iArr.Add(SortParam);
	SortParam.col_num = header->Find("id");
	SortParam.bSortAsString = false;
	iArr.Add(SortParam);

	SortParam.col_num = header->Find("ref_des");
	SortParam.bSortAsString = false;
	iArr.Add(SortParam);

	m_dict.m_data_source.Sort(&iArr);
	m_dict.m_data_source.GetSize(rows, cols);

	*/

	/*if(rows>0)
	{
		CaplReportValue *Val, *tVal;
		CString sVal1, sVal2, cPart, sValTmp, sValTmp2, sEtalonVal;
		int iIdInd, iPosInd, iCountInd, iPrdInd, iVerInd;
		int sInd, eInd;
		TR_Array Data, tdel;
		CTableRow *tRow;

		sInd = eInd = 0;

		iPrdInd = header->Find("prd");
		iVerInd = header->Find("ver");
		iIdInd = header->Find("id");
		iPosInd = header->Find("ref_des");		
		iCountInd = header->Find("count");

		Val = m_dict.m_data_source.GetAt(0, iIdInd);
		Val->Get(sEtalonVal);
		m_dict.m_data_source.GetAt(0, iVerInd)->Get(sValTmp2);
		sEtalonVal+=sValTmp2;
		tVal = m_dict.m_data_source.GetAt(0, iPosInd);
		tVal->Get(sVal1);
		CDataSource::GetStringPart(sVal1, cPart);
		bool ok = true;
		for(i=0; i<rows;i++)
		{
			tRow = m_dict.m_data_source.GetRow(i);
			tVal = tRow->GetColumn(iIdInd);
			tRow->GetColumn(iVerInd)->Get(sValTmp2);
			tVal->Get(sValTmp);
			sValTmp+=sValTmp2;
			if(sValTmp.IsEmpty()) continue;
			if(sEtalonVal.Compare(sValTmp)!=0)
			{
				CTableRow *cRow, *nRow;
				int Count = 1;
				CaplValue *val1, *val2;
				CString sv1, sv2, buf;
				CString sp1, sp2;
				int ip1, ip2;
				for(int j=0; j<Data.GetSize()-1; j++)
				{
					cRow = Data[j];
					nRow = Data[j+1];
					val1 = cRow->GetColumn(iPosInd);
					val2 = nRow->GetColumn(iPosInd);
					val1->Get(sv1);
					val2->Get(sv2);
					CDataSource::GetStringPart(sv1, sp1);
					CDataSource::GetStringPart(sv2, sp2);
					Data[j]->GetColumn(iCountInd)->Get(dCount);
					CountSumm += dCount;
					if(sp1!=sp2)
					{
						if(Count==1)
							continue;
						if(Count==2)
							buf = sv1+", "+sv2;
						else if(Count>2)
							buf = sv1+"..."+sv2;
						val1->Set(buf);
						Data[j-Count+1]->GetColumn(iCountInd)->Set(CountSumm);
						for(int z=0; z<Count-1; z++)
							tdel.Add(Data[j-z]);
						Count = 1;
						CountSumm = 0;
					}
					buf = sv1; buf.TrimLeft(sp1);
					ip1 = atoi(buf);
					buf = sv2; buf.TrimLeft(sp2);
					ip2 = atoi(buf);
					if(ip1==ip2-1)
						Count++;
					else
					{
						if(Count==1)
						{
							Data[j]->GetColumn(iCountInd)->Get(dCount);
							CountSumm += dCount;
						}
						else if(Count==2)
						{
							val1 = Data[j-Count+1]->GetColumn(iPosInd);
							val1->Get(sv2);
							buf = sv2+", "+sv1;
							val1->Set(buf);
						}
						else if(Count>2)
						{
							val1 = Data[j-Count+1]->GetColumn(iPosInd);
							val1->Get(sv2);
							buf = sv2+"..."+sv1;
							val1->Set(buf);
						}
						Data[j-Count+1]->GetColumn(iCountInd)->Set(CountSumm);
						for(int z=0; z<Count-1; z++)
							tdel.Add(Data[j-z]);
						Count = 1;
						CountSumm = 0;
					}
				}
				Data[j]->GetColumn(iCountInd)->Get(dCount);
				CountSumm += dCount;
				if(Count==2)
				{
					buf = sv1+", "+sv2;
					val1->Set(buf);
				}
				else if(Count>2)
				{
					val2 = Data[j-Count+1]->GetColumn(iPosInd);
					val2->Get(sv1);
					buf = sv1+"..."+sv2;
					val2->Set(buf);
				}
				Data[j-Count+1]->GetColumn(iCountInd)->Set(CountSumm);
				for(int z=0; z<Count-1; z++)
					tdel.Add(Data[j-z]);
				Count = 1;
				Data.RemoveAll();
				Val = tVal;
				sEtalonVal = sValTmp;
				CountSumm = 0;
				dCount = 0;
			}
			Data.Add(tRow);
			eInd = i;
		}

		{
			CTableRow *cRow, *nRow;
			int Count = 1;
			CaplValue *val1, *val2;
			CString sv1, sv2, buf;
			CString sp1, sp2;
			int ip1, ip2;
			for(int j=0; j<Data.GetSize()-1; j++)
			{
				cRow = Data[j];
				nRow = Data[j+1];
				Data[j]->GetColumn(iCountInd)->Get(dCount);
				CountSumm += dCount;
				val1 = cRow->GetColumn(iPosInd);
				val2 = nRow->GetColumn(iPosInd);
				val1->Get(sv1);
				val2->Get(sv2);
				
				CDataSource::GetStringPart(sv1, sp1);
				CDataSource::GetStringPart(sv2, sp2);
				if(sp1!=sp2)
				{
					if(Count==1)
						continue;
					if(Count==2)
						buf = sv1+", "+sv2;
					else if(Count>2)
						buf = sv1+"..."+sv2;
					val1->Set(buf);
					Data[j-Count+1]->GetColumn(iCountInd)->Set(CountSumm);
					for(int z=0; z<Count-1; z++)
						tdel.Add(Data[j-z]);
					Count = 1;
					CountSumm = 0;
				}

				buf = sv1; buf.TrimLeft(sp1);
				ip1 = atoi(buf);
				buf = sv2; buf.TrimLeft(sp2);
				ip2 = atoi(buf);
				if(ip1==ip2-1)
					Count++;
				else
				{
					if(Count==1)
					{
						Data[j-Count+1]->GetColumn(iCountInd)->Get(dCount);
						CountSumm += dCount;
					}
					if(Count==2)
					{
						val1 = Data[j-Count+1]->GetColumn(iPosInd);
						val1->Get(sv2);
						buf = sv2+", "+sv1;
					}
					else if(Count>2)
					{
						val1 = Data[j-Count+1]->GetColumn(iPosInd);
						val1->Get(sv2);
						buf = sv2+"..."+sv1;
					}
					val1->Set(buf);
					Data[j-Count+1]->GetColumn(iCountInd)->Set(CountSumm);
					for(int z=0; z<Count-1; z++)
						tdel.Add(Data[j-z]);
					Count = 1;
					CountSumm = 0;
					dCount;
				}
			}
			Data[j]->GetColumn(iCountInd)->Get(dCount);
			CountSumm += dCount;
			if(Count==2)
				buf = sv1+", "+sv2;
			else if(Count>2)
			{
				val1 = Data[j-Count+1]->GetColumn(iPosInd);
				val1->Get(sv1);
				buf = sv1+"..."+sv2;
			}
			if(Count>1)
				val1->Set(buf);
			Data[j-Count+1]->GetColumn(iCountInd)->Set(CountSumm);
			for(int z=0; z<Count-1; z++)
				tdel.Add(Data[j-z]);
			Data.RemoveAll();
		}
		// "" 
		for(i=0; i<tdel.GetSize();i++)
			m_dict.m_data_source.DeleteRow(m_dict.m_data_source.FindRow(tdel[i]));
	}*/
	//m_sExePath -   ReportConstructor.exe
	//m_sDotPath -   
	//m_sDataPath -    
	// preview,  print
	//m_sParamPath==spec_params.txt -    ( -  path)	
	CString tmp, out_file,out_file_path;
	CString t_str, exe_full_path, buf;
	int index;

	if(!m_sExePath.IsEmpty())
	{
		index = m_templ_combo.GetCurSel();
		if(index!= CB_ERR)
		{
			m_templ_combo.GetLBText(index, t_str);
			m_sDotPath = m_sExePath + "\\" + t_str;
			//   
			CWinApp * app = AfxGetApp();
			if(app!=NULL)
			{
				app->WriteProfileString("ExportKTS_plugin","LastSelectedSpecTemplate", t_str);
			}
			t_str.Empty();
		}
	}
	exe_full_path = m_sExePath + "\\ReportConstructor.exe";
	
	m_dict.m_data_source.m_RParams.Add("prd_id",m_sId);
	m_dict.m_data_source.m_RParams.Add("prd_name",m_sName);
	/*m_api->m_appr_mgr.GetAllSubOrganization(NULL,ext);
	if(ext.Size>0)
	{
		CString str;
		apidata.GetAttr(ext[0],m_api->m_appr_mgr.a_org_id, str);
		m_dict.m_data_source.m_RParams.Add("org_name",str);
	}*/

	m_api->m_data.m_IsWaitDlg = true;

	SaveToFile(&m_dict);

	if(GenerateReport(&m_dict, m_sDotPath, m_sOutFilename, &m_api->m_data)) 
	{
		aplEndWaitDlg(DlgId);
		buf.Format("  !\n    %s.\n    ?", out_file_path);

		if(AfxMessageBox(buf,MB_YESNO)==IDYES)
		{	
			if(m_preview)
			{
				tmp.Format("\"%s\" \"%s\" /preview",
					exe_full_path, m_sOutFilename);
			}
			else
			{
				tmp.Format("\"%s\" \"%s\"",
					exe_full_path, m_sOutFilename);
			}
			
			if(aplCreateProcess(0, LPCSTR(tmp), false)==-1)
			{
				CString buf; 
				buf.Format("   \n%s",LPCSTR(tmp));
				AfxMessageBox(buf);
			}			
		}
	}
	else
	{
		aplEndWaitDlg(DlgId);
	}

	
	CDialog::OnOK();
}

void CExportKTSDlg::SortData(CHeader *pHeader, CaplReportMgr *pReportMgr, CString sModify)
{
	int rows, cols, i;
	double dCount = 0;
	double CountSumm = 0;
	TSortParam SortParam;
	ISortArray iArr;

	//
	SortParam.col_num = pHeader->Find("name");
	SortParam.bSortAsString = false;
	iArr.Add(SortParam);
	SortParam.col_num = pHeader->Find("ver");
	SortParam.bSortAsString = false;
	iArr.Add(SortParam);
	SortParam.col_num = pHeader->Find("id");
	SortParam.bSortAsString = false;
	iArr.Add(SortParam);

	SortParam.col_num = pHeader->Find("ref_des");
	SortParam.bSortAsString = false;
	iArr.Add(SortParam);

	pReportMgr->m_data_source.Sort(&iArr);
	pReportMgr->m_data_source.GetSize(rows, cols);
	if(rows>0)
	{
		CaplReportValue *Val, *tVal;
		CString sVal1, sVal2, cPart, sValTmp, sValTmp2, sEtalonVal;
		int iIdInd, iPosInd, iCountInd, iPrdInd, iVerInd, nStringForFirstEtalon;
		int sInd, eInd;
		TR_Array Data, tdel;
		CTableRow *tRow;

		if(!sModify.IsEmpty() && m_bGrpSpec) nStringForFirstEtalon = 1;
		else nStringForFirstEtalon = 0;

		sInd = eInd = 0;
		iPrdInd = pHeader->Find("prd");
		iVerInd = pHeader->Find("ver");
		iIdInd = pHeader->Find("id");
		iPosInd = pHeader->Find("ref_des");		
		iCountInd = pHeader->Find("count");

		Val = pReportMgr->m_data_source.GetAt(nStringForFirstEtalon, iIdInd);
		Val->Get(sEtalonVal);
		pReportMgr->m_data_source.GetAt(nStringForFirstEtalon, iVerInd)->Get(sValTmp2);
		sEtalonVal+=sValTmp2;
		tVal = pReportMgr->m_data_source.GetAt(nStringForFirstEtalon, iPosInd);
		tVal->Get(sVal1);
		CDataSource::GetStringPart(sVal1, cPart);
		bool ok = true;

		for(i=0; i<rows;i++)
		{
			tRow = pReportMgr->m_data_source.GetRow(i);
			tVal = tRow->GetColumn(iIdInd);
			tRow->GetColumn(iVerInd)->Get(sValTmp2);
			tVal->Get(sValTmp);
			sValTmp+=sValTmp2;
			if(sValTmp.IsEmpty()) continue;
			if(sEtalonVal.Compare(sValTmp)!=0)
			{
				CTableRow *cRow, *nRow;
				int Count = 1;
				CaplValue *val1, *val2;
				CString sv1, sv2, buf;
				CString sp1, sp2;
				int ip1, ip2;
				int j;
				for(j=0; j<Data.GetSize()-1; j++)
				{
					cRow = Data[j];
					nRow = Data[j+1];
					val1 = cRow->GetColumn(iPosInd);
					val2 = nRow->GetColumn(iPosInd);
					val1->Get(sv1);
					val2->Get(sv2);
					CDataSource::GetStringPart(sv1, sp1);
					CDataSource::GetStringPart(sv2, sp2);
					Data[j]->GetColumn(iCountInd)->Get(dCount);
					CountSumm += dCount;
					if(sp1!=sp2)
					{
						if(Count==1)
							continue;
						if(Count==2)
							buf = sv1+", "+sv2;
						else if(Count>2)
							buf = sv1+"..."+sv2;

						val1->Set(buf);

						Data[j-Count+1]->GetColumn(iCountInd)->Set(CountSumm);
						for(int z=0; z<Count-1; z++)
							tdel.Add(Data[j-z]);
						Count = 1;
						CountSumm = 0;
					}
					buf = sv1; buf.TrimLeft(sp1);
					ip1 = atoi(buf);
					buf = sv2; buf.TrimLeft(sp2);
					ip2 = atoi(buf);
					if(ip1==ip2-1)
						Count++;
					else
					{
						if(Count==1)
						{
							Data[j]->GetColumn(iCountInd)->Get(dCount);
							CountSumm += dCount;
						}
						else if(Count==2)
						{
							val1 = Data[j-Count+1]->GetColumn(iPosInd);
							val1->Get(sv2);
							buf = sv2+", "+sv1;
							
							val1->Set(buf);
						}
						else if(Count>2)
						{
							val1 = Data[j-Count+1]->GetColumn(iPosInd);
							val1->Get(sv2);
							buf = sv2+"..."+sv1;

							val1->Set(buf);
						}
						Data[j-Count+1]->GetColumn(iCountInd)->Set(CountSumm);
						for(int z=0; z<Count-1; z++)
							tdel.Add(Data[j-z]);

						Count = 1;
						CountSumm = 0;
					}
				}
				Data[j]->GetColumn(iCountInd)->Get(dCount);
				CountSumm += dCount;
				if(Count==2)
				{
					buf = sv1+", "+sv2;					
					val1->Set(buf);
				}
				else if(Count>2)
				{
					val2 = Data[j-Count+1]->GetColumn(iPosInd);
					val2->Get(sv1);
					buf = sv1+"..."+sv2;
					
					val2->Set(buf);
				}
				Data[j-Count+1]->GetColumn(iCountInd)->Set(CountSumm);
				for(int z=0; z<Count-1; z++)
					tdel.Add(Data[j-z]);
				Count = 1;
				Data.RemoveAll();
				Val = tVal;
				sEtalonVal = sValTmp;
				CountSumm = 0;
				dCount = 0;
			}
			Data.Add(tRow);
			eInd = i;
		}

		{
			CTableRow *cRow, *nRow;
			int Count = 1;
			CaplValue *val1, *val2;
			CString sv1, sv2, buf;
			CString sp1, sp2;
			int ip1, ip2, j;
			for(j=0; j<Data.GetSize()-1; j++)
			{
				cRow = Data[j];
				nRow = Data[j+1];
				Data[j]->GetColumn(iCountInd)->Get(dCount);
				CountSumm += dCount;
				val1 = cRow->GetColumn(iPosInd);
				val2 = nRow->GetColumn(iPosInd);
				val1->Get(sv1);
				val2->Get(sv2);
				
				CDataSource::GetStringPart(sv1, sp1);
				CDataSource::GetStringPart(sv2, sp2);
				if(sp1!=sp2)
				{
					if(Count==1)
						continue;
					if(Count==2)
						buf = sv1+", "+sv2;
					else if(Count>2)
						buf = sv1+"..."+sv2;

					val1->Set(buf);

					Data[j-Count+1]->GetColumn(iCountInd)->Set(CountSumm);
					for(int z=0; z<Count-1; z++)
						tdel.Add(Data[j-z]);
					Count = 1;
					CountSumm = 0;
				}

				buf = sv1; buf.TrimLeft(sp1);
				ip1 = atoi(buf);
				buf = sv2; buf.TrimLeft(sp2);
				ip2 = atoi(buf);
				if(ip1==ip2-1)
					Count++;
				else
				{
					if(Count==1)
					{
						Data[j-Count+1]->GetColumn(iCountInd)->Get(dCount);
						CountSumm += dCount;
					}
					if(Count==2)
					{
						val1 = Data[j-Count+1]->GetColumn(iPosInd);
						val1->Get(sv2);
						buf = sv2+", "+sv1;
					}
					else if(Count>2)
					{
						val1 = Data[j-Count+1]->GetColumn(iPosInd);
						val1->Get(sv2);
						buf = sv2+"..."+sv1;
					}
					
					val1->Set(buf);

					Data[j-Count+1]->GetColumn(iCountInd)->Set(CountSumm);
					for(int z=0; z<Count-1; z++)
						tdel.Add(Data[j-z]);
					Count = 1;
					CountSumm = 0;
					dCount;
				}
			}
			Data[j]->GetColumn(iCountInd)->Get(dCount);
			CountSumm += dCount;
			if(Count==2)
				buf = sv1+", "+sv2;
			else if(Count>2)
			{
				val1 = Data[j-Count+1]->GetColumn(iPosInd);
				val1->Get(sv1);
				buf = sv1+"..."+sv2;
			}
			if(Count>1) val1->Set(buf);			

			Data[j-Count+1]->GetColumn(iCountInd)->Set(CountSumm);
			for(int z=0; z<Count-1; z++)
				tdel.Add(Data[j-z]);
			Data.RemoveAll();
		}

		// "" 
		for(i=0; i<tdel.GetSize();i++)
			pReportMgr->m_data_source.DeleteRow(pReportMgr->m_data_source.FindRow(tdel[i]));
	}
}

void CExportKTSDlg::GetMaterials(CaplInstance* ciPdf,CStringArray& caOutVals)
{
	aplExtent		aeRels,aePdfs;

	CaplInstance*	ciRel			=NULL;
	CaplInstance*	cit1			=NULL;
	CaplInstance*	cit2			=NULL;
	CaplInstance*	cit3			=NULL;

	CString			cst1,cst2;

	bool			bUseDesign		=false;

	int				i;

	for(i=0;i<6;i++)
		caOutVals.Add("");

	if(FALSE==m_bUseMFUO)
		bUseDesign=true;

	m_api->m_prd_mgr.LoadAllZagotov(ciPdf,aeRels,aePdfs,bUseDesign,true);

	if(0==aeRels.GetSize())
		return;

	//	
	i=0;
	TRACE("removing.\nbefore %d\n",aeRels.GetSize());
	while(i<aeRels.GetSize())
	{
		cit1=aeRels.GetAt(i);
		if(FALSE==m_bUseMFUO)
		{
			if(apidata.IsKindOf(cit1,m_api->m_prd_mgr.e_make_from))
				aeRels.Remove(i);
			else
				i++;
		}
		else
		{
			if(apidata.IsKindOf(cit1,m_api->m_prd_mgr.e_design_make_from))
				aeRels.Remove(i);
			else
				i++;
		}
	}
	TRACE("after %d\n",aeRels.GetSize());

	if(0==aeRels.GetSize())
		return;

	//	 MFUO   
	if(TRUE==m_bUseMFUO)
	{
		int ind=0,priority=INT_MAX,it=0;
		for(i=0;i<aeRels.GetSize();i++)
		{
			cit1=aeRels.GetAt(i);
			apidata.GetAttr(cit1,m_api->m_prd_mgr.a_make_from_ranking,it);
			if(it<priority)
			{
				priority=it;
				ind=i;
			}
		}
		cit1=aeRels.GetAt(ind);
	}
	else
		cit1=aeRels.GetAt(0);

	cit2=cit3=NULL;
	apidata.GetAttr(cit1,m_api->m_prd_mgr.a_pdr_r_ted,	cit2);
	apidata.GetAttr(cit2,m_api->m_prd_mgr.a_pdf_prd,	cit3);

	apidata.GetAttr(cit3,m_api->m_prd_mgr.a_prd_id,		caOutVals[0]);
	apidata.GetAttr(cit3,m_api->m_prd_mgr.a_prd_name,	caOutVals[1]);
	apidata.GetAttr(cit2,m_api->m_prd_mgr.a_pdf_id,		caOutVals[2]);

	apidata.GetAttr(cit1,m_api->m_prd_mgr.a_pdr_id,caOutVals[4]);
	apidata.GetAttr(cit1,m_api->m_prd_mgr.a_pdr_name,caOutVals[5]);

	if(FALSE==m_bUseMFUO)
		return;

	cit2=cit3=NULL;
	cst1=cst2="";
	apidata.GetAttr(cit1,m_api->m_prd_mgr.a_make_from_assortment,cit2);
	if(NULL!=cit2)
	{
		apidata.GetAttr(cit2,m_api->m_prd_mgr.a_assortment_name,	cst1);
		apidata.GetAttr(cit2,m_api->m_prd_mgr.a_assortment_shape,	cit3);
		if(NULL!=cit3)
			apidata.GetAttr(cit3,m_api->m_prd_mgr.a_assortment_shape_name,cst2);
		caOutVals[3]=cst2;
		caOutVals[3]+=" ";
		caOutVals[3]+=cst1;
	}
}

/**************************************************************/
void CExportKTSDlg::FreeItems(CArray <CSpecificationItem*, CSpecificationItem*> &items)
{
	for(int i=0;i<items.GetSize();i++) delete items[i];
	items.RemoveAll();
}

void CExportKTSDlg::PrintParamToFile()
{
	CStdioFile f_std;
	CString buf;
	if(f_std.Open(m_sDataPath+"\\"+m_sParamPath, CFile::modeCreate|CFile::modeWrite|CFile::typeText))
	{
		/**/
		buf.Format("prd_id=%s\n",m_sId);f_std.WriteString(buf);
		buf.Format("prd_name=%s\n",m_sName);f_std.WriteString(buf);
		aplExtent ext;
		m_api->m_appr_mgr.GetAllSubOrganization(NULL,ext);
		if(ext.Size>0)
		{
			CString str;
			apidata.GetAttr(ext[0],m_api->m_appr_mgr.a_org_id, str);
			buf.Format("org=%s\n",str);f_std.WriteString(buf);
		}
/*		buf.Format("prd_id,%s\n", m_sId);f_std.WriteString(buf);
		buf.Format("prd_name,%s\n", m_sName);f_std.WriteString(buf);

		/*   */
/*		buf.Format("prd_code,\n"); f_std.WriteString(buf);
		buf.Format("approval_1,\n"); f_std.WriteString(buf);
		buf.Format("approval_1_date,\n"); f_std.WriteString(buf);
		buf.Format("approval_2,\n"); f_std.WriteString(buf);
		buf.Format("approval_2_date,\n"); f_std.WriteString(buf);
		buf.Format("approval_3,\n"); f_std.WriteString(buf);
		buf.Format("approval_3_date,\n"); f_std.WriteString(buf);
		buf.Format("approval_4,\n"); f_std.WriteString(buf);
		buf.Format("approval_4_date,\n"); f_std.WriteString(buf);
		buf.Format("approval_5,\n"); f_std.WriteString(buf);
		buf.Format("approval_5_date,\n"); f_std.WriteString(buf);
		buf.Format("approval_6,\n"); f_std.WriteString(buf);
		buf.Format("approval_6_date,\n"); f_std.WriteString(buf);
		buf.Format("approval_7,\n"); f_std.WriteString(buf);
		buf.Format("approval_7_date,\n"); f_std.WriteString(buf);
		buf.Format("approval_8,\n"); f_std.WriteString(buf);
		buf.Format("approval_8_date,\n"); f_std.WriteString(buf);
		buf.Format("approval_9,\n"); f_std.WriteString(buf);
		buf.Format("approval_9_date,\n"); f_std.WriteString(buf);*/

		f_std.Flush();f_std.Close();
	}
}

int CExportKTSDlg::IsDirectoryExist(CString path_to_dir)
{
/*
	HANDLE	dir = CreateFile(path_to_dir,GENERIC_READ,NULL, 
		NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL|FILE_FLAG_BACKUP_SEMANTICS,NULL);

	if(dir==INVALID_HANDLE_VALUE)
	{
		LPVOID lpMsgBuf;
		FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM | 
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		GetLastError(),
		MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL );

		::MessageBox( NULL, (LPCTSTR)lpMsgBuf, "Error", MB_OK | MB_ICONINFORMATION );
		// Free the buffer.
		LocalFree( lpMsgBuf );

		return false;
	}

	CloseHandle(dir); //   NT 

	return true;
*/	
	CFileFind find;

	CString cst=path_to_dir+"\\*.*";

	if(find.FindFile(path_to_dir)!=NULL)
	{
		find.FindNextFile();
		if(find.IsDirectory())
			return true;
		return false;
	}

	return false;
}

bool CExportKTSDlg::CreatePath(const char* PathToCreate)
{
  char Path[_MAX_PATH];

  // Copy path because we have to modify it
  strcpy(Path,PathToCreate);

  // First add an ending slash
  char* Pos = strrchr(Path,'\\');

  if (!Pos || Pos[1]!=0)
    strcat(Path,"\\");

  // From the first slash to the last check and create path
  // Exception : Jump initial duble slashed UNC host name and include first directory

  if (Path[0]=='\\' && Path[1]=='\\')
  {
    // Find slash ending the host name
    Pos = strchr(Path+2,'\\');
    // Find slash after the first directory (after the host name)
    if (Pos)
      Pos = strchr(Pos+1,'\\');
  }
  else
    Pos = strchr(Path,'\\');

  bool AllOk = true;

  while (Pos && AllOk)
  {
    // Cut the string
    *Pos = 0;
    // Check if exist this piece of path
    if (GetFileAttributes(Path)==-1)
      if (GetLastError()==ERROR_FILE_NOT_FOUND)
        AllOk = CreateDirectory(Path,NULL)==TRUE;
      else
        AllOk = false;

    // Recover the character deleted
    *Pos = '\\';
    // Find next slash
    Pos = strchr(Pos+1,'\\');
  }

  // Return true if finally the path was created or exist
  // (if not was created see LastError)
  return AllOk;
}

void CExportKTSDlg::OnSelReportFile() 
{
	CFileDialog dlg(FALSE , "aplrep",m_sOutFilename, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
		"ReportFiles (*.aplrep)|*.aplrep|All Files (*.*)|*.*||");

	if(dlg.DoModal()==IDOK)
	{
		//- 
		m_sOutFilename = dlg.GetPathName();
		SetDlgItemText(IDC_OUT_FILE,m_sOutFilename);
	}
		
}

void CExportKTSDlg::OnAddOnlyHasSubstring() 
{
	UpdateData();
	m_sub_str_ctrl.EnableWindow(m_add_if_has_SubString);

}

bool CExportKTSDlg::GetSubstituteName(CaplInstance* rel, CaplInstance* substitute, CString &name, aplExtent *substitutes)
{
	if(substitute==0 && rel==0) return false;
	if(rel!=0)
	{
		if(rel->GetType()==0) return false;
		if(!m_api->m_data.IsKindOf(rel, m_api->m_prd_mgr.e_pdr)) return false;
		double count=1;
		CString buf, buf1="";
		if(m_api->m_data.IsKindOf(rel, m_api->m_prd_mgr.e_apl_qacu))
		{
			CaplInstance* inst1=NULL;
			m_api->m_data.GetAttr(rel, m_api->m_prd_mgr.a_apl_qacu_value,count);
			m_api->m_data.GetAttr(rel, m_api->m_prd_mgr.a_apl_qacu_unit,inst1);
			if(inst1)
				m_api->m_charact_mgr.GetUnitName(inst1,buf1);
			buf.Format("%g %s",count,buf1);
		}
		aplExtent rels, pdfs;
		m_api->m_prd_mgr.LoadAllSubstitutes(rel, rels, pdfs);
		if(substitutes!=0)
		{
			substitutes->Clear();
			substitutes->Append(rels);
		}
		if(rels.Size>0)
		{
			name=buf+" . ";
			//  
			int subst_count=0;
			CStringArray subst_group;
			for(int z=0;z<rels.GetSize();z++)
			{
				if(!rels[z]) continue;
				CString subst_name;
				m_api->m_data.GetAttr(rels[z],m_api->m_prd_mgr.a_pdf_subst_name,subst_name);
				int y;
				bool found=false;
				for(y=0;y<subst_group.GetSize();y++)
				{
					if(subst_group[y]==subst_name) 
					{
						found=true;
						break;
					}
				}
				if(found) continue;
				subst_group.Add(subst_name);
				m_api->m_data.GetAttr(rels[z],m_api->m_prd_mgr.a_pdf_subst_id,buf);
				if(buf=="") buf="' '";
				subst_count++;
				if(subst_count==1)
				{
					name+=" ."+buf;
				}
				else
				{
					name+="   ."+buf;
				}
				int together_subst_count=0;
				for(y=0;y<rels.GetSize();y++)
				{
					if(rels[y]==rels[z]) continue;
					m_api->m_data.GetAttr(rels[y],m_api->m_prd_mgr.a_pdf_subst_name,buf);
					if(buf==subst_name)
					{
						m_api->m_data.GetAttr(rels[y],m_api->m_prd_mgr.a_pdf_subst_id,buf);
						if(together_subst_count==0)
						{
							name+="   ."+buf;
						}
						else
						{
							name+=",."+buf;
						}
						together_subst_count++;
					}
					
				}
			}
			return true;
		}
		return false;
	}
	else
	{
		if(substitute->GetType()==0) return false;
		if(!m_api->m_data.IsKindOf(substitute, m_api->m_prd_mgr.e_pdf_subst)) return false;
		CaplInstance* pdr = NULL, *inst;
		double count=1;
		CString buf, buf1="", subst_name;
		m_api->m_data.GetAttr(substitute, m_api->m_prd_mgr.a_pdf_subst_pdr, pdr);
		m_api->m_data.GetAttr(substitute, m_api->m_prd_mgr.a_pdf_subst_value, count);
		m_api->m_data.GetAttr(substitute, m_api->m_prd_mgr.a_pdf_subst_unit,inst);
		m_api->m_data.GetAttr(substitute, m_api->m_prd_mgr.a_pdf_subst_name,subst_name);
		if(inst)
			m_api->m_charact_mgr.GetUnitName(inst, buf1);
		buf.Format("%g %s",count,buf1);
		aplExtent rels, pdfs;
		m_api->m_prd_mgr.LoadAllSubstitutes(pdr, rels, pdfs);
		name = buf+" .";
		int more_subst_count=0;
		for(int z=0;z<rels.GetSize();z++)
		{
			if(!rels[z]) continue;
			if(rels[z]==substitute) continue;			
			m_api->m_data.GetAttr(rels[z],m_api->m_prd_mgr.a_pdf_subst_name,buf);
			if(buf==subst_name)
			{
				m_api->m_data.GetAttr(rels[z],m_api->m_prd_mgr.a_pdf_subst_id,buf);
				if(buf=="") buf="' '";
				more_subst_count++;
				if(more_subst_count==1)
				{
					name+="  ."+buf;
				}
				else
				{
					name+=","+buf;
				}
			}
			
		}
		m_api->m_data.GetAttr(pdr, m_api->m_prd_mgr.a_pdr_id, buf);
		name+="  ."+buf;
	}
	return false;
}
