#if !defined(AFX_EXPORTKTSDLG_H__022C890D_100B_40C6_BBD0_29E77062B9CD__INCLUDED_)
#define AFX_EXPORTKTSDLG_H__022C890D_100B_40C6_BBD0_29E77062B9CD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// ExportKTSDlg.h : header file
//

#include "resource.h"
#include <reportdict.h>

class CaplAPI;
class CaplInstance;
class CDataSource;

class Template_item
{	
public:
	Template_item(CString name, CString file) : m_name(name), m_filename(file) {};
	CString m_name;
	CString m_filename;
};

/////////////////////////////////////////////////////////////////////////////
// CExportKTSDlg dialog

class CExportKTSDlg : public CDialog
{
// PSM
	struct CSpecificationItem
	{
		CString Format, Zone, Pos, Identification, 
			stand, type, e_type, source,
			Name, Count, Comments, pos1, Mater, Mass;
	};

public:
	void FreeItems(CArray <CSpecificationItem*, CSpecificationItem*> &items);
	void PrintParamToFile();

	void GetMaterials(CaplInstance* ciPdf,CStringArray& caOutVals);
	bool GetSubstituteName(CaplInstance* rel, CaplInstance* substitute, CString &name, aplExtent *substitutes=NULL);

	CaplInstance* GetSecondLevel(CaplInstance *pAssoc);

	CString GetType(CString type, CString stand, CString source);
	CString GetFormatFromDoc(CaplMap &map, CaplInstance *ciPdf);
	
	void FillMapWithDocs(CaplMap &map, aplExtent &aePdf);
	void FillPdfSpec(CaplInstance *ciPdf, CDataSource *m_data_source, CString sModify);
	void SortData(CHeader *pHeader, CaplReportMgr *pReportMgr, CString sModify);

// Construction
public:

	bool CreatePath(const char* PathToCreate);
	int IsDirectoryExist(CString path_to_dir);
	CExportKTSDlg(CWnd* pParent = NULL);   // standard constructor

// Dialog Data
	//{{AFX_DATA(CExportKTSDlg)
	enum { IDD = IDD_EXPORT_KTS_DIALOG };
	CEdit	m_sub_str_ctrl;
	CComboBox	m_templ_combo;
	CaplButton	m_cancel_btn;
	CaplButton	m_ok_btn;
	CString	m_sContext;
	CString	m_sDate;
	CString	m_sDotPath;
	CString	m_sId;
	CString	m_sName;
	CString	m_sVer;
	CString	m_sSN;
	CString	m_sCharId;
	CString	m_sOutFilename;
	BOOL	m_preview;
	BOOL	m_bUseMFUO;
	BOOL	m_add_if_has_SubString;
	BOOL	m_add_substitutes;
	BOOL	m_AddZagotov;
	//}}AFX_DATA

	CString m_sExePath;

	CaplAPI* m_api;
	CaplInstance* m_pdf, *m_context, *m_prd, *m_charact;
	bool m_bGrpSpec;

	COleDateTime m_date;
	CString m_sDictPath;
	CString m_sDataPath;
	CString m_sParamPath;
// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CExportKTSDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CExportKTSDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnDotSelectButton();
	afx_msg void OnExeSelectButton();
	afx_msg void OnSetFilterButton();
	virtual void OnOK();
	afx_msg void OnSelectCharButton();
	afx_msg void OnSelReportFile();
	afx_msg void OnAddOnlyHasSubstring();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_EXPORTKTSDLG_H__022C890D_100B_40C6_BBD0_29E77062B9CD__INCLUDED_)
