// ExportMaterialSpecificationDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ExportMaterialSpecificationDlg.h"
#include "aplExportTechDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExportMaterialSpecificationDlg dialog


CExportMaterialSpecificationDlg::CExportMaterialSpecificationDlg(CaplAPI* api, CWnd* pParent /*=NULL*/)
	: CDialog(CExportMaterialSpecificationDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExportMaterialSpecificationDlg)
	m_sId = _T("");
	m_sName = _T("");
	m_sSN = _T("");
	m_sDate = _T("");
	m_sContext = _T("");
	m_sFileName = _T("");
	//}}AFX_DATA_INIT
	m_api = api;
	ASSERT(api);
	m_inst = NULL;
	m_context = NULL;
}


void CExportMaterialSpecificationDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExportMaterialSpecificationDlg)
	DDX_Control(pDX, IDC_PROGRESS_CTRL, m_Progresbar);
	DDX_Control(pDX, IDC_DOT_COMBO, m_dotCombo);
	DDX_Control(pDX, IDCANCEL, m_cancel_btn);
	DDX_Control(pDX, IDOK, m_ok_btn);
	DDX_Text(pDX, IDC_ID, m_sId);
	DDX_Text(pDX, IDC_NAME, m_sName);
	DDX_Text(pDX, IDC_SN_EDIT, m_sSN);
	DDX_Text(pDX, IDC_DATE_EDIT, m_sDate);
	DDX_Text(pDX, IDC_CONTEXT_EDIT, m_sContext);
	DDX_Text(pDX, IDC_FILENAME, m_sFileName);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CExportMaterialSpecificationDlg, CDialog)
	//{{AFX_MSG_MAP(CExportMaterialSpecificationDlg)
	ON_BN_CLICKED(IDC_SET_FILTER, OnSetFilter)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExportMaterialSpecificationDlg message handlers

BOOL CExportMaterialSpecificationDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	if(m_inst==NULL)
	{
		EndDialog(0);
		return FALSE;
	}

	CaplInstance* prd;
	m_api->m_data.GetAttr(m_inst, m_api->m_prd_mgr.a_pdf_prd, prd);
	if(prd)
	{
		m_api->m_data.GetAttr(prd, m_api->m_prd_mgr.a_prd_id, m_sId);
		m_api->m_data.GetAttr(prd, m_api->m_prd_mgr.a_prd_name, m_sName);
	}
	
	m_sContext= " ";
	m_sSN= " ";

	m_date = COleDateTime::GetCurrentTime();
	m_sDate = m_date.Format("%d.%m.%Y  %H:%M:%S");

	CString desktop_path = "";
	{
		char *path = new char[MAX_PATH];
		SHGetSpecialFolderPath(m_hWnd, path, CSIDL_DESKTOPDIRECTORY, FALSE);
		desktop_path = path;
		delete path;
	}
	CString EditPath=AfxGetApp()->GetProfileString("options","WorkFolder", NULL);
	
	CString str = m_sName+"_"+m_sId+".aplrep";
	if(EditPath.IsEmpty())
		EditPath = desktop_path;
	
	if(!EditPath.IsEmpty())
	{
		if(EditPath.Right(1)!="\\")
			EditPath = EditPath+"\\";
		m_sFileName= EditPath+str;
	}

	CStringArray StrArr;
	bool bIsDefault = false;
	CFile file;
	ReadDots("ExportKTS.dots", "ExportKTS_MS", &StrArr);
	for(int i=0; i<StrArr.GetSize(); i++)
	{
		bIsDefault = false;
		str = StrArr[i];
		if(str.IsEmpty()) continue;
		if(str[0]=='&') 
		{
			bIsDefault = true;
			str = str.Right(str.GetLength()-1);
		}
		if(file.Open(GetExePath()+str, CFile::modeRead | CFile::shareDenyNone ))
		{
			file.Close();
			int cur = m_dotCombo.AddString(str);
			if(bIsDefault)
				m_dotCombo.SetCurSel(cur);
		}
	}
	
	if(m_dotCombo.GetCount()==0)
	{
		AfxMessageBox("         .");
		EndDialog(0);
		return FALSE;
	}
	if(m_dotCombo.GetCurSel()<0)
		m_dotCombo.SetCurSel(0);

	UpdateData(FALSE);
	return FALSE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CExportMaterialSpecificationDlg::OnSetFilter() 
{
	if(!UpdateData()) return;
	
	CaplInstance *new_cont=0;
	if(m_sSN==" ") m_sSN= "";
	if(m_sDate==" ") m_date.SetStatus(COleDateTime::invalid);
	
	if(m_api->m_prd_mgr.SelectDateSN(m_sSN, m_date, m_context, &new_cont))
	{
		if(m_sSN.IsEmpty()) m_sSN= " ";
		
		if(m_date.GetStatus()==COleDateTime::valid)
			m_sDate=m_date.Format("%d.%m.%Y  %H:%M:%S");
		else
			m_sDate= " ";
		
		m_context = new_cont;
		if(m_context)
		{
			aplExtent ext; ext.Add(m_context);
			m_api->m_prd_mgr.PrintItemContextInString(ext, m_sContext);
		}
		else
			m_sContext= " ";
		
		UpdateData(FALSE);
	}
}

void CExportMaterialSpecificationDlg::OnOK() 
{
	UpdateData();
	if(m_sSN==" ")
		m_sSN = "";

	CaplExportTechDoc Export(m_api);
	Export.inInst = m_inst;
	Export.m_DateFilter = m_date;
	Export.m_ContextFilter = m_context;
	Export.m_SNFilter = m_sSN;
	Export.m_progress = &m_Progresbar;

	CString str, exePath = GetExePath(), exeFile;
	exeFile = exePath+"ReportConstructor.exe";
	m_dotCombo.GetWindowText(str);
	if(Export.GenMaterialSpecification(exePath+str, m_sFileName))
	{
		CString buf;
		buf.Format("   !\n    %s.\n    ?", m_sFileName);
		
		if(AfxMessageBox(buf,MB_YESNO|MB_ICONINFORMATION)==IDYES)
		{
			CString tmp;
			tmp.Format("\"%s\" \"%s\"",
				exeFile, m_sFileName);
			
			if(aplCreateProcess(0, LPCSTR(tmp), false)==-1)
			{
				buf.Format("   \n%s",LPCSTR(tmp));
				AfxMessageBox(buf);
			}			
		}
	}
	
	CDialog::OnOK();
}
