// ExportSetupDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "ExportSetupDlg.h"
#include <reportdict.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExportSetupDlg dialog


CExportSetupDlg::CExportSetupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExportSetupDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExportSetupDlg)
	m_path = _T("");
	//}}AFX_DATA_INIT
}


void CExportSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExportSetupDlg)
	DDX_Control(pDX, IDC_DOTS, m_dots_ctrl);
	DDX_Text(pDX, IDC_EDIT_PATH, m_path);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CExportSetupDlg, CDialog)
	//{{AFX_MSG_MAP(CExportSetupDlg)
	ON_BN_CLICKED(IDC_FILE_BROWSE, OnFileBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExportSetupDlg message handlers

BOOL CExportSetupDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	SetWindowText(m_title);
	
	CString dict_path = "";
	{
		char buf[1024]="";
		DWORD len = 1024;
		GetPrivateProfileString("Paths", "Dictionary", "", buf, len,
									   "AplTransport.ini");
		dict_path = buf;
	}

	CStringArray arr;
	CString	str;
	CFile file;
	bool isDefault;
	ReadDots(GetExePath()+"ExportKTS.dots", m_dots_file, &arr);
	for(int i=0; i<arr.GetSize(); i++)
	{
		isDefault = false;
		str = arr[i];
		if(str.IsEmpty()) continue;
		if(str[0]=='&') 
		{
			isDefault = true;
			str = str.Right(str.GetLength()-1);
		}
		if(file.Open(GetExePath()+str, CFile::modeRead))
		{
			file.Close();
			int cur = m_dots_ctrl.AddString(str);
			if(isDefault)
				m_dots_ctrl.SetCurSel(cur);
		}
	}

	if(m_dots_ctrl.GetCount()==0)
	{
		AfxMessageBox("         .");
		OnCancel();
		return FALSE;
	}

	if(m_dots_ctrl.GetCurSel()<0)
		m_dots_ctrl.SetCurSel(0);

	CString desktop_path = "";
	{
		char *path = new char[MAX_PATH];
		SHGetSpecialFolderPath(m_hWnd, path, CSIDL_DESKTOPDIRECTORY, FALSE);
		desktop_path = path;
		delete path;
	}
	CString EditPath=AfxGetApp()->GetProfileString("options","WorkFolder", NULL);

	if(EditPath.IsEmpty())
		EditPath = desktop_path;

	if(!EditPath.IsEmpty())
	{
		if(EditPath.Right(1)=="\\")
			EditPath = EditPath.Left(EditPath.GetLength()-1);
		m_path = EditPath+"\\"+m_path;
	}

	UpdateData(FALSE);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CExportSetupDlg::OnOK() 
{
	if(!UpdateData()) return;
	m_dots_ctrl.GetWindowText(m_dot);
	
	
	CDialog::OnOK();
}

void CExportSetupDlg::OnFileBrowse() 
{
	if(!UpdateData()) return;
	CFileDialog dlg(FALSE,"aplrep",m_path,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,"  (*.aplrep)|*.aplrep|");
	if(dlg.DoModal()!=IDOK) return;
	m_path = dlg.GetPathName();
	UpdateData(FALSE);
}
