// ExportSpecs.cpp: implementation of the CExportSpecs class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ExportSpecs.h"
#include "CommonQuery.h"
#include "aplguiex.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CExportSpecs::CExportSpecs()
{
	m_api		=NULL;
	m_prd		=NULL;
	m_BasePdf	=NULL;		
}

CExportSpecs::~CExportSpecs()
{
}

CHeader* CExportSpecs::SetHeader(CHeader *header)
{
	if(header==NULL)
		header = new CHeader(NULL);
	header->AddColumn("modify",								aplSTRING);//1
	header->AddColumn("razdel",								aplSTRING);//2
	header->AddColumn("format",								aplSTRING);//3
	header->AddColumn("zone",								aplSTRING);//4
	header->AddColumn("pos",								aplSTRING);//5
	header->AddColumn("id",									aplSTRING);//6
	header->AddColumn("name",								aplSTRING);//7
	header->AddColumn("count_ass",							aplSTRING);//8
	header->AddColumn("count_prd",							aplSTRING);//9
	header->AddColumn("mass",								aplSTRING);//10
	header->AddColumn("material",							aplSTRING);//11
	header->AddColumn("ser_vned",							aplSTRING);//12
	header->AddColumn("ser_gran",							aplSTRING);//13
	header->AddColumn("unit_name",							aplSTRING);//14
	header->AddColumn("mater_code",							aplSTRING);//15
	header->AddColumn("mater_zagot_pofile",					aplSTRING);//16
	header->AddColumn("mater_zagot_count",					aplSTRING);//17
	header->AddColumn("mater_norm_pdf",						aplSTRING);//18
	header->AddColumn("mater_norm_prd",						aplSTRING);//19
	header->AddColumn("mater_norm_pdf_r",					aplSTRING);//20
	header->AddColumn("shifr1",								aplSTRING);//21
	header->AddColumn("shifr2",								aplSTRING);//22
	header->AddColumn("ser_norm_change",					aplSTRING);//23
	header->AddColumn("marshrut_zheh_termo",				aplSTRING);//24
	header->AddColumn("marshrut_zheh_pokryt",				aplSTRING);//25
	header->AddColumn("marshrut_zheh_provider",				aplSTRING);//26
	header->AddColumn("marshrut_zheh_potreb_mater",			aplSTRING);//27
	header->AddColumn("marshrut_zheh_manafacturer1",		aplSTRING);//28
	header->AddColumn("marshrut_zheh_offset_manafacturer1",	aplSTRING);//29
	header->AddColumn("marshrut_zheh_manafacturer2",		aplSTRING);//30
	header->AddColumn("marshrut_zheh_offset_manafacturer2",	aplSTRING);//31
	header->AddColumn("marshrut_zheh_manafacturer3",		aplSTRING);//32
	header->AddColumn("marshrut_zheh_offset_manafacturer3",	aplSTRING);//33
	header->AddColumn("marshrut_zheh_manafacturer4",		aplSTRING);//34
	header->AddColumn("marshrut_zheh_offset_manafacturer4",	aplSTRING);//35
	header->AddColumn("marshrut_zheh_manafacturer5",		aplSTRING);//36
	header->AddColumn("marshrut_zheh_offset_manafacturer5",	aplSTRING);//37
	header->AddColumn("marshrut_zheh_potreb_det",			aplSTRING);//38
	header->AddColumn("potreb_prd",							aplSTRING);//39
	header->AddColumn("ser_marshrut_change",				aplSTRING);//40
	header->AddColumn("comments",							aplSTRING);//41

	return header;
}

bool CExportSpecs::LoadData(aplExtent& pdfs)
{
	CaplInstance*	cit			=NULL;
	CaplLoadData	cld(&m_api->m_data,DEF_SOURCE);

	int				i;
	int				/*i1,i2,i3,i4,*/i5,i6;
	
	for(i=0;i<pdfs.GetSize();i++)
	{
		cit=pdfs.GetAt(i);
		cld.AddQuery(0,cit,true);
	}

	if(0==i) return true;

	//	 char_vals, .  aePdfs  a_apl_charact_val_item
	cld.AddQuery('r',0,m_api->m_charact_mgr.e_apl_charact_value,m_api->m_charact_mgr.a_apl_charact_val_item,true,true);
/*
	//	 bp_ref, .  aePdfs  a_bp_ref_item
	i1=cld.AddQuery('r',0,m_api->m_bp_mgr.e_bp_ref,m_api->m_bp_mgr.a_bp_ref_item,true,true);

		//	 bp,  . . i1  a_bp_ref_process
		i2=cld.AddQuery('d',i1,0,m_api->m_bp_mgr.a_bp_ref_process,true,true);
		
			//	 bp_act,  .  i2  a_bp_act
			cld.AddQuery('d',i2,0,m_api->m_bp_mgr.a_bp_act,true,true);

			//	 bp,  . . i2  a_bp_elements
			i3=cld.AddQuery('d',i2,0,m_api->m_bp_mgr.a_bp_elements,true,true);

				//	 bp_act,  .  i3  a_bp_act
				i4=cld.AddQuery('d',i3,0,m_api->m_bp_mgr.a_bp_act,true,true);

					//	 char_vals,  .  i4  a_bp_ver_char_val_versions
					cld.AddQuery('d',i4,0,m_api->m_bp_mgr.a_bp_ver_char_val_versions,true,true);

				//	 char_vals, .  i3  a_apl_charact_val_item
				cld.AddQuery('r',i3,m_api->m_charact_mgr.e_apl_charact_value,m_api->m_charact_mgr.a_apl_charact_val_item,true,true);
*/

	//	 e_make_from, .   aePdfs  a_pdr_r_ting
	i5=cld.AddQuery('r',0,m_api->m_prd_mgr.e_make_from,m_api->m_prd_mgr.a_pdr_r_ting,true,true);
	
		//	 char_vals, .  i5  a_apl_charact_val_item
		cld.AddQuery('r',i5,m_api->m_charact_mgr.e_apl_charact_value,m_api->m_charact_mgr.a_apl_charact_val_item,true,true);

	//	 ,  .  i5  a_pdr_r_ted
	i6=cld.AddQuery('d',i5,0,m_api->m_prd_mgr.a_pdr_r_ted,true,true);

		//	 prd,  .  i6  a_pdf_prd
		cld.AddQuery('d',i6,0,m_api->m_prd_mgr.a_pdf_prd,true,true);

		//	 char_vals, .  i6  a_apl_charact_val_item
		cld.AddQuery('r',i6,m_api->m_charact_mgr.e_apl_charact_value,m_api->m_charact_mgr.a_apl_charact_val_item,true,true);
	
	cld.LoadEx();
	return true;
}

bool CExportSpecs::DoExport()
{
	CaplReportMgr	mgr;
	CRParamsArray	rpParams;

	CString			cst;

	long			DlgId;

	ASSERT(m_api);
	ASSERT(m_prd);
	
	DlgId=aplStartWaitDlg(" ...");
	
	mgr.m_data_source.SetHeader(SetHeader());

	m_api->m_data.GetAttr(m_prd,m_api->m_prd_mgr.a_prd_id,cst);
	rpParams.Add("prd_id",cst);
	m_api->m_data.GetAttr(m_prd,m_api->m_prd_mgr.a_prd_name,cst);
	rpParams.Add("prd_name",cst);
	
//	params.Add("prd_code");
//	params.Add("prd_ass_code");
//	params.Add("rapped");
//	params.Add("org_name");
//	params.Add("org_id");

	m_api->m_data.GetAttr(m_prd,m_api->m_prd_mgr.a_prd_id,m_sPrdId);

	if(!GetData(&mgr.m_data_source,&rpParams))
	{
		aplEndWaitDlg(DlgId);
		return false;
	}

	SaveToFile(&mgr);
	if(m_sDot.Find("\\")<0)
		m_sDot=GetExePath()+m_sDot;
	if(m_sReport.Find("\\")<0)
		m_sReport=GetExePath()+m_sReport;

	if(GenerateReport(&mgr,&rpParams,m_sDot,m_sReport))
	{
		aplEndWaitDlg(DlgId);
		return true;
	}
	aplEndWaitDlg(DlgId);

	return false;
}

bool CExportSpecs::GetData(CDataSource *pDataSource,CRParamsArray *params)
{
	aplExtent	aePdfExt;

	CString		cst;

	int			i;

	if(pDataSource==NULL)
		return false;

	if(params==NULL)
		return false;

	ASSERT(m_api);
	ASSERT(m_prd);
	
	m_api->m_prd_mgr.GetAllProductVersion(m_prd,aePdfExt);
	LoadData(aePdfExt);
	
//	m_api->m_prd_mgr.LoadPrdInfo(PdfExt);
	
	for(i=0;i<aePdfExt.GetSize();i++)
	{
		m_api->m_data.GetAttr(aePdfExt[i],m_api->m_prd_mgr.a_pdf_id,cst);
		if(cst.IsEmpty())
		{
			m_BasePdf=aePdfExt[i];
			break;
		}
	}

	if(m_BasePdf==NULL)
		return false;

	for(i=0;i<aePdfExt.GetSize();i++)
		if(!AddPdfSpec(aePdfExt[i],pDataSource))
			return false;

	return true;
}

#define ADD_ROW	CTableRow* row = new CTableRow;\
/*1 */	row->AddColumn(modify);\
/*2 */	row->AddColumn(razd);\
/*3 */	row->AddColumn(format);\
/*4 */	row->AddColumn(zone);\
/*5 */	row->AddColumn(position);\
/*6 */	row->AddColumn(prd_id);\
/*7 */	row->AddColumn(prd_name);\
/*8 */	row->AddColumn(count);\
/*9 */	row->AddColumn("");\
/*10*/	if(mass!=0) row->AddColumn(mass);\
		else  row->AddColumn("");\
/*11*/	row->AddColumn(material);\
/*12*/	row->AddColumn("");\
/*13*/	row->AddColumn("");\
/*14*/	row->AddColumn(unit);\
/*15*/	row->AddColumn(mat_code);\
/*16*/	row->AddColumn(""/*mater_shape*/);\
/*17*/	row->AddColumn("");\
/*18*/	row->AddColumn(mat_count);\
/*19*/	row->AddColumn("");\
/*20*/	row->AddColumn("");\
/*21*/	row->AddColumn("");\
/*22*/	row->AddColumn("");\
/*23*/	row->AddColumn("");\
/*24*/	row->AddColumn(""/*zheh.m_sZhehTermo*/);\
/*25*/	row->AddColumn(""/*zheh.m_sZhehPokr*/);\
/*26*/	row->AddColumn(""/*zheh.m_sZhehProv*/);\
/*27*/	row->AddColumn(""/*zheh.m_sZhehPotrebMat*/);\
/*28*/	row->AddColumn(""/*zheh.m_sZheha[0]*/);\
/*29*/	row->AddColumn(""/*zheh.m_sOffset[0]*/);\
/*30*/	row->AddColumn(""/*zheh.m_sZheha[1]*/);\
/*31*/	row->AddColumn(""/*zheh.m_sOffset[1]*/);\
/*32*/	row->AddColumn(""/*zheh.m_sZheha[2]*/);\
/*33*/	row->AddColumn(""/*zheh.m_sOffset[2]*/);\
/*34*/	row->AddColumn(""/*zheh.m_sZheha[3]*/);\
/*35*/	row->AddColumn(""/*zheh.m_sOffset[3]*/);\
/*36*/	row->AddColumn(""/*zheh.m_sZheha[4]*/);\
/*37*/	row->AddColumn(""/*zheh.m_sOffset[4]*/);\
/*38*/	row->AddColumn(""/*zheh.m_sZhehPotrebDet*/);\
/*39*/	row->AddColumn("");\
/*40*/	row->AddColumn("");\
/*41*/	row->AddColumn("");\
		pDataSource->AddRow(row);

bool CExportSpecs::AddPdfSpec(CaplInstance *pdf,CDataSource *pDataSource)
{
	aplExtent RelExt, PdfExt, MaterRelsExt, MaterExt;
	aplExtent CharactExt, DocCharactExt, GrExt, MCharactExt, DocExt, DocRelExt;

	CaplInstance *iCurPdf, *iCurRel, *iCurPrd, *iMakeFrom, *iMaterial, *iMatPrd, *iUnit;
	CaplInstance* ShapeCharact, *MassCharact, *FormatCaharct;
	CaplInstance* val;

	CString position,prd_id,prd_name,material,modify,razd,buf;
	CString unit,mat_code,mater_shape,format,zone;
	CString pdf_id;

	double count, mat_count, mass;

	int		i;

	if(pdf==NULL) 
		return false;

	ShapeCharact	=m_api->m_charact_mgr.GetCharacteristicById("storage");
	MassCharact		=m_api->m_charact_mgr.GetCharacteristicById("");
	FormatCaharct	=m_api->m_charact_mgr.GetCharacteristicById("Format");

	m_api->m_data.GetAttr(pdf,m_api->m_prd_mgr.a_pdf_id,modify);
	if(!modify.IsEmpty() && !m_sPrdId.IsEmpty())
		modify=m_sPrdId+"-"+modify;
	
	m_api->m_prd_mgr.LoadAllSubProduct(NULL,NULL,pdf,RelExt,PdfExt);
	LoadData(PdfExt);
	FindAssociatedCharacteristic(PdfExt,CharactExt);
	
	//    
	position.Empty();prd_id.Empty();prd_name.Empty();material.Empty();razd.Empty();buf.Empty();
	unit.Empty();mat_code.Empty();mater_shape.Empty();format.Empty();zone.Empty();
	count=0;mat_count=0;mass=0;
	razd.Empty();

	iMakeFrom=FindMakeFrom(pdf);
	iMaterial=NULL;
	if(iMakeFrom)
		m_api->m_data.GetAttr(iMakeFrom,m_api->m_prd_mgr.a_pdr_r_ted,iMaterial);
	
//	CZhehChar zheh(pdf,NULL,iMakeFrom,iMaterial,m_api,m_BP_TP_type,m_BP_ZHEH_type);
//	zheh.GetData();
	
	ADD_ROW;
	
	//
	m_api->m_doc_mgr.FindAssociatedDocuments(pdf,DocExt,DocRelExt,NULL);
	FindAssociatedCharacteristic(DocExt,DocCharactExt);
	
	for(i=0;i<DocExt.GetSize();i++)
	{
		position.Empty();prd_id.Empty();prd_name.Empty();material.Empty();razd.Empty();
		buf.Empty();
		unit.Empty();mat_code.Empty();mater_shape.Empty();format.Empty();zone.Empty();
		count=0;mat_count=0;mass=0;
		razd="1";
		
		m_api->m_data.GetAttr(DocExt[i],m_api->m_doc_mgr.a_doc_descr,buf);
		if(buf.Find(m_sDocDescr)<0) 
			continue;
		m_api->m_data.GetAttr(DocExt[i],m_api->m_doc_mgr.a_doc_id,prd_id);
		m_api->m_data.GetAttr(DocExt[i],m_api->m_doc_mgr.a_doc_name,prd_name);
		//  .
		val=FindCharact(DocCharactExt,FormatCaharct,DocExt[i]);
		if(val)
			if(m_api->m_data.IsKindOf(val,m_api->m_charact_mgr.e_descr_value))
				m_api->m_data.GetAttr(val,m_api->m_charact_mgr.a_apl_charact_val_descr_val,
									  format);
		ADD_ROW;
	}

	//   ..
	for(i=0;i<RelExt.GetSize();i++)
	{
		position.Empty();prd_id.Empty();prd_name.Empty();material.Empty();razd.Empty();
		buf.Empty();
		unit.Empty();mat_code.Empty();mater_shape.Empty();format.Empty();zone.Empty();
		count=0;mat_count=0;mass=0;
		razd="9";
		iMaterial=iMakeFrom=NULL;

		iCurRel=RelExt[i];
		if(iCurRel==NULL) 
			continue;
		
		m_api->m_data.GetAttr(iCurRel,m_api->m_prd_mgr.a_pdr_r_ted,iCurPdf);
		if(m_BasePdf == iCurPdf)
			continue;// ,      
		
		razd=GetPartType(iCurPdf);
		m_api->m_data.GetAttr(iCurPdf,m_api->m_prd_mgr.a_pdf_prd,iCurPrd);
		if(iCurPrd==NULL)
			continue;
		
		m_api->m_data.GetAttr(iCurPrd,m_api->m_prd_mgr.a_prd_id,prd_id);
		m_api->m_data.GetAttr(iCurPrd,m_api->m_prd_mgr.a_prd_name,prd_name);
		m_api->m_data.GetAttr(iCurRel,m_api->m_prd_mgr.a_apl_qacu_value,count);
		m_api->m_data.GetAttr(iCurRel,m_api->m_prd_mgr.a_pdr_id,position);
		
		val=FindCharact(CharactExt,MassCharact,iCurPdf);
		if(val)
			if(m_api->m_data.IsKindOf(val,m_api->m_charact_mgr.e_meas_value))
				m_api->m_data.GetAttr(val,m_api->m_charact_mgr.a_apl_charact_val_meas_val,mass);
		
		//      .
		iMakeFrom=FindMakeFrom(iCurPdf);
		if(iMakeFrom)
		{
			m_api->m_data.GetAttr(iMakeFrom,m_api->m_prd_mgr.a_pdr_r_ted,iMaterial);
			if(iMaterial)
			{
//				m_api->m_prd_mgr.LoadPrdInfo(iMaterial);
				m_api->m_data.GetAttr(iMaterial,m_api->m_prd_mgr.a_pdf_prd,iMatPrd);
				if(iMatPrd)
					m_api->m_data.GetAttr(iMatPrd, m_api->m_prd_mgr.a_prd_name,material);
				m_api->m_data.GetAttr(iMaterial,m_api->m_prd_mgr.a_pdf_code,mat_code);
			}
			m_api->m_data.GetAttr(iMakeFrom,m_api->m_prd_mgr.a_make_from_unit,iUnit);
			m_api->m_data.GetAttr(iMakeFrom,m_api->m_prd_mgr.a_make_from_value,mat_count);
			if(iUnit)
				m_api->m_data.GetAttr(iUnit,m_api->m_charact_mgr.a_apl_unit_id,unit);
			
//			aplExtent extMat;
//			extMat.Add(iMaterial);
//			FindAssociatedCharacteristic(extMat,MCharactExt);
//			CaplInstance* val = FindCharact(MCharactExt,ShapeCharact,iMaterial);
//			if(val)
//				m_api->m_data.GetAttr(val,m_api->m_charact_mgr.a_apl_charact_val_descr_val,mater_shape);
		}
		
		//
//		CZhehChar zheh(iCurPdf,iCurRel,iMaterial,iMakeFrom,m_api,m_BP_TP_type,m_BP_ZHEH_type);
//		if(!zheh.GetData())
//			return false;
		ADD_ROW;
	}
	
	return true;
}

bool CExportSpecs::FindAssociatedCharacteristic(aplExtent &ext, aplExtent &out_ext)
{
	aplExtent		ext_ref;
	CaplInstance*	inst		=NULL;

	int				i;
	int				num;

	out_ext.Clear();

	CSortClass::SortExtentByInst(ext);
	
	m_api->m_data.GetEntityExtent(m_api->m_charact_mgr.e_apl_charact_value,ext_ref);

	for(i=0;i<ext_ref.GetSize();i++)
	{
		if(ext_ref[i]->GetAccessmode()>aplRO)
			continue;
		m_api->m_data.GetAttr(ext_ref[i],m_api->m_charact_mgr.a_apl_charact_val_item,inst);
		num=aplQFindInstInExtent(ext,inst);
		if(num>-1)
			out_ext.Add(ext_ref[i]);
	}

	return true;	
}

CaplInstance* CExportSpecs::FindMakeFrom(CaplInstance *pdf)
{
	aplExtent		res;
	CaplInstance*	item;

	int				ranking;
	int				i;

	ASSERT(m_api);
	ASSERT(m_prd);
	ASSERT(pdf);
	
/*	CaplLoadData ld(&m_api->m_data, DEF_SOURCE);
	ld.AddQuery('b', pdf->id, m_api->m_prd_mgr.e_make_from, m_api->m_prd_mgr.a_pdr_r_ting, true, true);
	ld.LoadEx(true, &res);*/
	
	m_api->m_data.GetEntityExtent(m_api->m_prd_mgr.e_make_from,res);

	if(res.Size==0)
		return NULL;
	for(i=0;i<res.Size;i++)
	{
		item=NULL;
		m_api->m_data.GetAttr(res[i],m_api->m_prd_mgr.a_pdr_r_ting,item);
		if(pdf!=item)
			continue;
		
		m_api->m_data.GetAttr(res[i],m_api->m_prd_mgr.a_make_from_ranking,ranking);
		if(ranking==1)
			return res[i];
	}
	
	return res[0];
}

CaplInstance* CExportSpecs::FindCharact(aplExtent &ext,CaplInstance *charact,
										CaplInstance *item,bool bDelete)
{
	CaplInstance*	ichar, *iitem;
	CaplInstance*	res;

	for(int i=0; i<ext.Size; i++)
	{
		m_api->m_data.GetAttr(ext[i],m_api->m_charact_mgr.a_apl_charact_val_item,iitem);
		if(item==iitem)
		{
			m_api->m_data.GetAttr(ext[i],m_api->m_charact_mgr.a_apl_charact_val_charact,ichar);
			if(ichar==charact)
			{
				if(bDelete)
				{
					res=ext[i];
					ext.Remove(i);
					return res;
				}
				else
					return ext[i];
			}
		}
	}

	return NULL;
}

CZhehChar::CZhehChar(CaplInstance* Pdf,CaplInstance* Rel,CaplInstance* Mater,
					 CaplInstance* MakeFrom,CaplAPI* api,CaplInstance* BP_TP_type,
					 CaplInstance* BP_ZHEH_type)
{
	int				i;

	ASSERT(api);
	ASSERT(Pdf);
	ASSERT(BP_TP_type);
	ASSERT(BP_ZHEH_type);

	m_BP_TP_type=BP_TP_type;
	m_BP_ZHEH_type=BP_ZHEH_type;

	m_api=api;
	m_Pdf=Pdf;
	m_Rel=Rel;
	m_Mater=Mater;
	m_MakeFrom=MakeFrom;

	m_sZhehTermo.Empty();
	m_sZhehPokr.Empty();
	m_sZhehProv.Empty();

	for(i=0;i<5;i++)
	{
		m_sZheha[i].Empty();
		m_sOffset[i].Empty();
	}

	m_sZhehPotrebMat.Empty();
}

CZhehChar::~CZhehChar()
{
}

bool CZhehChar::GetData()
{
	aplExtent		BPExt, TmpExt, RelExt;
	aplExtent		Characts, Groups;

	CaplInstance*	BpType;		
	CaplInstance*	BP		=NULL;
	CaplInstance*	zheha[5];
	CaplInstance*	Termo, *Pokr;
	CaplInstance*	ChShop, *ChOffset, *ChCustumer;

	CaplInstance*	item	=NULL;
	CaplInstance*	bp		=NULL;

	CString			buf,id,RootId;

	int				i,index,ind;

	for(i=0;i<5;i++)
		zheha[i]=NULL;
	
//	m_api->m_bp_mgr.FindAssociatedBP(m_Pdf, BPExt, RelExt);
	
	//  BP
	m_api->m_data.GetEntityExtent(m_api->m_bp_mgr.e_bp_ref,RelExt);
	
	for(i=0;i<RelExt.GetSize();i++)
	{
		item= NULL;
		m_api->m_data.GetAttr(RelExt[i],m_api->m_bp_mgr.a_bp_ref_item,item);
		if(item!=m_Pdf)
			continue;

		bp= NULL;
		m_api->m_data.GetAttr(RelExt[i],m_api->m_bp_mgr.a_bp_ref_process,bp);
		if(!bp)
			continue;
		
		m_api->m_data.GetAttr(bp,m_api->m_bp_mgr.a_bp_type,BpType);
		if(BpType==m_BP_TP_type)
		{
			BP = bp;
			break;
		}
	}

	if(!BP)
		return true;
	BPExt.Clear();
	
	m_api->m_data.GetAttr(BP,m_api->m_bp_mgr.a_bp_elements,BPExt);
//	m_api->m_bp_mgr.LoadBPInfo(BPExt);
	m_api->m_data.GetAttr(BP,m_api->m_bp_mgr.a_bp_id,RootId);
	
	for(i=0;i<BPExt.GetSize();i++)
	{
		m_api->m_data.GetAttr(BPExt[i],m_api->m_bp_mgr.a_bp_id,id);
		index=id.ReverseFind('_');
		if(-1!=index)
			id=id.Right(id.GetLength()-1-index);

/*		id.TrimLeft(RootId);
		id.TrimLeft("_");*/
		if(id=="")
			Termo=BPExt[i];
		else 
		if(id=="")
			Pokr=BPExt[i];
		else
		{
			if(!IsRealOrEmpty(id))/* return false;*/
				continue;
			ind=atoi(id)-1;
			zheha[ind]=BPExt[i];
		}
	}
	bool bAllZerro=true;
	for(i=0;i<5;i++)
		if(zheha[i])
			bAllZerro = false;
	if(!bAllZerro)
		while(zheha[4]==NULL)
		{
			for(i=1;i<5;i++)
			{
				if(zheha[5-i]==NULL)
				{
					zheha[5-i]=zheha[4-i];
					zheha[4-i]=NULL;
				}
				else break;			
			}
		}
	if(m_Rel)
		BPExt.Add(m_Rel);
	if(m_MakeFrom)
		BPExt.Add(m_MakeFrom);
	if(m_Mater)
		BPExt.Add(m_Mater);
	
	FindAssociatedCharacteristic(BPExt,Characts);
	
	ChShop=m_api->m_charact_mgr.GetCharacteristicById("SHOP");
	ChOffset=m_api->m_charact_mgr.GetCharacteristicById("OFFSET");
	ChCustumer=m_api->m_charact_mgr.GetCharacteristicById("CUSTUMER");

	m_sZhehPokr=GetZhehName(Characts,Pokr,ChShop);
	m_sZhehTermo=GetZhehName(Characts,Termo,ChShop);
	m_sZhehPotrebMat=GetZhehName(Characts,m_MakeFrom,ChCustumer);
	m_sZhehProv = GetZhehName(Characts,m_Mater,ChCustumer);
	m_sZhehPotrebDet = GetZhehName(Characts,m_Rel,ChCustumer);
	
	for(i=0;i<5;i++)
	{
		m_sZheha[i]=GetZhehName(Characts,zheha[i],ChShop);
		m_sOffset[i]=GetZhehName(Characts,zheha[i],ChOffset);
		if(m_sOffset[i]=="0") 
			m_sOffset[i].Empty();
	}
	
	return true;
}

CString CZhehChar::GetZhehName(aplExtent &Characts,CaplInstance *BP,CaplInstance *Charact)
{
	CaplInstance *item, *org, *ch;

	CString		res;

	double		d;
	
	int			i;

	if(BP==NULL)
		return res;

	if(Charact==NULL)
	{
		for(i=0;i<Characts.GetSize();i++)
		{
			m_api->m_data.GetAttr(Characts[i],m_api->m_charact_mgr.a_apl_charact_val_item,item);
			if(item==BP)
			{
				if(m_api->m_data.IsKindOf(Characts[i],m_api->m_charact_mgr.e_apl_reference_value))
				{
					m_api->m_data.GetAttr(Characts[i], m_api->m_charact_mgr.a_apl_reference_val,org);
					if(org)
						m_api->m_data.GetAttr(org, m_api->m_appr_mgr.a_org_id,res);
					return res;
				}
				else 
				if(m_api->m_data.IsKindOf(Characts[i],m_api->m_charact_mgr.e_meas_value))
				{
					m_api->m_data.GetAttr(Characts[i],m_api->m_charact_mgr.a_apl_charact_val_meas_val,d);
					res.Format("%.f");

					return res;
				}
			}
		}
	}
	else
	{
		for(i=0;i<Characts.GetSize();i++)
		{
			m_api->m_data.GetAttr(Characts[i],m_api->m_charact_mgr.a_apl_charact_val_charact,ch);
			if(ch!=Charact)
				continue;
			m_api->m_data.GetAttr(Characts[i],m_api->m_charact_mgr.a_apl_charact_val_item,item);
			if(item==BP)
			{
				if(m_api->m_data.IsKindOf(Characts[i],m_api->m_charact_mgr.e_apl_reference_value))
				{
					m_api->m_data.GetAttr(Characts[i],m_api->m_charact_mgr.a_apl_reference_val,org);
					if(org)
						m_api->m_data.GetAttr(org,m_api->m_appr_mgr.a_org_id,res);
					return res;
				}
				else 
				if(m_api->m_data.IsKindOf(Characts[i],m_api->m_charact_mgr.e_meas_value))
				{
					m_api->m_data.GetAttr(Characts[i],m_api->m_charact_mgr.a_apl_charact_val_meas_val,d);
					res.Format("%.f", d);

					return res;
				}
			}
		}
	}

	return res;
}

CString CExportSpecs::GetPartType(CaplInstance *pdf)
{
	CString buf;

	bool bStand;

	m_api->m_data.GetAttr(pdf,m_api->m_prd_mgr.a_apl_pdf_type,buf);
	m_api->m_data.GetAttr(pdf,m_api->m_prd_mgr.a_apl_pdf_standard,bStand);

	if(bStand && buf.CompareNoCase("material")!=0)
		return "5";

	if(!bStand && buf.CompareNoCase("assembly")==0)
		return "3";

	else 
	if(!bStand && buf.CompareNoCase("komplex")==0)
		return "2";
	else 
	if(!bStand && buf.CompareNoCase("kit")==0)
		return "8";
	else
	if(!bStand && buf.CompareNoCase("part")==0)
		return "4";
	else 
	if(buf.CompareNoCase("material")==0)
		return "7";
	else 
	if(!bStand)
	{
		m_api->m_data.GetAttr(pdf,m_api->m_prd_mgr.a_pdfwss_source,buf);
		if(buf.CompareNoCase("bought")==0)
			return "6";
	}

	return "9";
}

bool CZhehChar::FindAssociatedCharacteristic(aplExtent &ext,aplExtent &out_ext)
{
	aplExtent		ext_ref;

	CaplInstance*	inst;

	int				i,num;

	out_ext.Clear();
	CSortClass::SortExtentByInst(ext);

	m_api->m_data.GetEntityExtent(m_api->m_charact_mgr.e_apl_charact_value, ext_ref);
	
	for(i=0;i<ext_ref.GetSize();i++)
	{
		if(ext_ref[i]->GetAccessmode()>aplRO) 
			continue;
		m_api->m_data.GetAttr(ext_ref[i],m_api->m_charact_mgr.a_apl_charact_val_item,inst);
		num=aplQFindInstInExtent(ext,inst);
		if(num>-1)
			out_ext.Add(ext_ref[i]);
	}

	return true;
}
