// ExportSpecs.h: interface for the CExportSpecs class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EXPORTSPECS_H__648E5A81_057A_4ABD_B967_D550F9905CA9__INCLUDED_)
#define AFX_EXPORTSPECS_H__648E5A81_057A_4ABD_B967_D550F9905CA9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "apl_api.h"
#include "ReportDict.h"
class CZhehChar
{
protected:
	CaplInstance* m_Pdf;
	CaplInstance* m_Rel;
	CaplInstance* m_Mater;
	CaplInstance* m_MakeFrom;
	CaplInstance* m_BP_TP_type;
	CaplInstance* m_BP_ZHEH_type;
	CaplAPI* m_api;

public:
	CString GetZhehName(aplExtent& Characts, CaplInstance *BP, CaplInstance *Charact);

	CString m_sZhehTermo;
	CString m_sZhehPokr;
	CString m_sZhehProv;
	CString m_sZheha[5];
	CString m_sOffset[5];

	CString m_sZhehPotrebMat;
	CString m_sZhehPotrebDet;

	CZhehChar(CaplInstance* Pdf, CaplInstance* Rel, CaplInstance* Mater, CaplInstance* MakeFrom, CaplAPI* api, CaplInstance* BP_TP_type, CaplInstance* BP_ZHEH_type);
	~CZhehChar();
	bool GetData();

	bool FindAssociatedCharacteristic(aplExtent &ext, aplExtent &out_ext);
};

class AFX_CLASS_EXPORT CExportSpecs  
{
protected:
	CaplInstance	*m_BasePdf;
	CString			m_sPrdId;

public:
	CString GetPartType(CaplInstance* pdf);
	CaplInstance* FindMakeFrom(CaplInstance* pdf);
	bool AddPdfSpec(CaplInstance* pdf, CDataSource* pDataSource);
	bool FindAssociatedCharacteristic(aplExtent &ext, aplExtent &out_ext);
	CaplInstance* FindCharact(aplExtent &ext, CaplInstance *charact, CaplInstance *item, bool bDelete = false);
	CaplAPI			*m_api;
	CString			m_sReport;
	CString			m_sDot;
	CString			m_sDocDescr;
	CaplInstance	*m_prd;
	
	bool LoadData(aplExtent& pdfs);
	bool GetData(CDataSource* pDataSource, CRParamsArray* params);
	bool DoExport();
	static CHeader* SetHeader(CHeader* header = NULL);
	CExportSpecs();
	virtual ~CExportSpecs();

};

#endif // !defined(AFX_EXPORTKVZ_KTS_H__648E5A81_057A_4ABD_B967_D550F9905CA9__INCLUDED_)
