// ExportTDDlg.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "ExportTDDlg.h"
#include "aplExportTechDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExportTDDlg dialog


CExportTDDlg::CExportTDDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExportTDDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExportTDDlg)
	m_mk_export = TRUE;
	m_ok_export = TRUE;
	m_vm_export = TRUE;
	m_vo_export = TRUE;
	m_vob_export = TRUE;
	m_filename = _T("");
	m_tl_export = FALSE;
	m_os_export = FALSE;
	m_tp_export = FALSE;
	m_ki_export = FALSE;
	m_kk_export = FALSE;
	m_kp_export = FALSE;
	//}}AFX_DATA_INIT
	m_api = NULL;
	m_inst = NULL;
	m_bIsOGT = FALSE;
}


void CExportTDDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExportTDDlg)
	DDX_Control(pDX, IDC_COMBO_KP, m_kp_combo);
	DDX_Control(pDX, IDC_CHECK_KP, m_kp_btn);
	DDX_Control(pDX, IDC_COMBO_KK, m_kk_combo);
	DDX_Control(pDX, IDC_CHECK_KI, m_ki_btn);
	DDX_Control(pDX, IDC_COMBO_OK_OGT, m_ok_ogt_combo);
	DDX_Control(pDX, IDC_COMBO_KI, m_ki_combo);
	DDX_Control(pDX, IDC_COMBO_TP, m_tp_combo);
	DDX_Control(pDX, IDC_COMBO_OS, m_os_combo);
	DDX_Control(pDX, IDC_STATUS, m_status);
	DDX_Control(pDX, IDC_PROGRESS, m_progress);
	DDX_Control(pDX, IDC_COMBO_TL, m_tl_combo);
	DDX_Control(pDX, IDC_COMBO_VOB, m_vob_combo);
	DDX_Control(pDX, IDC_COMBO_VO, m_vo_combo);
	DDX_Control(pDX, IDC_COMBO_VM, m_vm_combo);
	DDX_Control(pDX, IDC_COMBO_OK, m_ok_combo);
	DDX_Control(pDX, IDC_COMBO_MK, m_mk_combo);
	DDX_Check(pDX, IDC_CHECK_MK, m_mk_export);
	DDX_Check(pDX, IDC_CHECK_OK, m_ok_export);
	DDX_Check(pDX, IDC_CHECK_VM, m_vm_export);
	DDX_Check(pDX, IDC_CHECK_VO, m_vo_export);
	DDX_Check(pDX, IDC_CHECK_VOB, m_vob_export);
	DDX_Text(pDX, IDC_FILEPATH, m_filename);
	DDX_Check(pDX, IDC_CHECK_TL, m_tl_export);
	DDX_Check(pDX, IDC_CHECK_OS, m_os_export);
	DDX_Check(pDX, IDC_CHECK_TP, m_tp_export);
	DDX_Check(pDX, IDC_CHECK_KI, m_ki_export);
	DDX_Check(pDX, IDC_CHECK_KK, m_kk_export);
	DDX_Check(pDX, IDC_CHECK_KP, m_kp_export);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CExportTDDlg, CDialog)
	//{{AFX_MSG_MAP(CExportTDDlg)
	ON_BN_CLICKED(IDC_BROWSE_FILE, OnBrowseFile)
	ON_BN_CLICKED(IDC_CHECK_MK, OnCheckMk)
	ON_BN_CLICKED(IDC_CHECK_OK, OnCheckOk)
	ON_BN_CLICKED(IDC_CHECK_VOB, OnCheckVob)
	ON_BN_CLICKED(IDC_CHECK_VO, OnCheckVo)
	ON_BN_CLICKED(IDC_CHECK_VM, OnCheckVm)
	ON_BN_CLICKED(IDC_CHECK_TL, OnCheckTl)
	ON_BN_CLICKED(IDC_CHECK_OS, OnCheckOs)
	ON_BN_CLICKED(IDC_CHECK_KI, OnCheckKi)
	ON_BN_CLICKED(IDC_CHECK_TP, OnCheckTp)
	ON_BN_CLICKED(IDC_CHECK_KK, OnCheckKk)
	ON_BN_CLICKED(IDC_CHECK_KP, OnCheckKp)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CExportTDDlg message handlers

BOOL CExportTDDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

	ASSERT(m_api);
	ASSERT(m_inst);

	//   
	m_sExePath = GetExePath();
	
	CString filename = m_sExePath+"ExportKTS.dots";
	if(!ReadDots(filename, "ExportKTS_MK", &m_mk_combo))
		EndDialog(0);
	if(!ReadDots(filename, "ExportKTS_OK", &m_ok_combo))
		EndDialog(0);
	if(!ReadDots(filename, "ExportKTS_OK_", &m_ok_ogt_combo))
		EndDialog(0);
	if(!ReadDots(filename, "ExportKTS_VO", &m_vo_combo))
		EndDialog(0);
	if(!ReadDots(filename, "ExportKTS_VOb", &m_vob_combo))
		EndDialog(0);
	if(!ReadDots(filename, "ExportKTS_VM", &m_vm_combo))
		EndDialog(0);
	if(!ReadDots(filename, "ExportKTS_TL", &m_tl_combo))
		EndDialog(0);
	if(!ReadDots(filename, "ExportKTS_OS", &m_os_combo))
		EndDialog(0);
	if(!ReadDots(filename, "ExportKTS_TP", &m_tp_combo))
		EndDialog(0);
	if(!ReadDots(filename, "ExportKTS_KI", &m_ki_combo))
		EndDialog(0);
	if(!ReadDots(filename, "ExportKTS_KK", &m_kk_combo))
		EndDialog(0);
	if(!ReadDots(filename, "ExportKTS_KP", &m_kp_combo))
		EndDialog(0);

	CaplInstance* CurPers = m_api->m_appr_mgr.GetCurrentPerson();
	if(CurPers)
	{
		//    .
		CString buf;
		CaplInstance* org;
		aplExtent rels;
		CaplLoadData ld(&m_api->m_data, DEF_SOURCE);
		ld.AddQuery('b', CurPers->GetId(), m_api->m_appr_mgr.e_pers_org, m_api->m_appr_mgr.a_po_the_pers, true, true);
		ld.LoadEx(true, &rels);
		for(int i=0; i<rels.Size; i++)
		{
			if(rels[i]->GetAccessmode()>aplRO) continue;
			if(!m_api->m_data.IsKindOf(rels[i], m_api->m_appr_mgr.e_pers_org)) continue;
			m_api->m_data.GetAttr(rels[i], m_api->m_appr_mgr.a_po_the_org, org);
			if(org==NULL) continue;
			if(org->GetAccessmode()>aplRO) continue;
			m_api->m_data.GetAttr(org, m_api->m_appr_mgr.a_org_id, buf);
			if(buf.CompareNoCase("")==0)
				m_bIsOGT = TRUE;
		}
	}

	m_ok_ogt_combo.EnableWindow(m_bIsOGT);

	//    
	CString str;
	m_api->m_data.GetAttr(m_inst, m_api->m_bp_mgr.a_bp_id, str);
	str+=".aplrep";

	CString desktop_path = "";
	{
		char *path = new char[MAX_PATH];
		SHGetSpecialFolderPath(m_hWnd, path, CSIDL_DESKTOPDIRECTORY, FALSE);
		desktop_path = path;
		delete path;
	}
	CString EditPath=AfxGetApp()->GetProfileString("options","WorkFolder", NULL);

	if(EditPath.IsEmpty())
		EditPath = desktop_path;

	if(!EditPath.IsEmpty())
	{
		if(EditPath.Right(1)!="\\")
			EditPath = EditPath+"\\";
		m_filename = EditPath+str;
	}

	//   
	m_mk_export = (BOOL)AfxGetApp()->GetProfileInt("ExportKTS_plugin","mk_export",1);
	m_ok_export = (BOOL)AfxGetApp()->GetProfileInt("ExportKTS_plugin","ok_export",1);
	m_vm_export = (BOOL)AfxGetApp()->GetProfileInt("ExportKTS_plugin","vm_export",1);
	m_vo_export = (BOOL)AfxGetApp()->GetProfileInt("ExportKTS_plugin","vo_export",1);
	m_vob_export = (BOOL)AfxGetApp()->GetProfileInt("ExportKTS_plugin","vob_export",1);
	m_tl_export = (BOOL)AfxGetApp()->GetProfileInt("ExportKTS_plugin","tl_export",1);
	m_os_export = (BOOL)AfxGetApp()->GetProfileInt("ExportKTS_plugin","os_export",1);
	m_tp_export = (BOOL)AfxGetApp()->GetProfileInt("ExportKTS_plugin","tp_export",1);
	m_ki_export = (BOOL)AfxGetApp()->GetProfileInt("ExportKTS_plugin","ki_export",1);
	m_kk_export = (BOOL)AfxGetApp()->GetProfileInt("ExportKTS_plugin","kk_export",1);
	m_kp_export = (BOOL)AfxGetApp()->GetProfileInt("ExportKTS_plugin","kp_export",1);
	TestFlag(m_ki_export, &m_ki_combo);
	TestFlag(m_kp_export, &m_kp_combo);
	TestFlag(m_mk_export, &m_mk_combo);
	TestFlag(m_ok_export, &m_ok_combo);
	if(m_bIsOGT)
		TestFlag(m_ok_export, &m_ok_ogt_combo);
	TestFlag(m_vob_export, &m_vob_combo);
	TestFlag(m_vo_export, &m_vo_combo);
	TestFlag(m_vm_export, &m_vm_combo);
	TestFlag(m_tl_export, &m_tl_combo);
	TestFlag(m_os_export, &m_os_combo);
	TestFlag(m_tp_export, &m_tp_combo);
	TestFlag(m_kk_export, &m_kk_combo);

	UpdateData(FALSE);

	OnCheckOk();

	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CExportTDDlg::OnBrowseFile() 
{
	if(!UpdateData()) return;
	CFileDialog dlg(FALSE,"aplrep",m_filename,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,"  (*.aplrep)|*.aplrep|");
	if(dlg.DoModal()!=IDOK) return;
	m_filename = dlg.GetPathName();
	UpdateData(FALSE);
}

bool CExportTDDlg::ReadDots(CString file, CString sec, CComboBox *combo)
{
	CStringArray Arr;
	::ReadDots(file, sec, &Arr);
	CFile f;
	CString pathname, str;
	bool bSelect;
	int ind;
	for(int i=0; i<Arr.GetSize(); i++)
	{
		bSelect = false;
		str = Arr[i];
		if(str[0]=='&')
		{
			bSelect = true;
			str = str.Right(str.GetLength()-1);
		}
		if(str.Find("\\")>-1)
		{
			if(!f.Open(str, CFile::modeRead))
				continue;
			f.Close();
		}
		else
		{
			pathname = GetExePath()+str;
			if(!f.Open(pathname, CFile::modeRead))
				continue;
			f.Close();
		}
		ind = combo->AddString(str);
		if(bSelect)
			combo->SetCurSel(ind);
	}
	if(combo->GetCount()==0)
	{
		CString MessBuf;
		MessBuf.Format("         .\n: [%s]", sec);
		AfxMessageBox(MessBuf);
		return false;
	}
	if(combo->GetCurSel()<0)
		combo->SetCurSel(0);
	return true;
}

void CExportTDDlg::OnOK() 
{
	if(!UpdateData()) return;

	AfxGetApp()->WriteProfileInt("ExportKTS_plugin","mk_export",m_mk_export);
	AfxGetApp()->WriteProfileInt("ExportKTS_plugin","ok_export",m_ok_export);
	AfxGetApp()->WriteProfileInt("ExportKTS_plugin","vm_export",m_vm_export);
	AfxGetApp()->WriteProfileInt("ExportKTS_plugin","vo_export",m_vo_export);
	AfxGetApp()->WriteProfileInt("ExportKTS_plugin","vob_export",m_vob_export);
	AfxGetApp()->WriteProfileInt("ExportKTS_plugin","tl_export",m_tl_export);
	AfxGetApp()->WriteProfileInt("ExportKTS_plugin","os_export",m_os_export);
	AfxGetApp()->WriteProfileInt("ExportKTS_plugin","tp_export",m_tp_export);
	AfxGetApp()->WriteProfileInt("ExportKTS_plugin","ki_export",m_ki_export);
	AfxGetApp()->WriteProfileInt("ExportKTS_plugin","kk_export",m_kk_export);
	AfxGetApp()->WriteProfileInt("ExportKTS_plugin","kp_export",m_kp_export);

	CaplExportTechDoc Export(m_api);
	Export.inInst = m_inst;
	Export.m_progress = &m_progress;
	Export.m_edit = &m_status;

	
	TDotsData data;
	data.ExMK = m_mk_export;
	data.ExOK = m_ok_export;
	data.ExVO = m_vo_export;
	data.ExVOb = m_vob_export;
	data.ExVM = m_vm_export;
	data.ExTL = m_tl_export;
	data.ExOS = m_os_export;
	data.ExTP = m_tp_export;
	data.ExKI = m_ki_export;
	data.ExKK = m_kk_export;
	data.ExKP = m_kp_export;

	m_mk_combo.GetWindowText(data.MK_dot);
	data.MK_dot = m_sExePath + data.MK_dot;
	m_ok_combo.GetWindowText(data.OK_dot);
	data.OK_dot = m_sExePath + data.OK_dot;
	m_vo_combo.GetWindowText(data.VO_dot);
	data.VO_dot = m_sExePath + data.VO_dot;
	m_vob_combo.GetWindowText(data.VOb_dot);
	data.VOb_dot = m_sExePath + data.VOb_dot;
	m_vm_combo.GetWindowText(data.VM_dot);
	data.VM_dot = m_sExePath + data.VM_dot;
	m_tl_combo.GetWindowText(data.TL_dot);
	data.TL_dot = m_sExePath + data.TL_dot;
	m_os_combo.GetWindowText(data.OS_dot);
	data.OS_dot = m_sExePath + data.OS_dot;
	m_tp_combo.GetWindowText(data.TP_dot);
	data.TP_dot = m_sExePath + data.TP_dot;
	m_ki_combo.GetWindowText(data.KI_dot);
	data.KI_dot = m_sExePath + data.KI_dot;
	m_ok_ogt_combo.GetWindowText(data.OK_OGT_dot);
	data.OK_OGT_dot= m_sExePath + data.OK_OGT_dot;
	m_kk_combo.GetWindowText(data.KK_dot);
	data.KK_dot = m_sExePath + data.KK_dot;
	m_kp_combo.GetWindowText(data.KP_dot);
	data.KP_dot = m_sExePath + data.KP_dot;

	if(Export.GenTechDocs(m_filename, data))
	{
		CString buf, sExeFullPath;
		buf.Format("   !\n    '%s'.\n    ?", m_filename);
		
		if(AfxMessageBox(buf,MB_YESNO)==IDYES)
		{	
			sExeFullPath= m_sExePath+"\\ReportConstructor.exe";

			buf.Format("\"%s\" \"%s\"",	sExeFullPath, m_filename);
			
			if(aplCreateProcess(0, LPCSTR(buf), false)==-1)
			{
				CString buf; 
				buf.Format("   \n%s",LPCSTR(buf));
				AfxMessageBox(buf);
			}			
		}
	}
	
	CDialog::OnOK();
}

void CExportTDDlg::OnCheckMk() 
{
	UpdateData();
	TestFlag(m_mk_export, &m_mk_combo);
}

void CExportTDDlg::TestFlag(BOOL Enable, CComboBox *combo)
{
	if(Enable)
		combo->EnableWindow();
	else
		combo->EnableWindow(FALSE);
}

void CExportTDDlg::OnCheckOk() 
{
	UpdateData();
	TestFlag(m_ok_export, &m_ok_combo);
	if(m_bIsOGT)
		TestFlag(m_ok_export, &m_ok_ogt_combo);
	if(m_ok_export)
	{
		m_ki_btn.EnableWindow(TRUE);
		TestFlag(m_ki_export, &m_ki_combo);
		m_kp_btn.EnableWindow(TRUE);
		TestFlag(m_kp_export, &m_kp_combo);
	}
	else
	{
		m_ki_btn.EnableWindow(FALSE);
		m_ki_combo.EnableWindow(FALSE);
		m_kp_btn.EnableWindow(FALSE);
		m_kp_combo.EnableWindow(FALSE);
	}
}

void CExportTDDlg::OnCheckVob() 
{
	UpdateData();
	TestFlag(m_vob_export, &m_vob_combo);
}

void CExportTDDlg::OnCheckVo() 
{
	UpdateData();
	TestFlag(m_vo_export, &m_vo_combo);
}

void CExportTDDlg::OnCheckVm() 
{
	UpdateData();
	TestFlag(m_vm_export, &m_vm_combo);
}

void CExportTDDlg::OnCheckTl() 
{
	UpdateData();
	TestFlag(m_tl_export, &m_tl_combo);
}

void CExportTDDlg::OnCheckOs() 
{
	UpdateData();
	TestFlag(m_os_export, &m_os_combo);
}

void CExportTDDlg::OnCheckKi() 
{
	UpdateData();
	TestFlag(m_ki_export, &m_ki_combo);
}

void CExportTDDlg::OnCheckTp() 
{
	UpdateData();
	TestFlag(m_tp_export, &m_tp_combo);
}

void CExportTDDlg::OnCheckKk() 
{
	UpdateData();
	TestFlag(m_kk_export, &m_kk_combo);
}

void CExportTDDlg::OnCheckKp() 
{
	UpdateData();
	TestFlag(m_kp_export, &m_kp_combo);
}
