#include "stdafx.h"
#include "mainfunctions.h"
#include "apl_api.h"
#include "ExportKTSDlg.h"
#include "ReportDict.h"
#include "CommonQuery.h"
#include "ExportSetupDlg.h"
#include "export2dlg.h"
#include "ExportTDDlg.h"
#include "aplExportTechDoc.h"
#include "ExportSpecs.h"
#include "ExportMaterialSpecificationDlg.h"


//************************************************************************
__declspec(dllexport) bool GetFunctionsList(CArray<CaplItemInfo*, CaplItemInfo*> *strArray)
{
	for(int i= 0; i<functionArraySize; i++)
	{
		strArray->Add(&functionArray[i]);
	}
	return true;
}

__declspec (dllexport) char* GetAddInName()
{
	return _PlugInName;
}

__declspec (dllexport) char* GetAddInDescription()
{
	return _PlugInDescr;
}

__declspec (dllexport) bool add_ExportVO(CaplAPI* api, aplExtent& inExtent, bool bUpdateUI)
{
	if(!api || !api->m_data.IsConnected()) return false;
	
	if(!bUpdateUI)
	{
		if(!inExtent.GetSize()) return false;
		CaplInstance* bp_type= NULL;
		api->m_data.GetAttr(inExtent[0], api->m_bp_mgr.a_bp_type, bp_type);
		CString  buf, tmp;
		if(bp_type)
			api->m_data.GetAttr(bp_type, api->m_bp_mgr.a_bp_type_name, buf);
		if(buf.CompareNoCase(" ")) return false;
		
		CString sOrgName, sOrgId, sPrdId, sPrdName, sBPId, sBPName, sBPNum, 
			sAssortName, sZagotShap, sMaterName;
		// .
		api->m_data.GetAttr(inExtent[0], api->m_bp_mgr.a_bp_id, sBPId);
		CExportSetupDlg dlg;
		dlg.m_path = sBPId+"_VO.aplrep";
		dlg.m_dots_file = "ExportKTS_VO";
		dlg.m_title = "  ";
		if(dlg.DoModal()!=IDOK) return false;

		CaplExportTechDoc Export(api);
		Export.inInst = inExtent[0];

		HMODULE hModule;
		char szModuleName[2048];
		
		CString sExeFullPath, sExePath, sOutFileName, sDotPath;
		hModule = GetModuleHandle(NULL);
		if(hModule!=NULL)
		{
			if(GetModuleFileName(hModule, szModuleName, 2048)>0)
			{
				buf= szModuleName;
				sExePath = buf.Left(buf.ReverseFind('\\'));
			}
		}
		
		sExeFullPath= sExePath+"\\ReportConstructor.exe";
		sOutFileName= dlg.m_path;
		sDotPath= sExePath+"\\"+dlg.m_dot;
		if(Export.GenVO(sDotPath, sOutFileName))
		{
			buf.Format(" MK !\n    %s.\n    ?", sOutFileName);
			
			if(AfxMessageBox(buf,MB_YESNO)==IDYES)
			{	
				tmp.Format("\"%s\" \"%s\"",	sExeFullPath, sOutFileName);
				
				if(aplCreateProcess(0, LPCSTR(tmp), false)==-1)
				{
					CString buf; 
					buf.Format("   \n%s",LPCSTR(tmp));
					AfxMessageBox(buf);
				}			
			}
		}
	}
	else
	{
		if(!inExtent.GetSize()) return false;
		if(!api->m_data.IsKindOf(inExtent[0], api->m_bp_mgr.e_bp)/*&&
			!api->m_data.IsKindOf(inExtent[0], api->m_bp_mgr.e_apl_bp_ver)*/) return false;
		
		CaplInstance* bp_type= NULL;
		api->m_data.GetAttr(inExtent[0], api->m_bp_mgr.a_bp_type, bp_type);
		if(!bp_type) return false;
		
		CString  buf;
		api->m_data.GetAttr(bp_type, api->m_bp_mgr.a_bp_type_name, buf);
		if(buf.CompareNoCase(" ")) return false;
		
		return true;
	}

	return true;
}

__declspec (dllexport) bool add_ExportOK(CaplAPI* api, aplExtent& inExtent, bool bUpdateUI)
{
	if(!api || !api->m_data.IsConnected()) return false;
	
	if(!bUpdateUI)
	{
		if(inExtent.GetSize()==0) return false;
		CaplInstance* bp_type= NULL;
		api->m_data.GetAttr(inExtent[0], api->m_bp_mgr.a_bp_type, bp_type);
		CString  buf, tmp;
		if(bp_type)
			api->m_data.GetAttr(bp_type, api->m_bp_mgr.a_bp_type_name, buf);
		
		if(buf.CompareNoCase("")) return false;
		
		CString sOrgName, sOrgId, sPrdId, sPrdName, sBPId, sBPName, sBPNum, 
			sAssortName, sZagotShap, sOperId, sOperName, sStanok, sMaterName, sOperDocuments;
		
		// .
		api->m_data.GetAttr(inExtent[0], api->m_bp_mgr.a_bp_id, sBPId);
		CExportSetupDlg dlg;
		dlg.m_path = sBPId+"_OK.aplrep";
		dlg.m_dots_file = "ExportKTS_OK";
		dlg.m_title = "  ";
		if(dlg.DoModal()!=IDOK) return false;

		CaplExportTechDoc Export(api);
		Export.inInst = inExtent[0];

		HMODULE hModule;
		char szModuleName[2048];
		
		CString sExeFullPath, sExePath, sOutFileName, sDotPath;
		hModule = GetModuleHandle(NULL);
		if(hModule!=NULL)
		{
			if(GetModuleFileName(hModule, szModuleName, 2048)>0)
			{
				buf= szModuleName;
				sExePath = buf.Left(buf.ReverseFind('\\'));
			}
		}
		
		sExeFullPath= sExePath+"\\ReportConstructor.exe";
		sOutFileName= dlg.m_path;
		sDotPath= sExePath+"\\"+dlg.m_dot;
		if(Export.GenOK(sDotPath, sOutFileName))
		{
			buf.Format("  !\n    %s.\n    ?", sOutFileName);
			
			if(AfxMessageBox(buf,MB_YESNO)==IDYES)
			{	
				tmp.Format("\"%s\" \"%s\"",	sExeFullPath, sOutFileName);
				
				if(aplCreateProcess(0, LPCSTR(tmp), false)==-1)
				{
					CString buf; 
					buf.Format("   \n%s",LPCSTR(tmp));
					AfxMessageBox(buf);
				}			
			}
		}		
	}
	else
	{
		if(!inExtent.GetSize()) return false;
		if(!api->m_data.IsKindOf(inExtent[0], api->m_bp_mgr.e_bp)/*&&
			!api->m_data.IsKindOf(inExtent[0], api->m_bp_mgr.e_apl_bp_ver)*/) return false;
		CaplInstance* bp_type= NULL;
		api->m_data.GetAttr(inExtent[0], api->m_bp_mgr.a_bp_type, bp_type);
		if(!bp_type) return false;
		CString  buf;
		api->m_data.GetAttr(bp_type, api->m_bp_mgr.a_bp_type_name, buf);
		if(buf.CompareNoCase("")) return false;
		return true;
	}
	return true;
}

__declspec (dllexport) bool add_ExportMK(CaplAPI* api, aplExtent& inExtent, bool bUpdateUI)
{
	if(!api || !api->m_data.IsConnected()) return false;
	
	if(!bUpdateUI)
	{
		if(!inExtent.GetSize()) return false;
		CaplInstance* bp_type= NULL;
		api->m_data.GetAttr(inExtent[0], api->m_bp_mgr.a_bp_type, bp_type);
		CString  buf, tmp;
		if(bp_type)
			api->m_data.GetAttr(bp_type, api->m_bp_mgr.a_bp_type_name, buf);
		
		if(buf.CompareNoCase(" ")) return false;
		
		CString sOrgName, sOrgId, sPrdId, sPrdName, sBPId, sBPName, sBPNum, 
			sAssortName, sZagotShap, sMaterName;
		
		// .
		api->m_data.GetAttr(inExtent[0], api->m_bp_mgr.a_bp_id, sBPId);
		
		CExportSetupDlg dlg;
		dlg.m_path = sBPId+"_MK.aplrep";
		dlg.m_dots_file = "ExportKTS_MK";
		dlg.m_title = "  ";
		if(dlg.DoModal()!=IDOK) return false;
		CaplExportTechDoc Export(api);
		Export.inInst = inExtent[0];

		HMODULE hModule;
		char szModuleName[2048];
		
		CString sExeFullPath, sExePath, sOutFileName, sDotPath;
		hModule = GetModuleHandle(NULL);
		if(hModule!=NULL)
		{
			if(GetModuleFileName(hModule, szModuleName, 2048)>0)
			{
				buf= szModuleName;
				sExePath = buf.Left(buf.ReverseFind('\\'));
			}
		}
		
		sExeFullPath= sExePath+"\\ReportConstructor.exe";
		sOutFileName= dlg.m_path;
		sDotPath= sExePath+"\\"+dlg.m_dot;
		if(Export.GenMK(sDotPath, sOutFileName))
		{
			buf.Format(" MK !\n    %s.\n    ?", sOutFileName);
			
			if(AfxMessageBox(buf,MB_YESNO)==IDYES)
			{	
				tmp.Format("\"%s\" \"%s\"",	sExeFullPath, sOutFileName);
				
				if(aplCreateProcess(0, LPCSTR(tmp), false)==-1)
				{
					CString buf; 
					buf.Format("   \n%s",LPCSTR(tmp));
					AfxMessageBox(buf);
				}			
			}
		}
	}
	else
	{
		if(!inExtent.GetSize()) return false;
		if(!api->m_data.IsKindOf(inExtent[0], api->m_bp_mgr.e_bp)/*&&
			!api->m_data.IsKindOf(inExtent[0], api->m_bp_mgr.e_apl_bp_ver)*/) return false;
		
		CaplInstance* bp_type= NULL;
		api->m_data.GetAttr(inExtent[0], api->m_bp_mgr.a_bp_type, bp_type);
		if(!bp_type) return false;
		
		CString  buf;
		api->m_data.GetAttr(bp_type, api->m_bp_mgr.a_bp_type_name, buf);
		if(buf.CompareNoCase(" ")) return false;
		
		return true;
	}
	
	return true;
}

//************************************************************************
/*     Add-in*/
__declspec (dllexport) bool add_ExportKTS(CaplAPI* api, aplExtent& inExtent, bool bUpdateUI)
{
	if(!api || !api->m_data.IsConnected()) return false;
	
	if(!bUpdateUI)
	{
		//   
		SetResources();

		CExportKTSDlg dlg;
		dlg.m_api= api;

		if(api->m_data.IsKindOf(inExtent[0], api->m_prd_mgr.e_pdf))
		{
			dlg.m_pdf= inExtent[0];
			dlg.m_bGrpSpec = false;
		}
		else if(api->m_data.IsKindOf(inExtent[0], api->m_prd_mgr.e_prd))
		{
			dlg.m_prd= inExtent[0];
			dlg.m_bGrpSpec = true;
		}

		dlg.DoModal();
		
		//    
		ResetResources();
	}
	else
	{
		if(!inExtent.GetSize()) return false;
		if(!api->m_data.IsKindOf(inExtent[0], api->m_prd_mgr.e_pdf)) return false;
		
		return true;
	}
	
	return true;
}

__declspec (dllexport) bool add_ExportKTS2(CaplAPI* api, aplExtent& inExtent, bool bUpdateUI)
{
	if(!api || !api->m_data.IsConnected()) return false;
	
	if(!bUpdateUI)
	{
		//   
		SetResources();

		CExport2Dlg dlg;
		dlg.m_api= api;
		dlg.m_pdf= inExtent[0];

		dlg.DoModal();
		
		//    
		ResetResources();
	}
	else
	{
		if(!inExtent.GetSize()) return false;
		if(!api->m_data.IsKindOf(inExtent[0], api->m_prd_mgr.e_pdf)) return false;
		
		return true;
	}
	
	return true;
}

//************************************************************************
void SetResources()
{
	if(afxCurrentResourceHandle!=0) 
		_hProcessInstance = AfxGetResourceHandle();
	AfxSetResourceHandle(_hDllInstance);	
}

void ResetResources()
{
	if(_hProcessInstance!=0)
	{
		AfxSetResourceHandle(_hProcessInstance);	
		_hProcessInstance= 0;
	}
}
//************************************************************************
__declspec(dllexport) bool GetQueryList(CArray<CaplQuery, CaplQuery> *querys)
{
	int size = sizeof(m_querys)/sizeof(CaplQuery);
	for(int i=0; i<size;i++) querys->Add(m_querys[i]);
	return true;
}

__declspec( dllexport) bool GetExp2QueryData(CaplQuery* query, CRParamsArray& m_params, UINT mode)
{
	if(mode!=APL_GET_HEADER) return false;
	if(query==NULL) return false;

	query->m_header->AddColumn("prd_id",aplSTRING);
	query->m_header->AddColumn("prd_name",aplSTRING);
	query->m_header->AddColumn("pdf_id",aplSTRING);
	query->m_header->AddColumn("unit_name", aplSTRING);
	query->m_header->AddColumn("d_val", aplREAL);

	return true;
}

__declspec(dllexport) bool GetTDQueryData(CaplQuery* query, CRParamsArray& m_params, UINT mode)
{
	if(mode!=APL_GET_HEADER) return false;
	if(query==NULL) return false;
	
	CaplExportTechDoc::SetHeaderData(query->m_header);
	
	m_params.Add("org_structure");
	m_params.Add("prd_id");
	m_params.Add("prd_name");
	m_params.Add("bp_id");
	m_params.Add("bp_number");
	m_params.Add("bp_litera");
	m_params.Add("bp_name");
	m_params.Add("assort_name");
	m_params.Add("zagot_shap");
	m_params.Add("bp_oper_id");
	m_params.Add("bp_oper_name");
	m_params.Add("oborud");
	m_params.Add("mater_name");
	m_params.Add("prog_id");
	m_params.Add("oper_descr");
	m_params.Add("org_structure_id");
	m_params.Add("oper_document");
	m_params.Add("hardness");
	m_params.Add("tpz");
	m_params.Add("tsht");
	m_params.Add("soj");
	m_params.Add("to");
	m_params.Add("tv");
	
	return true;
}

__declspec(dllexport) bool GetKKQueryData(CaplQuery* query, CRParamsArray& m_params, UINT mode)
{
	if(mode!=APL_GET_HEADER) return false;
	if(query==NULL) return false;
	
	CaplExportTechDoc::SetKKHeaderData(query->m_header);
	
	m_params.Add("org_structure");
	m_params.Add("prd_id");
	m_params.Add("prd_name");
	m_params.Add("bp_id");
	m_params.Add("bp_number");
	m_params.Add("bp_litera");
	m_params.Add("bp_name");
	m_params.Add("assort_name");
	m_params.Add("zagot_shap");
	m_params.Add("bp_oper_id");
	m_params.Add("bp_oper_name");
	m_params.Add("oborud");
	m_params.Add("mater_name");
	m_params.Add("prog_id");
	m_params.Add("oper_descr");
	m_params.Add("org_structure_id");
	m_params.Add("oper_document");
	
	return true;
}

__declspec(dllexport) bool GetKSQueryData(CaplQuery* query, CRParamsArray& m_params, UINT mode)
{
	if(mode!=APL_GET_HEADER) return false;
	if(query==NULL) return false;

	CHeader* header = query->m_header;
	//header->AddColumn("peremennoe",		aplSTRING);
	//header->AddColumn("ispolnenine",	aplSTRING);
	header->AddColumn("format", aplSTRING);
	header->AddColumn("zone", aplSTRING);
	header->AddColumn("pos", aplSTRING);
	header->AddColumn("ref_des", aplSTRING);
	header->AddColumn("id", aplSTRING);
	header->AddColumn("dt_code",		aplSTRING);
	header->AddColumn("sort_num",		aplINTEGER);
	header->AddColumn("name", aplSTRING);
	header->AddColumn("prd_descr", aplSTRING);
	header->AddColumn("count", aplSTRING);
	header->AddColumn("descr", aplSTRING);
	header->AddColumn("mass", aplSTRING);

	header->AddColumn("prd_id", aplSTRING);
	header->AddColumn("prd_name", aplSTRING);
	header->AddColumn("pdf_id", aplSTRING);
	header->AddColumn("shape", aplSTRING);
	header->AddColumn("rel_id", aplSTRING);
	header->AddColumn("rel_name", aplSTRING);

	header->AddColumn("e_type", aplSTRING);
	header->AddColumn("zaimstv", aplSTRING);
	//header->AddColumn("modify", aplSTRING);
	//header->AddColumn("full_pdf_name", aplSTRING);

	header->AddColumn("type", aplSTRING);
	header->AddColumn("stand", aplSTRING);
	header->AddColumn("source", aplSTRING);
	header->AddColumn("ver",aplSTRING);
	
	header->AddColumn("pdf",aplINSTANCE);

	m_params.Add("prd_id");
	m_params.Add("prd_name");
	m_params.Add("org_name");
	m_params.Add("pdf_id");
	
	return true;
}

__declspec (dllexport) bool GetELQuerydata(CaplQuery* query, CRParamsArray& m_params, UINT mode)
{
	if(mode!=APL_GET_HEADER) return false;
	if(query==NULL) return false;

	CHeader* header = query->m_header;
	header->AddColumn("Pos", aplSTRING);
	header->AddColumn("PrdName",	aplSTRING);
	header->AddColumn("PrdId",		aplSTRING);
	header->AddColumn("PdfId",		aplSTRING);
	header->AddColumn("Count",		aplINTEGER);
	header->AddColumn("Comments",	aplSTRING);
	
	m_params.Add("prd_id");
	m_params.Add("prd_name");
	m_params.Add("org_name");
	
	return true;
}

__declspec (dllexport) bool add_ExportVOb(CaplAPI* api, aplExtent& inExtent, bool bUpdateUI)
{
	if(!api || !api->m_data.IsConnected()) return false;
	
	if(!bUpdateUI)
	{
		if(!inExtent.GetSize()) return false;
		CaplInstance* bp_type= NULL;
		api->m_data.GetAttr(inExtent[0], api->m_bp_mgr.a_bp_type, bp_type);
		CString  buf, tmp;
		if(bp_type)
			api->m_data.GetAttr(bp_type, api->m_bp_mgr.a_bp_type_name, buf);
		
		if(buf.CompareNoCase(" ")) return false;
		
		CString sOrgName, sOrgId, sPrdId, sPrdName, sBPId, sBPName, sBPNum, 
			sAssortName, sZagotShap, sMaterName;
		
		// .
		api->m_data.GetAttr(inExtent[0], api->m_bp_mgr.a_bp_id, sBPId);
		CExportSetupDlg dlg;
		dlg.m_path = sBPId+"_VOb.aplrep";
		dlg.m_dots_file = "ExportKTS_VOb";
		dlg.m_title = "  ";
		if(dlg.DoModal()!=IDOK) return false;

		CaplExportTechDoc Export(api);
		Export.inInst = inExtent[0];

		HMODULE hModule;
		char szModuleName[2048];
		
		CString sExeFullPath, sExePath, sOutFileName, sDotPath;
		hModule = GetModuleHandle(NULL);
		if(hModule!=NULL)
		{
			if(GetModuleFileName(hModule, szModuleName, 2048)>0)
			{
				buf= szModuleName;
				sExePath = buf.Left(buf.ReverseFind('\\'));
			}
		}
		
		sExeFullPath= sExePath+"\\ReportConstructor.exe";
		sOutFileName= dlg.m_path;
		sDotPath= sExePath+"\\"+dlg.m_dot;
		if(Export.GenMK(sDotPath, sOutFileName))
		{
			buf.Format(" MK !\n    %s.\n    ?", sOutFileName);
			
			if(AfxMessageBox(buf,MB_YESNO)==IDYES)
			{	
				tmp.Format("\"%s\" \"%s\"",	sExeFullPath, sOutFileName);
				
				if(aplCreateProcess(0, LPCSTR(tmp), false)==-1)
				{
					CString buf; 
					buf.Format("   \n%s",LPCSTR(tmp));
					AfxMessageBox(buf);
				}			
			}
		}
	}
	else
	{
		if(!inExtent.GetSize()) return false;
		if(!api->m_data.IsKindOf(inExtent[0], api->m_bp_mgr.e_bp)/*&&
			!api->m_data.IsKindOf(inExtent[0], api->m_bp_mgr.e_apl_bp_ver)*/) return false;
		
		CaplInstance* bp_type= NULL;
		api->m_data.GetAttr(inExtent[0], api->m_bp_mgr.a_bp_type, bp_type);
		if(!bp_type) return false;
		
		CString  buf;
		api->m_data.GetAttr(bp_type, api->m_bp_mgr.a_bp_type_name, buf);
		if(buf.CompareNoCase(" ")) return false;
		
		return true;
	}

	return true;
}

__declspec (dllexport) bool ExportTechDoc(CaplAPI* api, aplExtent& inExtent, bool bUpdateUI)
{
	if(!api || !api->m_data.IsConnected()) return false;
	
	if(!bUpdateUI)
	{
		if(inExtent.Size==0) return false;
		CExportTDDlg dlg;
		dlg.m_api = api;
		dlg.m_inst = inExtent[0];
		dlg.DoModal();
		return true;
	}
	else
	{
		if(!inExtent.GetSize()) return false;
		if(!api->m_data.IsKindOf(inExtent[0], api->m_bp_mgr.e_bp)/*&&
			!api->m_data.IsKindOf(inExtent[0], api->m_bp_mgr.e_apl_bp_ver)*/) return false;
		
		CaplInstance* bp_type= NULL;
		api->m_data.GetAttr(inExtent[0], api->m_bp_mgr.a_bp_type, bp_type);
		if(!bp_type) return false;
		
		CString  buf;
		api->m_data.GetAttr(bp_type, api->m_bp_mgr.a_bp_type_name, buf);
		if(buf.CompareNoCase(" ")) return false;
		
		return true;
	}

	return true;
}



CString GetExePath()
{
	CString sExePath;
	HMODULE hModule;
	char szModuleName[2048];
	
	hModule = GetModuleHandle(NULL);
	if(hModule!=NULL)
	{
		if(GetModuleFileName(hModule, szModuleName, 2048)>0)
		{
			CString buf;
			buf= szModuleName;
			sExePath = buf.Left(buf.ReverseFind('\\')+1);
		}
	}
	return sExePath;
}

__declspec (dllexport) bool GenerateSpecsReport(CaplAPI* api, aplExtent &inExtent, LPCTSTR dot, LPCTSTR report, CStringArray& NamesArr)
{
	if(api==NULL) return false;
	if(!api->m_data.IsConnected()) return false;
	if(inExtent.Size!=1) return false;
	if(!api->m_data.IsKindOf(inExtent[0], api->m_prd_mgr.e_prd)) return false;
	if(NamesArr.GetSize()!=3) return false;
	CExportSpecs specs;
	specs.m_api = api;
	specs.m_sDot = dot;
	specs.m_sReport = report;
	specs.m_prd = inExtent[0];
	specs.m_sDocDescr = NamesArr[0];
	return specs.DoExport();
}


__declspec (dllexport) bool ExportMaterialSpecification(CaplAPI* api, aplExtent& inExtent, bool bUpdateUI)
{
	if(!api || !api->m_data.IsConnected()) return false;
	
	if(!bUpdateUI)
	{
		if(!inExtent.GetSize()) return false;
		if(!api->m_data.IsKindOf(inExtent[0], api->m_prd_mgr.e_apl_pdf)) return false;
		
		// .
		CExportMaterialSpecificationDlg dlg(api);
		dlg.m_inst = inExtent[0];
		if(dlg.DoModal()!=IDOK) return false;
	}
	else
	{
		if(!inExtent.GetSize()) return false;
		if(!api->m_data.IsKindOf(inExtent[0], api->m_prd_mgr.e_apl_pdf)) return false;
				
		return true;
	}
	return false;
}

__declspec (dllexport) bool GetMaterialSpecificationQueryData(CaplQuery* query, CRParamsArray& m_params, UINT mode)
{
	if(mode!=APL_GET_HEADER) return false;
	if(query==NULL) return false;

	CaplExportTechDoc::SetMaterialSpecificationHeaderData(query->m_header);

	m_params.Add("prd_id");
	m_params.Add("prd_name");
	m_params.Add("prd_code");
	m_params.Add("prd_ass_code");
	m_params.Add("org_name");
	m_params.Add("org_id");
	
	return true;
}
