// aplExportTechDoc.cpp: implementation of the CaplExportTechDoc class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "aplExportTechDoc.h"
#include "ReportDict.h"
#include "CommonQuery.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#define IsWindow(wnd) wnd==0 ? false : ::IsWindow(wnd->m_hWnd) ? true : false

CaplExportTechDoc::CaplExportTechDoc(CaplAPI* api)
{
	ASSERT(api);
	m_api = api;
	m_inst = NULL;
	m_pdf = NULL;
	m_prd = NULL;
	inInst = NULL;
	m_IsFindedPrdAndMater = false;
	bGenIfOK = FALSE;
	m_edit = NULL;
	m_progress = NULL;
	m_LastError = 0;
	bIsOGT = FALSE;
	CaplInstance* CurPers = m_api->m_appr_mgr.GetCurrentPerson();
	if(CurPers)
	{
		//    .
		CString buf;
		CaplInstance* org;
		aplExtent rels;
		CaplLoadData ld(&m_api->m_data, DEF_SOURCE);
		ld.AddQuery('b', CurPers->GetId(), m_api->m_appr_mgr.e_pers_org, m_api->m_appr_mgr.a_po_the_pers, true, true);
		ld.LoadEx(true, &rels);
		for(int i=0; i<rels.Size; i++)
		{
			if(rels[i]->GetAccessmode()>aplRO) continue;
			if(!m_api->m_data.IsKindOf(rels[i], m_api->m_appr_mgr.e_pers_org)) continue;
			m_api->m_data.GetAttr(rels[i], m_api->m_appr_mgr.a_po_the_org, org);
			if(org==NULL) continue;
			if(org->GetAccessmode()>aplRO) continue;
			m_api->m_data.GetAttr(org, m_api->m_appr_mgr.a_org_id, buf);
			if(buf.CompareNoCase("")==0)
				bIsOGT = TRUE;
		}
	}
}

CaplExportTechDoc::~CaplExportTechDoc()
{

}

// 
CHeader* CaplExportTechDoc::SetHeaderData(CHeader* hd)
{
	CHeader* header = hd;
	if(hd==0)
		header = new CHeader(NULL);

	header->AddColumn("hardness", aplSTRING);
	header->AddColumn("to", aplREAL);
	header->AddColumn("tv", aplREAL);
	header->AddColumn("tpz", aplREAL);
	header->AddColumn("tsht", aplREAL);
	header->AddColumn("soj", aplSTRING);
	header->AddColumn("rm", aplSTRING);

	header->AddColumn("BP(OPER)_id",aplSTRING);
	header->AddColumn("BP(OPER)_id_num",aplINTEGER);
	header->AddColumn("BP(OPER)_name",aplSTRING);
	header->AddColumn("OPER_CHECH", aplSTRING);
	header->AddColumn("OPER_UCHASTOK", aplSTRING);
	header->AddColumn("OPER_MATERIALS", aplSTRING);
	header->AddColumn("BP(OPER)_docId", aplSTRING);
	
	header->AddColumn("RES_BP(OPER)_id",aplSTRING);
	header->AddColumn("RES_BP(OPER)_name", aplSTRING);
	header->AddColumn("RES_BP(OPER)_ver", aplSTRING);
	header->AddColumn("RazRab", aplSTRING);
	
	header->AddColumn("BP(PER)_id", aplSTRING);
	header->AddColumn("BP(PER)_id_num", aplINTEGER);
	header->AddColumn("BP(PER)_dscr", aplSTRING);
	
	header->AddColumn("RES_BP(PER)_pos", aplSTRING);
	header->AddColumn("RES_BP(PER)_id", aplSTRING);
	header->AddColumn("RES_BP(PER)_name", aplSTRING);
	header->AddColumn("RES_BP(PER)_ver", aplSTRING);
	header->AddColumn("RES_BP(PER)_count", aplREAL);
	header->AddColumn("RES_BP(PER)_unit", aplSTRING);
	header->AddColumn("RES_BP(PER)_docId", aplSTRING);
	header->AddColumn("RES_BP(PER)_type", aplSTRING);
	header->AddColumn("RES_BP(PER)_typeNum", aplINTEGER);
	
	header->AddColumn("Machine_List", aplSTRING);

	header->AddColumn("MK_OK", aplSTRING);
	header->AddColumn("TP", aplSTRING);
	//  
	header->AddColumn("RES_BP(OPER)_T", aplREAL);
	header->AddColumn("RES_BP(OPER)_T", aplREAL);
	
	header->AddColumn("BP(PER)_L", aplREAL);
	header->AddColumn("BP(PER)_t", aplREAL);
	header->AddColumn("BP(PER)_i", aplREAL);
	header->AddColumn("BP(PER)_s", aplREAL);
	header->AddColumn("BP(PER)_n", aplREAL);
	header->AddColumn("BP(PER)_v", aplREAL);
	
	header->AddColumn("V_PK", aplSTRING);

	header->AddColumn("diametr", aplREAL);
	header->AddColumn("dlina", aplREAL);
	header->AddColumn("glubina", aplREAL);
	header->AddColumn("perehodu", aplREAL);
	header->AddColumn("podacha", aplREAL);
	header->AddColumn("shpindel", aplREAL);
	header->AddColumn("skorost", aplREAL);
	header->AddColumn("obiem", aplSTRING);
	header->AddColumn("pi", aplSTRING);
	header->AddColumn("totv", aplREAL);

	return header;
}

CHeader* CaplExportTechDoc::SetKKHeaderData(CHeader* hd)
{
	CHeader* header = hd;
	if(hd==0)
		header = new CHeader(NULL);
	
	header->AddColumn("pos", aplSTRING);
	header->AddColumn("id", aplSTRING);
	header->AddColumn("name", aplSTRING);
	header->AddColumn("count", aplSTRING);
	header->AddColumn("descr", aplSTRING);
	
	header->AddColumn("type", aplSTRING);
	header->AddColumn("stand", aplSTRING);
	header->AddColumn("source", aplSTRING);
	header->AddColumn("ver",aplSTRING);
	
	return header;
}


int CaplExportTechDoc::GetTypeNum(CaplInstance* inst, CString &sPerType)
{
	if(m_api==0 || inst==0) return -1;
	
	CaplInstance* res_type;
	int iPerTypeNum=-1;
	sPerType = "";

	m_api->m_data.GetAttr(inst, m_api->m_bp_mgr.a_bp_res_type, res_type);
	if(res_type)
	{
		m_api->m_data.GetAttr(res_type, m_api->m_bp_mgr.a_bp_res_type_name, sPerType);
		if(sPerType.CompareNoCase("")==0)
		{
			sPerType = "";iPerTypeNum = 1;
		}
		else if (sPerType.CompareNoCase(" ")==0)
		{
			sPerType = "";iPerTypeNum = 3;
		}
		else if (sPerType.CompareNoCase(" ")==0)
		{
			sPerType = "";iPerTypeNum = 2;
		}
		else if (sPerType.CompareNoCase(" ")==0)
		{
			sPerType = "";iPerTypeNum = 4;
		}
		else iPerTypeNum = 5;
	}
	return iPerTypeNum;
}

//  
bool CaplExportTechDoc::GetResourceName(CaplInstance* inst_item, CString &name, CString &id, CString &ver)
{
	id = name = ver = "";
	if(m_api==0) return false;
	if(inst_item==0) return false;
	if(m_api->m_data.IsKindOf(inst_item, m_api->m_prd_mgr.e_pdf))
	{
		CaplInstance* inst_prd= NULL;
		m_api->m_data.GetAttr(inst_item, m_api->m_prd_mgr.a_pdf_id, ver);
		m_api->m_data.GetAttr(inst_item, m_api->m_prd_mgr.a_pdf_prd, inst_prd);
		if(inst_prd)
		{
			m_api->m_data.GetAttr(inst_prd, m_api->m_prd_mgr.a_prd_id, id);
			m_api->m_data.GetAttr(inst_prd, m_api->m_prd_mgr.a_prd_name, name);
		}
	}
	else if(m_api->m_data.IsKindOf(inst_item, m_api->m_prd_inst_mgr.e_prd_inst))
	{
		m_api->m_data.GetAttr(inst_item, m_api->m_prd_inst_mgr.a_prd_inst_sn, ver);
		
		CaplInstance* inst_pdf= NULL;
		m_api->m_data.GetAttr(inst_item, m_api->m_prd_inst_mgr.a_prd_inst_pdf, inst_pdf);
		CaplInstance* inst_prd= NULL;
		m_api->m_data.GetAttr(inst_pdf, m_api->m_prd_mgr.a_pdf_prd, inst_prd);
		if(inst_prd)
		{
			m_api->m_data.GetAttr(inst_prd, m_api->m_prd_mgr.a_prd_id, id);
			m_api->m_data.GetAttr(inst_prd, m_api->m_prd_mgr.a_prd_name, name);
		}
	}
	else if(m_api->m_data.IsKindOf(inst_item, m_api->m_prd_mgr.e_prd))
	{
		m_api->m_data.GetAttr(inst_item, m_api->m_prd_mgr.a_prd_id, id);
		m_api->m_data.GetAttr(inst_item, m_api->m_prd_mgr.a_prd_name, name);
	}
	else return false;

	return true;
}

//   
//************************************************************************
bool CaplExportTechDoc::Perehod(CaplReportMgr* mgr, CaplInstance* oper, CaplAPI* api, CString sBPOperId, 
								int iBPOperIdNum, CString sBPOperName, CString sBPOperResId, CString sBPOperResName,
								CString sBPOperResVer, CString sMK, CString sTP, CString sOperDocId, CString sZone, 
								CString sMaterial, CString sRR, CString sZech, CString sOborudList, CString sHardness, 
								CString sTo, CString sTv, CString sTpz, CString sTsht, CString sSoj, CString sRm, CString RType)
{
	if(mgr==NULL || m_api==0 || oper==NULL) return false;
	CTableRow* row = NULL;
	aplExtent bp_pers, bp_per_res;
	bp_pers.Clear();
	m_api->m_data.GetAttr(oper, m_api->m_bp_mgr.a_bp_elements, bp_pers);
	m_api->m_bp_mgr.LoadBPInfo(bp_pers);
	CString sBPPerId= "", sBPPerDscr= "", sBPPerResId= "", sBPPerResName= "", sBPPerResVer= "",
		sPerDocId = "",	sPerType = "", sResPerUnit, sVPK="", sResBPperPos;
	int iPerTypeNum = -1, iBPRepIdNum=-1, per_num = 1;
	double dRR_Tsht=0, dRR_Tpz=0, dRR_L=0, dRR_t=0, dRR_i=0, dRR_s=0, dRR_n=0, dRR_v=0, dResPerCount=0;
	int ObSvedNum = 1, STP_num =1 ;
	CString tmpBP_Oper_Res_id = sBPOperResId;

	CString sObiem, sPI;
	CString sDiametr, sDlina, sGlubina, sPerehodu, sPodacha, sShpindel, sSkorost, sTotv;
	
	aplExtent PerCharExt, ResCharacts, gr;
	CaplInstance* VPK = m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* ResPos = m_api->m_charact_mgr.GetCharacteristicById("_");

	CaplInstance *diametr_char=m_api->m_charact_mgr.GetCharacteristicById("D  B");
	CaplInstance *dlina_char=m_api->m_charact_mgr.GetCharacteristicById("l");
	CaplInstance *glubina_char=m_api->m_charact_mgr.GetCharacteristicById("t");
	CaplInstance *prohodu_char=m_api->m_charact_mgr.GetCharacteristicById("i");
	CaplInstance *podacha_char=m_api->m_charact_mgr.GetCharacteristicById("s");
	CaplInstance *shpindel_char=m_api->m_charact_mgr.GetCharacteristicById("n");
	CaplInstance *skorost_char=m_api->m_charact_mgr.GetCharacteristicById("v");
	CaplInstance *obiem_char=m_api->m_charact_mgr.GetCharacteristicById("  ");
	CaplInstance *pi_char=m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance *totv_char=m_api->m_charact_mgr.GetCharacteristicById("/");
	
	CaplInstance* bp_per_type = m_api->m_bp_mgr.GetBpTypeByName("");
	CaplInstance* bp_os_type = m_api->m_bp_mgr.GetBpTypeByName(" ");
	CaplInstance* bp_stp_type = m_api->m_bp_mgr.GetBpTypeByName("  ");
	m_api->m_charact_mgr.FindAssociatedCharacteristic(bp_pers, PerCharExt, gr);

 	for(int j= 0; j<bp_pers.GetSize(); j++)
	{
		sBPPerId= ""; sBPPerDscr= ""; sBPPerResId= ""; sBPPerResName= ""; sBPPerResVer= "";
		sPerDocId = "";	sPerType = sResPerUnit = "";sResBPperPos.Empty();
		iPerTypeNum = -1; dResPerCount=0;
		iBPRepIdNum = -1;
		sBPOperResId = tmpBP_Oper_Res_id;
		sVPK.Empty();
		
		CaplInstance* bp_type;
		CString type_name="";
		m_api->m_data.GetAttr(bp_pers[j], m_api->m_bp_mgr.a_bp_type, bp_type);
		if(bp_type==NULL) continue;
		m_api->m_data.GetAttr(bp_type, m_api->m_bp_mgr.a_bp_type_name, type_name);
		GetCharactValue(bp_pers[j], VPK, &PerCharExt, sVPK, true);

		//  
		GetCharactValue(bp_pers[j], diametr_char, &PerCharExt, sDiametr, true);
		GetCharactValue(bp_pers[j], dlina_char, &PerCharExt, sDlina, true);
		GetCharactValue(bp_pers[j], glubina_char, &PerCharExt, sGlubina, true);
		GetCharactValue(bp_pers[j], prohodu_char, &PerCharExt, sPerehodu, true);
		GetCharactValue(bp_pers[j], podacha_char, &PerCharExt, sPodacha, true);
		GetCharactValue(bp_pers[j], shpindel_char, &PerCharExt, sShpindel, true);
		GetCharactValue(bp_pers[j], skorost_char, &PerCharExt, sSkorost, true);
		GetCharactValue(bp_pers[j], obiem_char, &PerCharExt, sObiem, true);
		GetCharactValue(bp_pers[j], pi_char, &PerCharExt, sPI, true);
		GetCharactValue(bp_pers[j], totv_char, &PerCharExt, sTotv, true);

		if(bp_type!=bp_per_type)
		{
			if(	type_name.CompareNoCase(" ")!=0 &&
				type_name.CompareNoCase("  ")!=0)
				continue;
			//       ,    
			if(RType=="oper")
			{
				m_api->m_data.GetAttr(bp_pers[j], m_api->m_bp_mgr.a_bp_descr, sBPPerDscr);
				if(bp_type!=bp_os_type)
				{
					sBPPerId.Format("%d", ObSvedNum);
					iBPRepIdNum = ObSvedNum;
					ObSvedNum++;
				}
				else
				{
					sBPPerId.Format("%d", STP_num);
					iBPRepIdNum = STP_num;
					STP_num++;
				}
				sBPOperResId = type_name;
				
				//  
				aplExtent docs, rel_docs;
				m_api->m_doc_mgr.FindAssociatedDocuments(bp_pers[j],docs, rel_docs);
				m_api->m_doc_mgr.LoadDocInfo(docs);
				for(int d=0; d<docs.Size;d++)
				{
					CString tmp_id;
					m_api->m_data.GetAttr(docs[d],m_api->m_doc_mgr.a_doc_id,tmp_id);
					if(!sPerDocId.IsEmpty() && !tmp_id.IsEmpty())
						sPerDocId+=", ";
					sPerDocId+=tmp_id;
				}
				if(!sPerDocId.IsEmpty())
					sBPPerDscr+=sPerDocId;
				
				//  ...
				bp_per_res.Clear();
				m_api->m_bp_mgr.LoadAllBPResources(bp_pers[j], bp_per_res);
				m_api->m_charact_mgr.FindAssociatedCharacteristic(bp_per_res, ResCharacts, gr);

 				CString sHardness, sSoj;
 				CString sTo, sTv, sTpz, sTsht;

				for(int k= 0; k<bp_per_res.GetSize(); k++)
				{
					sBPPerResId= ""; sBPPerResName= ""; sBPPerResVer= "";
					sPerType = ""; iPerTypeNum = -1; dResPerCount=0;
					sResBPperPos.Empty();
					
					CaplInstance* inst_item= NULL;
					CaplInstance* res_type= NULL;
					CaplInstance* unit = NULL;
					m_api->m_data.GetAttr(bp_per_res[k], m_api->m_bp_mgr.a_bp_res_object, inst_item);
					m_api->m_data.GetAttr(bp_per_res[k], m_api->m_bp_mgr.a_bp_res_val, dResPerCount);
					m_api->m_data.GetAttr(bp_per_res[k], m_api->m_bp_mgr.a_bp_res_unit, unit);
					if(unit)
						m_api->m_data.GetAttr(unit, m_api->m_charact_mgr.a_apl_unit_name, sResPerUnit);

					
					if(!GetResourceName(inst_item, sBPPerResName, sBPPerResId, sBPPerResVer))
						continue;//    ...
					// .   ..
					iPerTypeNum = GetTypeNum(bp_per_res[k], sPerType);
					GetCharactValue(bp_per_res[k], ResPos, &ResCharacts, sResBPperPos, true);

					//  
					//GetCharactValue()

					ADD_ROW
					mgr->m_data_source.AddRow(row);					
				}
				if(!bp_per_res.GetSize())
				{
					ADD_ROW
					mgr->m_data_source.AddRow(row);				
				}
			}
			continue;
		}
		
		m_api->m_data.GetAttr(bp_pers[j], m_api->m_bp_mgr.a_bp_id, sBPPerId);
		m_api->m_data.GetAttr(bp_pers[j], m_api->m_bp_mgr.a_bp_descr, sBPPerDscr);
		iBPRepIdNum= per_num;sBPPerId.Format("%i", iBPRepIdNum);
		per_num++;
		
		//    
		aplExtent docs, rel_docs;
		m_api->m_doc_mgr.FindAssociatedDocuments(bp_pers[j],docs, rel_docs);
		m_api->m_doc_mgr.LoadDocInfo(docs);
		for(int d=0; d<docs.Size;d++)
		{
			CaplInstance* doc_type=NULL;
			m_api->m_data.GetAttr(docs[d],m_api->m_doc_mgr.a_doc_kind,doc_type);
			if(doc_type)
			{
				CString type_name;
				m_api->m_data.GetAttr(docs[d],m_api->m_doc_mgr.a_doc_id,sPerDocId);
				sBPPerDscr+=" "+sPerDocId;
				break;							
			}
		}
		bp_per_res.Clear();
		m_api->m_bp_mgr.LoadAllBPResources(bp_pers[j], bp_per_res);
		m_api->m_charact_mgr.FindAssociatedCharacteristic(bp_per_res, ResCharacts, gr);		

		for(int k= 0; k<bp_per_res.GetSize(); k++)
		{
			sBPPerResId= ""; sBPPerResName= ""; sBPPerResVer= "";
			sPerType = ""; iPerTypeNum = -1; dResPerCount=0;
			
			CaplInstance* inst_item= NULL;
			CaplInstance* res_type= NULL;
			CaplInstance* unit = NULL;
			m_api->m_data.GetAttr(bp_per_res[k], m_api->m_bp_mgr.a_bp_res_object, inst_item);
			m_api->m_data.GetAttr(bp_per_res[k], m_api->m_bp_mgr.a_bp_res_val, dResPerCount);
			m_api->m_data.GetAttr(bp_per_res[k], m_api->m_bp_mgr.a_bp_res_unit, unit);
			if(unit)
				m_api->m_data.GetAttr(unit, m_api->m_charact_mgr.a_apl_unit_name, sResPerUnit);
			
			if(!GetResourceName(inst_item, sBPPerResName, sBPPerResId, sBPPerResVer))
				continue;//    ...
			// .   ..
			GetCharactValue(bp_per_res[k], ResPos, &ResCharacts, sResBPperPos, true);
			m_api->m_data.GetAttr(bp_per_res[k], m_api->m_bp_mgr.a_bp_res_type, res_type);
			if(res_type)
			{
				m_api->m_data.GetAttr(res_type, m_api->m_bp_mgr.a_bp_res_type_name, sPerType);
				if(sPerType.CompareNoCase("")==0)
				{
					sPerType = "";iPerTypeNum = 1;
				}
				else if (sPerType.CompareNoCase(" ")==0)
				{
					sPerType = "";iPerTypeNum = 3;
				}
				else if (sPerType.CompareNoCase(" ")==0)
				{
					sPerType = "";iPerTypeNum = 2;
				}
				else if (sPerType.CompareNoCase(" ")==0)
				{
					sPerType = "";iPerTypeNum = 4;
				} else iPerTypeNum=5;
			}
			ADD_ROW
			mgr->m_data_source.AddRow(row);					
		}
		if(!bp_per_res.GetSize())
		{
			ADD_ROW
			mgr->m_data_source.AddRow(row);				
		}
	}
	if(!bp_pers.GetSize())
	{
		ADD_ROW
		mgr->m_data_source.AddRow(row);
	}

	return true;
}

bool CaplExportTechDoc::FindPrd_and_Mater(	CaplInstance* bp, CaplAPI* m_api, CString &sPrdId, CString &sPrdName, 
						CString &sAssortName, CString &sZagotShap, CString &sMaterName)
{
	if(m_api==0 || bp==NULL) return false;
	if(m_IsFindedPrdAndMater)
	{
		sPrdId = m_sPrdId;
		sPrdName = m_sPrdName;
		sAssortName = m_sAssortName;
		sZagotShap = m_sZagotShap;
		sMaterName = m_sMaterName;
		return true;
	}
	
	m_IsFindedPrdAndMater = true;

	aplExtent ext_bp_ref;
	CaplInstance* pdf_mater= NULL;	//   
	CaplInstance* mf_rel= NULL;		// pdf & pdf_mater
	CaplInstance* zagotov = NULL;	//
	CaplInstance* rel = NULL;
	
	CaplLoadData ld(&m_api->m_data,DEF_SOURCE);
	
	int i2=	ld.AddQuery('b', bp->GetId(), m_api->m_bp_mgr.e_bp_ref, m_api->m_bp_mgr.a_bp_ref_process, true, true);
/*	ld.AddQuery('d', i2, 0, m_api->m_bp_mgr.a_bp_ref_process, true);
	ld.AddQuery('d', i2, 0, m_api->m_bp_mgr.a_bp_ref_frames_of_reference, true);
	ld.AddQuery('d', i2, 0, m_api->m_bp_mgr.a_bp_ref_item, true);
	ld.AddQuery('d', i2, 0, m_api->m_bp_mgr.a_bp_ref_zagotov, true);*/
	ld.LoadEx(true, &ext_bp_ref);		
	
	for(int i= 0; i<ext_bp_ref.GetSize(); i++)
	{
		CaplInstance* ref= NULL;
		if(ext_bp_ref[i] && m_api->m_data.IsKindOf(ext_bp_ref[i], m_api->m_bp_mgr.e_bp_ref))
		{
			m_api->m_data.GetAttr(ext_bp_ref[i], m_api->m_bp_mgr.a_bp_ref_item, ref);
			m_api->m_data.GetAttr(ext_bp_ref[i], m_api->m_bp_mgr.a_bp_ref_zagotov, mf_rel);
			if(ref && mf_rel)
			{
				if(m_api->m_data.IsKindOf(ref, m_api->m_prd_mgr.e_pdf))
				{
					rel = ext_bp_ref[i];
					m_pdf = ref;
					break;
				}
			}
			rel = ext_bp_ref[i];
			m_pdf = ref;
		}
	}
	if(rel==NULL)
	{
		//       - 
		return false;
	}

	m_api->m_prd_mgr.LoadPrdInfo(m_pdf);
	m_api->m_data.GetAttr(m_pdf, m_api->m_prd_mgr.a_pdf_prd, m_prd);
	if(m_prd)
	{
		CString buf;
		m_api->m_data.GetAttr(m_pdf, m_api->m_prd_mgr.a_pdf_id, buf);
		m_api->m_data.GetAttr(m_prd, m_api->m_prd_mgr.a_prd_id, sPrdId);
		m_api->m_data.GetAttr(m_prd, m_api->m_prd_mgr.a_prd_name, sPrdName);
		if(!buf.IsEmpty())
			sPrdId+= " - "+buf;
	}
	CaplInstance* inst;
	// ,     
	aplExtent rels, ext;
	m_api->m_prd_mgr.LoadAllZagotov(m_pdf, rels, ext);
	CaplInstance *assort=NULL, *shape=NULL;
	if(mf_rel)
	{
		m_api->m_data.GetAttr(mf_rel, m_api->m_prd_mgr.a_pdr_id, sZagotShap);
		m_api->m_data.GetAttr(mf_rel, m_api->m_prd_mgr.a_make_from_assortment, assort);
		m_api->m_data.GetAttr(mf_rel, m_api->m_prd_mgr.a_pdr_r_ted, inst);
		if(assort)
		{
			m_api->m_data.GetAttr(assort, m_api->m_prd_mgr.a_assortment_name, sAssortName);
			m_api->m_data.GetAttr(assort, m_api->m_prd_mgr.a_assortment_shape, shape);
			if(shape)
				m_api->m_data.GetAttr(shape, m_api->m_prd_mgr.a_assortment_shape_id, sAssortName);
		}
		m_api->m_prd_mgr.LoadPrdInfo(inst);
		if(inst)
		{
			CString id, name, ver;
			CaplInstance* prd;
			m_api->m_data.GetAttr(inst, m_api->m_prd_mgr.a_pdf_id, ver);
			m_api->m_data.GetAttr(inst, m_api->m_prd_mgr.a_pdf_prd, prd);
	//		m_api->m_prd_mgr.LoadPrdInfo(prd);
			if(prd)
			{
				m_api->m_data.GetAttr(prd, m_api->m_prd_mgr.a_prd_id, id);
				m_api->m_data.GetAttr(prd, m_api->m_prd_mgr.a_prd_name, name);
			}
			sMaterName = name+" "+id+" "+ver;
		}
	}
	m_sPrdId = sPrdId;
	m_sPrdName = sPrdName;
	m_sAssortName = sAssortName;
	m_sZagotShap = sZagotShap;
	m_sMaterName = sMaterName;

	//
	CaplInstance* Litera = NULL, *LiteraVal;
	aplExtent characts, gr;

	Litera = m_api->m_charact_mgr.GetCharacteristicById("");
	if(Litera==NULL) return true;

	LiteraVal = m_api->m_charact_mgr.FindCharacteristic(bp, Litera, NULL);
	if(LiteraVal)
	{
		if(m_api->m_data.IsKindOf(LiteraVal, m_api->m_charact_mgr.e_descr_value))
			m_api->m_data.GetAttr(LiteraVal, m_api->m_charact_mgr.a_apl_charact_val_descr_val, m_sBpLit);
		else if(m_api->m_data.IsKindOf(LiteraVal, m_api->m_charact_mgr.e_enum_value))
			m_api->m_data.GetAttr(LiteraVal, m_api->m_charact_mgr.a_apl_charact_val_enum_val, m_sBpLit);
	}

	return true;
}

bool CaplExportTechDoc::GenMK(LPCTSTR dot_file, LPCTSTR report_file)
{
	if(inInst==0 || m_api==0) return false;
	CaplInstance* bp_type= NULL;
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_type, bp_type);
	CString  buf, tmp;
	if(bp_type)
		m_api->m_data.GetAttr(bp_type, m_api->m_bp_mgr.a_bp_type_name, buf);
	
	if(buf.CompareNoCase(" ")) return false;

	m_inst = inInst;
	
	CString sOrgName, sOrgId, sPrdId, sPrdName, sBPId, sBPName, sBPNum, 
		sAssortName, sZagotShap, sMaterName;
	
	// .
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_id, sBPId);
	
	/************************************************************************/
	/*                                              */
	/************************************************************************/
	aplExtent all_orgs, all_org_rels;		
	m_api->m_appr_mgr.GetAllSubOrganization(NULL,all_orgs);
	if(all_orgs.Size>0)
	{
		m_api->m_data.GetAttr(all_orgs[0], m_api->m_appr_mgr.a_org_id, sOrgId);
		m_api->m_data.GetAttr(all_orgs[0], m_api->m_appr_mgr.a_org_name, sOrgName);
	}
	int i = 0;
	int j = 0;
	
	/************************************************************************/
	/*                                                */
	/************************************************************************/		
	
	FindPrd_and_Mater(inInst, m_api, sPrdId, sPrdName, sAssortName, sZagotShap, sMaterName);
	
	/************************************************************************/
	/*  -                                             */
	/************************************************************************/
	
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_id, sBPId);
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_name, sBPName);
	CaplInstance* bpVer= NULL;
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_act, bpVer);
	if(bpVer)
		m_api->m_data.GetAttr(bpVer, m_api->m_bp_mgr.a_bp_ver_num, sBPNum);	
	
	CRParamsArray RParams;
	RParams.Add("org_structure", sOrgName);
	RParams.Add("org_structure_id", sOrgId);
	RParams.Add("prd_id", sPrdId);
	RParams.Add("prd_name", sPrdName);
	RParams.Add("bp_id", sBPId);
	RParams.Add("bp_number", sBPNum);
	RParams.Add("bp_litera", m_sBpLit);
	RParams.Add("assort_name", sAssortName);
	RParams.Add("zagot_shap", sZagotShap);
	RParams.Add("prog_id","");
	RParams.Add("oper_descr","");
	RParams.Add("bp_name",sBPName);
	RParams.Add("mater_name", sMaterName);
	
	
	CaplReportMgr dict; dict.Init();
	CDataSource *data_source = &dict.m_data_source;
	dict.m_data_source.SetHeader(SetHeaderData());
	/************************************************************************/
	/*                                                      */
	/************************************************************************/
	aplExtent bp_opers, bp_oper_res, bp_pers, bp_per_res;
	
	INITIAL_PARAMS//   
		
		CTableRow* row= NULL;
	//		m_api->m_bp_mgr.GetAllSubBP(inExtent[0], bp_opers);
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_elements, bp_opers);
	m_api->m_bp_mgr.LoadBPInfo(bp_opers);
	
	CaplInstance* mk_ok_char= m_api->m_charact_mgr.GetCharacteristicById("_");
	CaplInstance* tp_char= m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* zeh_char= m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* rr_char= m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* zone_char = m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* hardness_char=m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* to_char=m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* tv_char=m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* tpz_char=m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* tsht_char=m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* soj_char=m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* rm_char=m_api->m_charact_mgr.GetCharacteristicById("");
	
	aplExtent chars_ext, chars_group_ext;
	m_api->m_charact_mgr.FindAssociatedCharacteristic(bp_opers, chars_ext, chars_group_ext);
	int OS_num = 1, STP_num = 1;
	int oper_num = 0;
	
	if(IsWindow(m_progress))
	{
		m_progress->SetPos(0);
		m_progress->SetRange32(0, bp_opers.GetSize());
		m_progress->SetStep(1);
	}	

	for(i= 0; i<bp_opers.GetSize(); i++)
	{
		if(IsWindow(m_progress))
			m_progress->StepIt();

		sBPOperName= ""; sBPOperId= ""; sBPOperResId= ""; sBPOperResName= ""; sBPOperResVer= "";
		sBPPerId= ""; sBPPerDscr= ""; sBPPerResId= ""; sBPPerResName= "";
		sBPPerResVer=sOborudList= "";
		sMK= ""; sTP= ""; iBPOperIdNum= -1; iBPRepIdNum= -1;
		sOperDocId= ""; sPerDocId = ""; sPerType="", sZech = sZone = "", sRR = "";
		iPerTypeNum = -1;
		sMaterial="";
		
		m_api->m_data.GetAttr(bp_opers[i], m_api->m_bp_mgr.a_bp_type, bp_type);
		if(!bp_type) continue;
		m_api->m_data.GetAttr(bp_type, m_api->m_bp_mgr.a_bp_type_name, buf);
		if(buf.CompareNoCase(""))
		{
			if(	buf.CompareNoCase(" ")==0 || 
				buf.CompareNoCase("  ")==0)//      
			{
				//   
				aplExtent docs, rels;
				m_api->m_doc_mgr.FindAssociatedDocuments(bp_opers[i], docs, rels);
				m_api->m_doc_mgr.LoadDocInfo(docs);
				//     
				CString doc_id;
				for(int d=0; d<docs.Size; d++)
				{
					m_api->m_data.GetAttr(docs[d], m_api->m_doc_mgr.a_doc_id, doc_id);
					if(sOperDocId.IsEmpty())
						sOperDocId = doc_id;
					else if(!doc_id.IsEmpty())
						sOperDocId = sOperDocId+", "+doc_id;
				}
				m_api->m_data.GetAttr(bp_opers[i], m_api->m_bp_mgr.a_bp_id, sBPOperId);
				m_api->m_data.GetAttr(bp_opers[i], m_api->m_bp_mgr.a_bp_descr, sBPOperName);
				if(	buf.CompareNoCase(" ")==0)
				{
					sBPOperId.Format("%d",OS_num);
					iBPOperIdNum = OS_num;
					OS_num++;
				}
				else 
				{
					sBPOperId.Format("%d", STP_num);
					iBPOperIdNum = STP_num;
					STP_num++;
				}
				sBPOperResId = buf;
				sMK = sTP = "";
				bp_oper_res.Clear();
				m_api->m_bp_mgr.LoadAllBPResources(bp_opers[i], bp_oper_res);

 				CString sHardness, sSoj, sRm;
 				for(int j= 0; j<bp_oper_res.GetSize(); j++)
				{
					sBPPerResId= ""; sBPPerResName= ""; sBPPerResVer= "";
					sPerType = ""; iPerTypeNum = -1;
					sZech = "", sZone = "", sRR = "";
					CaplInstance* res_type= NULL;
					m_api->m_data.GetAttr(bp_oper_res[j], m_api->m_bp_mgr.a_bp_res_type, res_type);
					if(res_type)
					{
						m_api->m_data.GetAttr(res_type, m_api->m_bp_mgr.a_bp_res_type_name, sPerType);
						{
							CaplInstance* inst_item= NULL;
							m_api->m_data.GetAttr(bp_oper_res[j], m_api->m_bp_mgr.a_bp_res_object, inst_item);
							GetResourceName(inst_item, sBPPerResName, sBPPerResId, sBPPerResVer);
							iPerTypeNum = GetTypeNum(bp_oper_res[j], sPerType);
						}
					}
					ADD_ROW
						data_source->AddRow(row);					
				}
				
				if(bp_oper_res.GetSize()==0)
				{
					ADD_ROW
						data_source->AddRow(row);					
				}
			}
			continue;
		}
		
		m_api->m_data.GetAttr(bp_opers[i], m_api->m_bp_mgr.a_bp_id, sBPOperId);
		m_api->m_data.GetAttr(bp_opers[i], m_api->m_bp_mgr.a_bp_name, sBPOperName);
		iBPOperIdNum= oper_num;
		oper_num++;
		
		//      
		aplExtent docs, rel_docs;
		m_api->m_doc_mgr.FindAssociatedDocuments(bp_opers[i],docs, rel_docs);
		m_api->m_doc_mgr.LoadDocInfo(docs);
		for(int d=0; d<docs.Size;d++)
		{
			CaplInstance* doc_type=NULL;
			m_api->m_data.GetAttr(docs[d],m_api->m_doc_mgr.a_doc_kind,doc_type);
			if(doc_type)
			{
				CString type_name;
				m_api->m_data.GetAttr(doc_type,m_api->m_doc_mgr.a_dt_pdt,type_name);
				if(	type_name.CompareNoCase("")==0 ||
					type_name.CompareNoCase("")==0)
				{
					// ,         
					CString doc_id;
					m_api->m_data.GetAttr(docs[d],m_api->m_doc_mgr.a_doc_id,doc_id);
					if(sOperDocId.IsEmpty())
						sOperDocId = doc_id;
					else if(!doc_id.IsEmpty())
						sOperDocId += ", "+doc_id;
				}
			}
		}
		
		for(j= 0; j<chars_ext.GetSize(); j++)
		{
			double dValue = 0;
			CaplInstance* inst1= NULL, *inst2= NULL;
			m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_charact_val_item, inst1);
			m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_charact_val_charact, inst2);

			if(inst1==bp_opers[i] && mk_ok_char==inst2)
			{
				m_api->m_charact_mgr.PrintCharacteristicValue(chars_ext[j], NULL, sMK);
			}
			else if(inst1==bp_opers[i] && tp_char==inst2)
			{
				m_api->m_charact_mgr.PrintCharacteristicValue(chars_ext[j], NULL, sTP);					
			}
			else if(inst1==bp_opers[i] && zeh_char==inst2)
			{
				CaplInstance* inst;
				m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_reference_val, inst);
				m_api->m_categ_mgr.LoadCategoryInfo(inst);
				if(inst)
					m_api->m_data.GetAttr(inst, m_api->m_appr_mgr.a_org_descr, sZech);
			}
			else if(inst1==bp_opers[i] && rr_char==inst2)
			{
				m_api->m_charact_mgr.PrintCharacteristicValue(chars_ext[j], NULL, sRR);
			}
			else if(inst1==bp_opers[i] && zone_char==inst2)
			{
				CaplInstance* inst;
				m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_reference_val, inst);
				m_api->m_categ_mgr.LoadCategoryInfo(inst);
				if(inst)
					m_api->m_data.GetAttr(inst, m_api->m_appr_mgr.a_org_descr, sZone);
			}			
			else if(inst1==bp_opers[i] && hardness_char==inst2)
			{
				m_api->m_charact_mgr.PrintCharacteristicValue(chars_ext[j], NULL, sHardness);
			}
			else if(inst1==bp_opers[i] && to_char==inst2)
			{
				m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_charact_val_meas_val, dValue);	
				sTo.Format("%g", dValue);
			}
			else if(inst1==bp_opers[i] && tv_char==inst2)
			{
				m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_charact_val_meas_val, dValue);								
				sTv.Format("%g", dValue);
			}
			else if(inst1==bp_opers[i] && tpz_char==inst2)
			{
				m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_charact_val_meas_val, dValue);								
				sTpz.Format("%g", dValue);
			}
			else if(inst1==bp_opers[i] && tsht_char==inst2)
			{
				m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_charact_val_meas_val, dValue);								
				sTsht.Format("%g", dValue);
			}
			else if(inst1==bp_opers[i] && soj_char==inst2)
			{
				CaplInstance* inst;
				m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_reference_val, inst);
				if(inst) m_api->GetItemName(inst, sSoj);
			}
			else if(inst1==bp_opers[i] && rm_char==inst2)
			{
				m_api->m_charact_mgr.PrintCharacteristicValue(chars_ext[j], NULL, sRm);
			}
		}
		
		// 
		bp_oper_res.Clear();
		m_api->m_bp_mgr.LoadAllBPResources(bp_opers[i], bp_oper_res);
		
		for(j= 0; j<bp_oper_res.GetSize(); j++)
		{
			CaplInstance* res_type= NULL;
			m_api->m_data.GetAttr(bp_oper_res[j], m_api->m_bp_mgr.a_bp_res_type, res_type);
			if(res_type)
			{
				m_api->m_data.GetAttr(res_type, m_api->m_bp_mgr.a_bp_res_type_name, buf);
				if(buf.CompareNoCase("")==0)
				{
					CaplInstance* inst_item= NULL;
					m_api->m_data.GetAttr(bp_oper_res[j], m_api->m_bp_mgr.a_bp_res_object, inst_item);
					GetResourceName(inst_item, sBPOperResName, sBPOperResId, sBPOperResVer);
					iPerTypeNum = GetTypeNum(bp_oper_res[j], sPerType);
					//       
					if(!sOborudList.IsEmpty())
						sOborudList+=", ";
					sOborudList += sBPOperResName;
					if(!sOborudList.IsEmpty() && !sBPOperResId.IsEmpty())
						sOborudList+=" ";
					sOborudList+=sBPOperResId;
					if(!sOborudList.IsEmpty()&& !sBPOperResVer.IsEmpty())
						sOborudList+=" ";
					sOborudList+=sBPOperResVer;
				}
				else if(buf.CompareNoCase("")==0)
				{
					CString mName, mId, mVer;
					CaplInstance* inst_item= NULL;
					m_api->m_data.GetAttr(bp_oper_res[j], m_api->m_bp_mgr.a_bp_res_object, inst_item);
					GetResourceName(inst_item, mName, mId, mVer);
					iPerTypeNum = GetTypeNum(bp_oper_res[j], sPerType);
					//       
					if(!sMaterial.IsEmpty())
						sMaterial+=", ";
					sMaterial += mName+" "+mId+" "+mVer;
				}
			}
		}
		/************************************************************************/
		/*                                                              */
		/************************************************************************/
		Perehod(&dict, bp_opers[i], m_api, sBPOperId, iBPOperIdNum, sBPOperName, sBPOperResId, 
			sBPOperResName, sBPOperResVer, sMK, sTP, sOperDocId, sZone, sMaterial, sRR, sZech,
			sOborudList, sHardness, sTo, sTv, sTpz, sTsht, sSoj, sRm);

		sTo.Empty(); sTv.Empty(); sTpz.Empty(); sTsht.Empty();
		sHardness.Empty(), sSoj.Empty(), sRm.Empty();
	}
		
	CString sExePath;
	/************************************************************************/
	/*                                                       */
	/************************************************************************/
	HMODULE hModule;
	char szModuleName[2048];
	
	hModule = GetModuleHandle(NULL);
	if(hModule!=NULL)
	{
		if(GetModuleFileName(hModule, szModuleName, 2048)>0)
		{
			buf= szModuleName;
			sExePath = buf.Left(buf.ReverseFind('\\'));
		}
	}
	
	SaveToFile(&dict);
	
	return GenerateReport(&dict, &RParams, dot_file, report_file);
}

bool CaplExportTechDoc::GenVO(LPCTSTR dot_file, LPCTSTR report_file)
{
	if(!inInst || !m_api) return false;
	CaplInstance* bp_type= NULL;
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_type, bp_type);
	CString  buf, tmp;
	if(bp_type)
		m_api->m_data.GetAttr(bp_type, m_api->m_bp_mgr.a_bp_type_name, buf);
	if(buf.CompareNoCase(" ")) return false;

	m_inst = inInst;
	
	CString sOrgName, sOrgId, sPrdId, sPrdName, sBPId, sBPName, sBPNum, 
		sAssortName, sZagotShap, sMaterName;
	// .
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_id, sBPId);

	/************************************************************************/
	/*                                              */
	/************************************************************************/
	aplExtent all_orgs, all_org_rels;		
	m_api->m_appr_mgr.GetAllSubOrganization(NULL,all_orgs);
	if(all_orgs.Size>0)
	{
		m_api->m_data.GetAttr(all_orgs[0], m_api->m_appr_mgr.a_org_id, sOrgId);
		m_api->m_data.GetAttr(all_orgs[0], m_api->m_appr_mgr.a_org_name, sOrgName);
	}
	
	/************************************************************************/
	/*                                                */
	/************************************************************************/		
	
	FindPrd_and_Mater(inInst, m_api, sPrdId, sPrdName, sAssortName, sZagotShap, sMaterName);
	
	/************************************************************************/
	/*  -                                             */
	/************************************************************************/
	
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_id, sBPId);
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_name, sBPName);
	CaplInstance* bpVer= NULL;
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_act, bpVer);
	if(bpVer)
		m_api->m_data.GetAttr(bpVer, m_api->m_bp_mgr.a_bp_ver_num, sBPNum);	
	
	CRParamsArray RParams;
	RParams.Add("org_structure", sOrgName);
	RParams.Add("org_structure_id", sOrgId);
	RParams.Add("prd_id", sPrdId);
	RParams.Add("prd_name", sPrdName);
	RParams.Add("bp_id", sBPId);
	RParams.Add("bp_number", sBPNum);
	RParams.Add("bp_litera", m_sBpLit);
	RParams.Add("assort_name", sAssortName);
	RParams.Add("zagot_shap", sZagotShap);
	RParams.Add("prog_id","");
	RParams.Add("oper_descr","");
	RParams.Add("bp_name",sBPName);
	RParams.Add("mater_name", sMaterName);
	
	CaplReportMgr dict; dict.Init();
	CDataSource *data_source = &dict.m_data_source;
	dict.m_data_source.SetHeader(SetHeaderData());
	/************************************************************************/
	/*                                                      */
	/************************************************************************/
	aplExtent bp_opers, bp_oper_res, bp_pers, bp_per_res;
	INITIAL_PARAMS;//   
		CTableRow* row= NULL;
	
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_elements, bp_opers);
	m_api->m_bp_mgr.LoadBPInfo(bp_opers);
	
	CaplInstance* mk_ok_char= m_api->m_charact_mgr.GetCharacteristicById("_");
	CaplInstance* tp_char= m_api->m_charact_mgr.GetCharacteristicById("");
	aplExtent chars_ext, chars_group_ext;
	m_api->m_charact_mgr.FindAssociatedCharacteristic(bp_opers, chars_ext, chars_group_ext);
	int oper_num = 1;
	
	if(IsWindow(m_progress))
	{
		m_progress->SetPos(0);
		m_progress->SetRange32(0, bp_opers.GetSize());
		m_progress->SetStep(1);
	}

	int i, j;

	for(i= 0; i<bp_opers.GetSize(); i++)
	{
		if(IsWindow(m_progress))
			m_progress->StepIt();
		sBPOperName= ""; sBPOperId= ""; sBPOperResId= ""; sBPOperResName= ""; sBPOperResVer= "";
		sBPPerId= ""; sBPPerDscr= ""; sBPPerResId= ""; sBPPerResName= ""; sBPPerResVer= "";
		sMK= ""; sTP= ""; iBPOperIdNum= -1; iBPRepIdNum= -1;
		sOperDocId= ""; sPerDocId = ""; sPerType="", sZone = "", sRR = "";
		iPerTypeNum = -1;
		
		m_api->m_data.GetAttr(bp_opers[i], m_api->m_bp_mgr.a_bp_type, bp_type);
		if(!bp_type) continue;
		m_api->m_data.GetAttr(bp_type, m_api->m_bp_mgr.a_bp_type_name, buf);
		if(buf.CompareNoCase("")) continue;
		
		m_api->m_data.GetAttr(bp_opers[i], m_api->m_bp_mgr.a_bp_id, sBPOperId);
		m_api->m_data.GetAttr(bp_opers[i], m_api->m_bp_mgr.a_bp_name, sBPOperName);
		iBPOperIdNum= oper_num;
		oper_num++;
		
		for(j= 0; j<chars_ext.GetSize(); j++)
		{
			CaplInstance* inst1= NULL, *inst2= NULL;
			m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_charact_val_item, inst1);
			m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_charact_val_charact, inst2);
			if(inst1==bp_opers[i] && mk_ok_char==inst2)
			{
				m_api->m_charact_mgr.PrintCharacteristicValue(chars_ext[j], NULL, sMK);
			}
			else if(inst1==bp_opers[i] && tp_char==inst2)
			{
				m_api->m_charact_mgr.PrintCharacteristicValue(chars_ext[j], NULL, sTP);					
			}
		}
		
		bp_oper_res.Clear();
		m_api->m_bp_mgr.LoadAllBPResources(bp_opers[i], bp_oper_res);
		
		for(j= 0; j<bp_oper_res.GetSize(); j++)
		{
			CaplInstance* res_type= NULL;
			m_api->m_data.GetAttr(bp_oper_res[j], m_api->m_bp_mgr.a_bp_res_type, res_type);
			if(res_type)
			{
				m_api->m_data.GetAttr(res_type, m_api->m_bp_mgr.a_bp_res_type_name, buf);
				if(!buf.CompareNoCase(""))
				{
					CaplInstance* inst_item= NULL;
					m_api->m_data.GetAttr(bp_oper_res[j], m_api->m_bp_mgr.a_bp_res_object, inst_item);
					GetResourceName(inst_item, sBPOperResName, sBPOperResId, sBPOperResVer);
				}
				else
				{
					CaplInstance* inst_item= NULL;
					m_api->m_data.GetAttr(bp_oper_res[j], m_api->m_bp_mgr.a_bp_res_object, inst_item);
					GetResourceName(inst_item, sBPPerResName, sBPPerResId, sBPPerResVer);
					sBPOperResName = sBPPerResName;
					sBPOperResId = sBPPerResId;
					sBPOperResVer = sBPPerResVer;
					iPerTypeNum = GetTypeNum(bp_oper_res[j], sPerType);
					ADD_ROW
						data_source->AddRow(row);
				}
			}
		}
		/************************************************************************/
		/*                                                              */
		/************************************************************************/
		Perehod(&dict, bp_opers[i], m_api, sBPOperId, iBPOperIdNum, sBPOperName, sBPOperResId, 
			sBPOperResName, sBPOperResVer, sMK, sTP, sOperDocId, sZone, sMaterial, sRR, sZech, sOborudList,
			sHardness, sTo, sTv, sTpz, sTsht, sSoj, sRm);
	}
	
	CString sExePath;
	/************************************************************************/
	/*                                                       */
	/************************************************************************/
	HMODULE hModule;
	char szModuleName[2048];
	
	hModule = GetModuleHandle(NULL);
	if(hModule!=NULL)
	{
		if(GetModuleFileName(hModule, szModuleName, 2048)>0)
		{
			buf= szModuleName;
			sExePath = buf.Left(buf.ReverseFind('\\'));
		}
	}
	
	SaveToFile(&dict);
	
	return GenerateReport(&dict, &RParams, dot_file, report_file);
}

bool CaplExportTechDoc::GenOK(LPCTSTR dot_file, LPCTSTR report_file)
{
	if(!inInst || !m_api) return false;
	CaplInstance* bp_type= NULL;
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_type, bp_type);
	CString  buf, tmp;
	if(bp_type)
		m_api->m_data.GetAttr(bp_type, m_api->m_bp_mgr.a_bp_type_name, buf);
	
	if(buf.CompareNoCase("")) 
	{
		m_LastError = APL_LE_BADTYPE;
		return false;
	}
	
	CString sOrgName, sOrgId, sPrdId, sPrdName, sBPId, sBPName, sBPNum, 
		sAssortName, sZagotShap, sOperId, sOperName, sStanok, sMaterName, sOperDocuments;
	
	// .
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_id, sBPId);

	/************************************************************************/
	/*                                              */
	/************************************************************************/
	aplExtent all_orgs, all_org_rels;		
	m_api->m_appr_mgr.GetAllSubOrganization(NULL,all_orgs);
	if(all_orgs.Size>0)
	{
		m_api->m_data.GetAttr(all_orgs[0], m_api->m_appr_mgr.a_org_name, sOrgName);
		m_api->m_data.GetAttr(all_orgs[0], m_api->m_appr_mgr.a_org_id, sOrgId);
	}
	
	int i;
	
	/************************************************************************/
	/*                                                */
	/************************************************************************/		
	aplExtent prds, ext_bp_ref, ext_pear_bp;
	CaplInstance* pdf= NULL;		//   
	CaplInstance* pdf_mater= NULL;	//   
	CaplInstance* mf_rel= NULL;		// pdf & pdf_mater
	CaplInstance* p_bp= NULL;	// 
	
	if(m_inst==0)
	{
		m_api->m_bp_mgr.WhereUsedBP(inInst, ext_pear_bp);
		for(i= 0; i<ext_pear_bp.GetSize(); i++)
		{
			m_api->m_data.GetAttr(ext_pear_bp[i], m_api->m_bp_mgr.a_bp_type, bp_type);
			if(!bp_type) continue;
			m_api->m_data.GetAttr(bp_type, m_api->m_bp_mgr.a_bp_type_name, buf);
			if(!buf.CompareNoCase(" "))
			{
				p_bp= ext_pear_bp[i];
				break;
			}
		}
	}
	else
		p_bp = m_inst;
	
	FindPrd_and_Mater(p_bp, m_api, sPrdId, sPrdName, sAssortName, sZagotShap, sMaterName);
	
	/************************************************************************/
	/*  -                                             */
	/************************************************************************/
	m_api->m_bp_mgr.LoadBPInfo(p_bp);
	
	m_api->m_data.GetAttr(p_bp, m_api->m_bp_mgr.a_bp_id, sBPId);
	m_api->m_data.GetAttr(p_bp, m_api->m_bp_mgr.a_bp_name, sBPName);
	CaplInstance* bpVer= NULL;
	m_api->m_data.GetAttr(p_bp, m_api->m_bp_mgr.a_bp_act, bpVer);
	if(bpVer)
		m_api->m_data.GetAttr(bpVer, m_api->m_bp_mgr.a_bp_ver_num, sBPNum);	
	
	aplExtent bp_opers, bp_oper_res, bp_pers, bp_per_res;
	
	INITIAL_PARAMS;//   
		
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_name, sOperName);
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_id, sOperId);
	sBPOperId= sOperId; sBPOperName= sOperName;
	
	m_api->m_bp_mgr.LoadAllBPResources(inInst, bp_oper_res);	
	
	for(i= 0; i<bp_oper_res.GetSize(); i++)
	{
		CaplInstance* res_type= NULL;
		sBPOperResVer = "";
		m_api->m_data.GetAttr(bp_oper_res[i], m_api->m_bp_mgr.a_bp_res_type, res_type);
		if(res_type)
		{
			m_api->m_data.GetAttr(res_type, m_api->m_bp_mgr.a_bp_res_type_name, buf);
			if(!buf.CompareNoCase(""))
			{
				CaplInstance* inst_item= NULL;
				m_api->m_data.GetAttr(bp_oper_res[i], m_api->m_bp_mgr.a_bp_res_object, inst_item);
				if(!GetResourceName(inst_item, sBPOperResName, sBPOperResId, sBPOperResVer))
					continue;
				if(sStanok.IsEmpty())
					sStanok = sBPOperResName+" "+sBPOperResId+" "+sBPOperResVer;
				else if(!sBPOperResId.IsEmpty() || !sBPOperResName.IsEmpty() || !sBPOperResVer.IsEmpty())
					sStanok+=", "+sBPOperResName+" "+sBPOperResId+" "+sBPOperResVer;;
			}
			else if(!buf.CompareNoCase(""))
			{
				CString mName, mId, mVer;
				CaplInstance* inst_item= NULL;
				m_api->m_data.GetAttr(bp_oper_res[i], m_api->m_bp_mgr.a_bp_res_object, inst_item);
				GetResourceName(inst_item, mName, mId, mVer);
				iPerTypeNum = GetTypeNum(bp_oper_res[i], sPerType);
				//       
				if(!sMaterial.IsEmpty())
					sMaterial+=", ";
				sMaterial += mName+" "+mId+" "+mVer;
			}
		}
		sOborudList = sStanok;
	}
	
	CaplInstance* mk_ok_char= m_api->m_charact_mgr.GetCharacteristicById("_");
	CaplInstance* tp_char= m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* zeh_char= m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* rr_char= m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* zone_char = m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* hardness_char=m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* to_char=m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* tv_char=m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* tpz_char=m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* tsht_char=m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* soj_char=m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* rm_char=m_api->m_charact_mgr.GetCharacteristicById("");
	aplExtent chars_ext, chars_group_ext;
	
	m_api->m_charact_mgr.FindAssociatedCharacteristic(inInst, chars_ext, chars_group_ext);
	for(int j= 0; j<chars_ext.GetSize(); j++)
	{
		double dValue = 0;
		CaplInstance* inst1= NULL, *inst2= NULL;
		m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_charact_val_item, inst1);
		m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_charact_val_charact, inst2);
		if(inst1==inInst && mk_ok_char==inst2)
		{
			m_api->m_charact_mgr.PrintCharacteristicValue(chars_ext[j], NULL, sMK);
		}
		else if(inst1==inInst && tp_char==inst2)
		{
			m_api->m_charact_mgr.PrintCharacteristicValue(chars_ext[j], NULL, sTP);					
		}
		else if(inst1==inInst && zeh_char==inst2)
		{
			CaplInstance* inst;
			m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_reference_val, inst);
			m_api->m_categ_mgr.LoadCategoryInfo(inst);
			if(inst)
				m_api->m_data.GetAttr(inst, m_api->m_appr_mgr.a_org_descr, sZech);
		}
		else if(inst1==inInst && rr_char==inst2)
		{
			m_api->m_charact_mgr.PrintCharacteristicValue(chars_ext[j], NULL, sRR);
		}
		else if(inst1==inInst && zone_char==inst2)
		{
			CaplInstance* inst;
			m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_reference_val, inst);
			m_api->m_categ_mgr.LoadCategoryInfo(inst);
			if(inst)
				m_api->m_data.GetAttr(inst, m_api->m_appr_mgr.a_org_descr, sZone);
		}
		else if(inst1==inInst && hardness_char==inst2)
		{
			m_api->m_charact_mgr.PrintCharacteristicValue(chars_ext[j], NULL, sHardness);
		}
		else if(inst1==inInst && to_char==inst2)
		{
			m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_charact_val_meas_val, dValue);
			sTo.Format("%g", dValue);
		}
		else if(inst1==inInst && tv_char==inst2)
		{
			m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_charact_val_meas_val, dValue);								
			sTv.Format("%g", dValue);
		}
		else if(inst1==inInst && tpz_char==inst2)
		{
			m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_charact_val_meas_val, dValue);								
			sTpz.Format("%g", dValue);
		}
		else if(inst1==inInst && tsht_char==inst2)
		{
			m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_charact_val_meas_val, dValue);								
			sTsht.Format("%g", dValue);
		}
		else if(inst1==inInst && soj_char==inst2)
		{
			CaplInstance* inst;
			m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_reference_val, inst);
			if(inst) m_api->GetItemName(inst, sSoj);
		}
		else if(inst1==inInst && rm_char==inst2)
		{
			m_api->m_charact_mgr.PrintCharacteristicValue(chars_ext[j], NULL, sRm);
		}
	}
	if(bGenIfOK && sMK!="")
	{
		m_LastError = APL_LE_NOT_OK;
		return false;
	}
	//  
	CString sProgId="";
	{
		CString type_name;
		aplExtent docs, rels;
		m_api->m_doc_mgr.FindAssociatedDocuments(inInst, docs, rels, NULL);
		m_api->m_doc_mgr.LoadDocInfo(docs);
		for(int i=0; i<docs.Size; i++)
		{
			CaplInstance* type;
			m_api->m_data.GetAttr(docs[i], m_api->m_doc_mgr.a_doc_kind, type);
			if(type==0) continue;
			m_api->m_data.GetAttr(type, m_api->m_doc_mgr.a_dt_pdt, type_name);
			if(!type_name.CompareNoCase(" "))
				m_api->m_data.GetAttr(docs[i], m_api->m_doc_mgr.a_doc_id, sProgId);
			else if(!type_name.CompareNoCase("") ||
				!type_name.CompareNoCase(""))
			{
				CString doc_id;
				m_api->m_data.GetAttr(docs[i], m_api->m_doc_mgr.a_doc_id, doc_id);
				if(!sOperDocuments.IsEmpty() && !doc_id.IsEmpty())
					sOperDocuments+=", ";
				sOperDocuments+=doc_id;
			}
		}
	}
	
	CRParamsArray RParams;
	RParams.Add("org_structure", sOrgName);
	RParams.Add("org_structure_id", sOrgId);
	RParams.Add("prd_id", sPrdId);
	RParams.Add("prd_name", sPrdName);
	RParams.Add("bp_id", sBPId);
	RParams.Add("bp_number", sBPNum);
	RParams.Add("bp_litera", m_sBpLit);
	RParams.Add("assort_name", sAssortName);
	RParams.Add("zagot_shap", sZagotShap);
	RParams.Add("bp_oper_id", sOperId);
	RParams.Add("bp_oper_name", sOperName);
	RParams.Add("oborud", sStanok);
	RParams.Add("mater_name", sMaterName);
	RParams.Add("prog_id",sProgId);
	RParams.Add("oper_document",sOperDocuments);
	RParams.Add("bp_name",sBPName);
	RParams.Add("hardness", sHardness);
	RParams.Add("tpz", sTpz);
	RParams.Add("tsht", sTsht);
	RParams.Add("soj", sSoj);
	RParams.Add("to", sTo);
	RParams.Add("tv", sTv);
	
	CaplReportMgr dict; dict.Init();
	CDataSource *data_source = &dict.m_data_source;
	/************************************************************************/
	/*                                                      */
	/************************************************************************/	
	dict.m_data_source.SetHeader(SetHeaderData());
	/************************************************************************/
	/*                                                              */
	/************************************************************************/
	
	Perehod(&dict, inInst, m_api, sBPOperId, iBPOperIdNum, sBPOperName, sBPOperResId, sBPOperResName,
		sBPOperResVer, sMK, sTP, sOperDocId, sZone, sMaterial, sRR, sZech, sOborudList, sHardness, sTo, 
		sTv, sTpz, sTsht, sSoj, sRm, "oper");	
	
	CString sExePath;
	/************************************************************************/
	/*                                                       */
	/************************************************************************/
	HMODULE hModule;
	char szModuleName[2048];
	
	hModule = GetModuleHandle(NULL);
	if(hModule!=NULL)
	{
		if(GetModuleFileName(hModule, szModuleName, 2048)>0)
		{
			buf= szModuleName;
			sExePath = buf.Left(buf.ReverseFind('\\'));
		}
	}
	
	SaveToFile(&dict);
	
	return GenerateReport(&dict, &RParams, dot_file, report_file);
}

bool CaplExportTechDoc::GenVOb(LPCTSTR dot_file, LPCTSTR report_file)
{
	if(!inInst || !m_api) return false;
	CaplInstance* bp_type= NULL;
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_type, bp_type);
	CString  buf, tmp;
	if(bp_type)
		m_api->m_data.GetAttr(bp_type, m_api->m_bp_mgr.a_bp_type_name, buf);
	
	if(buf.CompareNoCase(" ")) return false;
	
	CString sOrgName, sOrgId, sPrdId, sPrdName, sBPId, sBPName, sBPNum, 
		sAssortName, sZagotShap, sMaterName;
	
	// .
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_id, sBPId);

	/************************************************************************/
	/*                                              */
	/************************************************************************/
	aplExtent all_orgs, all_org_rels;		
	m_api->m_appr_mgr.GetAllSubOrganization(NULL,all_orgs);
	if(all_orgs.Size>0)
	{
		m_api->m_data.GetAttr(all_orgs[0], m_api->m_appr_mgr.a_org_name, sOrgName);
		m_api->m_data.GetAttr(all_orgs[0], m_api->m_appr_mgr.a_org_id, sOrgId);
	}
	
	
	/************************************************************************/
	/*                                                */
	/************************************************************************/		
	
	FindPrd_and_Mater(inInst, m_api, sPrdId, sPrdName, sAssortName, sZagotShap, sMaterName);
	
	/************************************************************************/
	/*  -                                             */
	/************************************************************************/
	
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_id, sBPId);
	CaplInstance* bpVer= NULL;
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_act, bpVer);
	if(bpVer)
	{
		m_api->m_data.GetAttr(bpVer, m_api->m_bp_mgr.a_bp_ver_num, sBPNum);	
	}
	
	CRParamsArray RParams;
	RParams.Add("org_structure", sOrgName);
	RParams.Add("org_structure_id", sOrgId);
	RParams.Add("prd_id", sPrdId);
	RParams.Add("prd_name", sPrdName);
	RParams.Add("bp_id", sBPId);
	RParams.Add("bp_number", sBPNum);
	RParams.Add("bp_litera", m_sBpLit);
	RParams.Add("assort_name", sAssortName);
	RParams.Add("zagot_shap", sZagotShap);
	RParams.Add("prog_id","");
	RParams.Add("oper_descr","");
	RParams.Add("bp_name",sBPName);
	RParams.Add("mater_name", sMaterName);
	
	CaplReportMgr dict; dict.Init();
	CDataSource *data_source = &dict.m_data_source;
	/************************************************************************/
	/*                                                      */
	/************************************************************************/
	dict.m_data_source.SetHeader(SetHeaderData());
	
	/************************************************************************/
	/*                                                      */
	/************************************************************************/
	
	aplExtent bp_opers, bp_oper_res, bp_pers, bp_per_res;
	
	INITIAL_PARAMS//   
		
		CTableRow* row= NULL;
	
	//		m_api->m_bp_mgr.GetAllSubBP(inExtent[0], bp_opers);
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_elements, bp_opers);
	m_api->m_bp_mgr.LoadBPInfo(bp_opers);
	
	CaplInstance* mk_ok_char= m_api->m_charact_mgr.GetCharacteristicById("_");
	CaplInstance* tp_char= m_api->m_charact_mgr.GetCharacteristicById("");
	aplExtent chars_ext, chars_group_ext;
	m_api->m_charact_mgr.FindAssociatedCharacteristic(bp_opers, chars_ext, chars_group_ext);
	int oper_num = 1;
	int i, j;
	if(IsWindow(m_progress))
	{
		m_progress->SetPos(0);
		m_progress->SetRange32(0, bp_opers.GetSize());
		m_progress->SetStep(1);
	}	

	for(i= 0; i<bp_opers.GetSize(); i++)
	{
		if(IsWindow(m_progress))
			m_progress->StepIt();
		sBPOperName= ""; sBPOperId= ""; sBPOperResId= ""; sBPOperResName= ""; sBPOperResVer= "";
		sBPPerId= ""; sBPPerDscr= ""; sBPPerResId= ""; sBPPerResName= ""; sBPPerResVer= "";
		sMK= ""; sTP= ""; iBPOperIdNum= -1; iBPRepIdNum= -1;
		sOperDocId= ""; sPerDocId = ""; sPerType="", sZone = "", sRR = "";
		iPerTypeNum = 5;
		
		m_api->m_data.GetAttr(bp_opers[i], m_api->m_bp_mgr.a_bp_type, bp_type);
		if(!bp_type) continue;
		m_api->m_data.GetAttr(bp_type, m_api->m_bp_mgr.a_bp_type_name, buf);
		if(buf.CompareNoCase("")) continue;
		
		m_api->m_data.GetAttr(bp_opers[i], m_api->m_bp_mgr.a_bp_id, sBPOperId);
		m_api->m_data.GetAttr(bp_opers[i], m_api->m_bp_mgr.a_bp_name, sBPOperName);
		iBPOperIdNum= oper_num;
		oper_num++;
		
		for(j= 0; j<chars_ext.GetSize(); j++)
		{
			CaplInstance* inst1= NULL, *inst2= NULL;
			m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_charact_val_item, inst1);
			m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_charact_val_charact, inst2);
			if(inst1==bp_opers[i] && mk_ok_char==inst2)
			{
				m_api->m_charact_mgr.PrintCharacteristicValue(chars_ext[j], NULL, sMK);
			}
			else if(inst1==bp_opers[i] && tp_char==inst2)
			{
				m_api->m_charact_mgr.PrintCharacteristicValue(chars_ext[j], NULL, sTP);					
			}
		}
		
		bp_oper_res.Clear();
		m_api->m_bp_mgr.LoadAllBPResources(bp_opers[i], bp_oper_res);
		
		for(j= 0; j<bp_oper_res.GetSize(); j++)
		{
			sBPOperResName = sBPOperResVer = sBPOperResId = "";
			CaplInstance* res_type= NULL;
			m_api->m_data.GetAttr(bp_oper_res[j], m_api->m_bp_mgr.a_bp_res_type, res_type);
			if(res_type)
			{
				m_api->m_data.GetAttr(res_type, m_api->m_bp_mgr.a_bp_res_type_name, buf);
				if(!buf.CompareNoCase(""))
				{
					CaplInstance* inst_item= NULL;
					m_api->m_data.GetAttr(bp_oper_res[j], m_api->m_bp_mgr.a_bp_res_object, inst_item);
					GetResourceName(inst_item, sBPOperResName, sBPOperResId, sBPOperResVer);
					ADD_ROW
						data_source->AddRow(row);				
				}
			}
		}
	}
	
	CString sExePath;
	/************************************************************************/
	/*                                                       */
	/************************************************************************/
	HMODULE hModule;
	char szModuleName[2048];
	
	hModule = GetModuleHandle(NULL);
	if(hModule!=NULL)
	{
		if(GetModuleFileName(hModule, szModuleName, 2048)>0)
		{
			buf= szModuleName;
			sExePath = buf.Left(buf.ReverseFind('\\'));
		}
	}
	
	SaveToFile(&dict);
	
	return GenerateReport(&dict, &RParams, dot_file, report_file);
}

bool CaplExportTechDoc::GenTechDocs(LPCTSTR report_file, TDotsData data)
{
	bool ok = true;

	CString tempdir = getenv("TEMP");
	if(!tempdir.IsEmpty())
		tempdir+="\\";
	CaplInstance* Inst = inInst;
	CStringArray Files;
	int tc;
	if(data.ExTL && ok)
	{
		tc = GetTickCount();
		if(IsWindow(m_edit))
			m_edit->SetWindowText("  ...");
		CString file;
		COleDateTime time = COleDateTime::GetCurrentTime();
		aplDate2String(time, file);
		file=tempdir+file+"_TL.tmprep";
		ok &= GenTL(data.TL_dot, file);
		if(ok)
			Files.Add(file);
		TRACE("TL - %d\n", GetTickCount()-tc);
	}
	if(data.ExOS && ok)
	{
		tc = GetTickCount();
		if(IsWindow(m_edit))
			m_edit->SetWindowText("  ...");
		CString file;
		COleDateTime time = COleDateTime::GetCurrentTime();
		aplDate2String(time, file);
		file=tempdir+file+"_OS.tmprep";
		ok &= GenOS(data.OS_dot, file);
		if(ok)
			Files.Add(file);
		TRACE("OS - %d\n", GetTickCount()-tc);
	}
	if(data.ExVOb && ok)
	{
		if(IsWindow(m_edit))
			m_edit->SetWindowText("  ...");
		CString file;
		COleDateTime time = COleDateTime::GetCurrentTime();
		aplDate2String(time, file);
		file=tempdir+file+"_VOb.tmprep";
		ok &= GenVOb(data.VOb_dot, file);
		if(ok)
			Files.Add(file);
	}
	if(data.ExVM && ok)
	{
		if(IsWindow(m_edit))
			m_edit->SetWindowText("  ...");
		CString file;
		COleDateTime time = COleDateTime::GetCurrentTime();
		aplDate2String(time, file);
		file=tempdir+file+"_VM.tmprep";
		ok &= GenVO(data.VM_dot, file);
		if(ok)
			Files.Add(file);
	}
	if(data.ExVO && ok)
	{
		if(IsWindow(m_edit))
			m_edit->SetWindowText("  ...");
		CString file;
		COleDateTime time = COleDateTime::GetCurrentTime();
		aplDate2String(time, file);
		file=tempdir+file+"_VO.tmprep";
		ok &= GenVO(data.VO_dot, file);
		if(ok)
			Files.Add(file);
	}
	if(data.ExMK && ok)
	{
		if(IsWindow(m_edit))
			m_edit->SetWindowText("  ...");
		CString file;
		COleDateTime time = COleDateTime::GetCurrentTime();
		aplDate2String(time, file);
		file=tempdir+file+"_MK.tmprep";
		ok &= GenMK(data.MK_dot, file);
		if(ok)
			Files.Add(file);
	}
	if(data.ExOK && ok)
	{
		if(IsWindow(m_edit))
			m_edit->SetWindowText("  ...");
		CaplInstance* TP = m_api->m_charact_mgr.GetCharacteristicById("");
		CaplInstance* OK = m_api->m_charact_mgr.GetCharacteristicById("_");
		CaplInstance* KP = m_api->m_charact_mgr.GetCharacteristicById("");
		bGenIfOK = TRUE;
		aplExtent bp_opers;
		if(m_inst==0)
			m_inst = inInst;
		m_api->m_data.GetAttr(m_inst, m_api->m_bp_mgr.a_bp_elements, bp_opers);
		if(IsWindow(m_progress))
		{
			m_progress->SetPos(0);
			m_progress->SetRange32(0, bp_opers.GetSize());
			m_progress->SetStep(1);
		}
		m_api->m_bp_mgr.LoadBPInfo(bp_opers);
		CString buf;
		aplExtent charact_ext, gr_ext;
		m_api->m_charact_mgr.FindAssociatedCharacteristic(bp_opers, charact_ext, gr_ext);
		for(int i=0; i<bp_opers.Size;i++)
		{
			if(IsWindow(m_progress))
				m_progress->StepIt();
			inInst = bp_opers[i];
			buf.Empty();
			GetCharactValue(inInst,OK, &charact_ext, buf, true);
			if(buf.CompareNoCase("")!=0)
				continue;
			m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_name, buf);
			if(buf.CompareNoCase("")==0 && bIsOGT)
				buf = data.OK_OGT_dot;
			else
				buf = data.OK_dot;
			CString file, tmp;
			COleDateTime time = COleDateTime::GetCurrentTime();
			aplDate2String(time, tmp);

			file=tempdir+tmp+"_OK.tmprep";
			//   
			while(FindString(file, &Files))
			{
				tmp+="N";
				file=tempdir+tmp+"_OK.tmprep";
			}
			bool oper_ok = GenOK(buf, file);
			int le = GetLastError();
			if(le==0)
				Files.Add(file);
			buf.Empty();
			GetCharactValue(inInst,TP, &charact_ext, buf, true);
			if(oper_ok && data.ExKI && buf.CompareNoCase("")==0)
			{
				file = tempdir+tmp+"_KI.tmprep";
				ok &= GenKI(data.KI_dot, file);
				Files.Add(file);
			}
			if(data.ExKP)
			{
				int pages;
				CaplInstance* KP_Val = GetCharactValue(inInst, KP, &charact_ext, buf, true);
				if(KP_Val)
				{
					double dVal;
					m_api->m_data.GetAttr(KP_Val, m_api->m_charact_mgr.a_apl_charact_val_meas_val, dVal);
					pages = int(dVal);
					for(int p=0; p<pages; p++)
					{
						time = COleDateTime::GetCurrentTime();
						aplDate2String(time, tmp);
						
						file=tempdir+tmp+"_KP.tmprep";
						//   
						while(FindString(file, &Files))
						{
							tmp+="N";
							file=tempdir+tmp+"_KP.tmprep";
						}
						ok = GenKP(data.KP_dot, file);
						if(ok)
							Files.Add(file);
					}
				}
			}
			ok = ok&(oper_ok || (le!=0));
			if(!ok) break;
		}
	}
	inInst = Inst;
	if(data.ExTP && ok)
	{
		if(IsWindow(m_edit))
			m_edit->SetWindowText("  ...");
		CString file;
		COleDateTime time = COleDateTime::GetCurrentTime();
		aplDate2String(time, file);
		file=tempdir+file+"_TP.tmprep";
		ok &= GenTP(data.TP_dot, file);
		if(ok)
			Files.Add(file);
	}
	if(data.ExKK && ok)
	{
		if(IsWindow(m_edit))
			m_edit->SetWindowText("  ...");
		CString file;
		COleDateTime time = COleDateTime::GetCurrentTime();
		aplDate2String(time, file);
		file=tempdir+file+"_KK.tmprep";
		ok &= GenKK(data.KK_dot, file);
		if(ok)
			Files.Add(file);
	}
	
	ok = ok&(Files.GetSize()>0);
	if(ok)
	{
		if(IsWindow(m_edit))
			m_edit->SetWindowText("  ...");
		if(IsWindow(m_progress))
			UnificationArrayReports(report_file, &Files, m_progress);
		else
			UnificationArrayReports(report_file, &Files);
	}
	//  
	for(int i=0; i<Files.GetSize();i++)
	{
		CString file = Files.GetAt(i);
		try{DeleteFile(file);}catch(...){}
	}
	if(IsWindow(m_edit) && ok)
		m_edit->SetWindowText("    !");
	
	return ok;
}

bool CaplExportTechDoc::FindString(CString str, CStringArray *array)
{
	if(array==0) return false;
	int cnt = array->GetSize();
	if(cnt==0) return false;
	for(int i=0; i<cnt; i++)
		if(array->GetAt(i)==str) return true;
	return false;
}

int CaplExportTechDoc::GetLastError()
{
	int res = m_LastError;
	m_LastError = 0;
	return res;
}

bool CaplExportTechDoc::GenTL(LPCTSTR dot_file, LPCTSTR report_file)
{
	if(inInst==0 || m_api==0) return false;
	CaplInstance* bp_type= NULL;
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_type, bp_type);
	CString  buf, tmp;
	if(bp_type)
		m_api->m_data.GetAttr(bp_type, m_api->m_bp_mgr.a_bp_type_name, buf);
	
	if(buf.CompareNoCase(" ")) return false;

	m_inst = inInst;
	
	CString sOrgName, sOrgId, sPrdId, sPrdName, sBPId, sBPName, sBPNum, 
		sAssortName, sZagotShap, sMaterName;
	
	// .
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_id, sBPId);
	
	/************************************************************************/
	/*                                              */
	/************************************************************************/
	aplExtent all_orgs, all_org_rels;		
	m_api->m_appr_mgr.GetAllSubOrganization(NULL,all_orgs);
	if(all_orgs.Size>0)
	{
		m_api->m_data.GetAttr(all_orgs[0], m_api->m_appr_mgr.a_org_id, sOrgId);
		m_api->m_data.GetAttr(all_orgs[0], m_api->m_appr_mgr.a_org_name, sOrgName);
	}
	int i=0;
	
	/************************************************************************/
	/*                                                */
	/************************************************************************/		
	
	FindPrd_and_Mater(inInst, m_api, sPrdId, sPrdName, sAssortName, sZagotShap, sMaterName);
	
	/************************************************************************/
	/*  -                                             */
	/************************************************************************/
	
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_id, sBPId);
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_name, sBPName);
	CaplInstance* bpVer= NULL;
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_act, bpVer);
	if(bpVer)
		m_api->m_data.GetAttr(bpVer, m_api->m_bp_mgr.a_bp_ver_num, sBPNum);	
	
	CRParamsArray RParams;
	RParams.Add("org_structure", sOrgName);
	RParams.Add("org_structure_id", sOrgId);
	RParams.Add("prd_id", sPrdId);
	RParams.Add("prd_name", sPrdName);
	RParams.Add("bp_id", sBPId);
	RParams.Add("bp_number", sBPNum);
	RParams.Add("bp_litera", m_sBpLit);
	RParams.Add("assort_name", sAssortName);
	RParams.Add("zagot_shap", sZagotShap);
	RParams.Add("prog_id","");
	RParams.Add("oper_descr","");
	RParams.Add("bp_name",sBPName);
	RParams.Add("mater_name", sMaterName);

	CaplReportMgr dict; dict.Init();
	CDataSource *data_source = &dict.m_data_source;
	/************************************************************************/
	/*                                                      */
	/************************************************************************/
	dict.m_data_source.SetHeader(SetHeaderData());

	return GenerateReport(&dict, &RParams, dot_file, report_file);
}

bool CaplExportTechDoc::GenOS(LPCTSTR dot_file, LPCTSTR report_file)
{
	if(inInst==0 || m_api==0) return false;
	CaplInstance* bp_type= NULL;
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_type, bp_type);
	CString  buf, tmp;
	if(bp_type)
		m_api->m_data.GetAttr(bp_type, m_api->m_bp_mgr.a_bp_type_name, buf);
	
	if(buf.CompareNoCase(" ")) return false;

	m_inst = inInst;
	
	CString sOrgName, sOrgId, sPrdId, sPrdName, sBPId, sBPName, sBPNum, 
		sAssortName, sZagotShap, sMaterName;
	
	// .
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_id, sBPId);
	
	/************************************************************************/
	/*                                              */
	/************************************************************************/
	aplExtent all_orgs, all_org_rels;		
	m_api->m_appr_mgr.GetAllSubOrganization(NULL,all_orgs);
	if(all_orgs.Size>0)
	{
		m_api->m_data.GetAttr(all_orgs[0], m_api->m_appr_mgr.a_org_id, sOrgId);
		m_api->m_data.GetAttr(all_orgs[0], m_api->m_appr_mgr.a_org_name, sOrgName);
	}
	int i=0;
	
	/************************************************************************/
	/*                                                */
	/************************************************************************/		
	
	FindPrd_and_Mater(inInst, m_api, sPrdId, sPrdName, sAssortName, sZagotShap, sMaterName);
	
	/************************************************************************/
	/*  -                                             */
	/************************************************************************/
	
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_id, sBPId);
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_name, sBPName);
	CaplInstance* bpVer= NULL;
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_act, bpVer);
	if(bpVer)
		m_api->m_data.GetAttr(bpVer, m_api->m_bp_mgr.a_bp_ver_num, sBPNum);	
	
	CRParamsArray RParams;
	RParams.Add("org_structure", sOrgName);
	RParams.Add("org_structure_id", sOrgId);
	RParams.Add("prd_id", sPrdId);
	RParams.Add("prd_name", sPrdName);
	RParams.Add("bp_id", sBPId);
	RParams.Add("bp_number", sBPNum);
	RParams.Add("bp_litera", m_sBpLit);
	RParams.Add("assort_name", sAssortName);
	RParams.Add("zagot_shap", sZagotShap);
	RParams.Add("prog_id","");
	RParams.Add("oper_descr","");
	RParams.Add("bp_name",sBPName);
	RParams.Add("mater_name", sMaterName);
	
	
	CaplReportMgr dict; dict.Init();
	CDataSource *data_source = &dict.m_data_source;
	dict.m_data_source.SetHeader(SetHeaderData());
	/************************************************************************/
	/*                                                      */
	/************************************************************************/
	aplExtent bp_opers, bp_oper_res, bp_pers, bp_per_res;
	
	INITIAL_PARAMS;//   
		
	CTableRow* row= NULL;
	//		m_api->m_bp_mgr.GetAllSubBP(inExtent[0], bp_opers);
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_elements, bp_opers);
	m_api->m_bp_mgr.LoadBPInfo(bp_opers);
	
	CaplInstance* mk_ok_char= m_api->m_charact_mgr.GetCharacteristicById("_");
	CaplInstance* tp_char= m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* zeh_char= m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* rr_char= m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* zone_char = m_api->m_charact_mgr.GetCharacteristicById("");
	aplExtent chars_ext, chars_group_ext;
	m_api->m_charact_mgr.FindAssociatedCharacteristic(bp_opers, chars_ext, chars_group_ext);
	int OS_num = 1, STP_num = 1;
	int oper_num = 0;
	
	if(IsWindow(m_progress))
	{
		m_progress->SetPos(0);
		m_progress->SetRange32(0, bp_opers.GetSize());
		m_progress->SetStep(1);
	}	

	for(i= 0; i<bp_opers.GetSize(); i++)
	{
		if(IsWindow(m_progress))
			m_progress->StepIt();
		sBPOperName= ""; sBPOperId= ""; sBPOperResId= ""; sBPOperResName= ""; sBPOperResVer= "";
		sBPPerId= ""; sBPPerDscr= ""; sBPPerResId= ""; sBPPerResName= "";
		sBPPerResVer=sOborudList= "";
		sMK= ""; sTP= ""; iBPOperIdNum= -1; iBPRepIdNum= -1;
		sOperDocId= ""; sPerDocId = ""; sPerType="", sZech = sZone = "", sRR = "";
		iPerTypeNum = -1;
		sMaterial="";
		
		m_api->m_data.GetAttr(bp_opers[i], m_api->m_bp_mgr.a_bp_type, bp_type);
		if(!bp_type) continue;
		m_api->m_data.GetAttr(bp_type, m_api->m_bp_mgr.a_bp_type_name, buf);
		if(	buf.CompareNoCase(" ")==0 || 
				buf.CompareNoCase("  ")==0)//      
		{
			//   
			aplExtent docs, rels;
			m_api->m_doc_mgr.FindAssociatedDocuments(bp_opers[i], docs, rels);
			m_api->m_doc_mgr.LoadDocInfo(docs);
			//     
			CString doc_id;
			for(int d=0; d<docs.Size; d++)
			{
				m_api->m_data.GetAttr(docs[d], m_api->m_doc_mgr.a_doc_id, doc_id);
				if(sOperDocId.IsEmpty())
					sOperDocId = doc_id;
				else if(!doc_id.IsEmpty())
					sOperDocId = sOperDocId+", "+doc_id;
			}
			m_api->m_data.GetAttr(bp_opers[i], m_api->m_bp_mgr.a_bp_id, sBPOperId);
			m_api->m_data.GetAttr(bp_opers[i], m_api->m_bp_mgr.a_bp_descr, sBPOperName);
			if(	buf.CompareNoCase(" ")==0)
			{
				sBPOperId.Format("%d",OS_num);
				iBPOperIdNum = OS_num;
				OS_num++;
			}
			else 
			{
				sBPOperId.Format("%d", STP_num);
				iBPOperIdNum = STP_num;
				STP_num++;
			}
			sBPOperResId = buf;
			sMK = sTP = "";
			bp_oper_res.Clear();
			m_api->m_bp_mgr.LoadAllBPResources(bp_opers[i], bp_oper_res);
			for(int j= 0; j<bp_oper_res.GetSize(); j++)
			{
				sBPPerResId= ""; sBPPerResName= ""; sBPPerResVer= "";
				sPerType = ""; iPerTypeNum = -1;
				sZech = "", sZone = "", sRR = "";
				CaplInstance* res_type= NULL;
				m_api->m_data.GetAttr(bp_oper_res[j], m_api->m_bp_mgr.a_bp_res_type, res_type);
				if(res_type)
				{
					m_api->m_data.GetAttr(res_type, m_api->m_bp_mgr.a_bp_res_type_name, sPerType);
					{
						CaplInstance* inst_item= NULL;
						m_api->m_data.GetAttr(bp_oper_res[j], m_api->m_bp_mgr.a_bp_res_object, inst_item);
						GetResourceName(inst_item, sBPPerResName, sBPPerResId, sBPPerResVer);
						iPerTypeNum = GetTypeNum(bp_oper_res[j], sPerType);
					}
				}
				ADD_ROW
					data_source->AddRow(row);					
			}
			
			if(bp_oper_res.GetSize()==0)
			{
				ADD_ROW
					data_source->AddRow(row);					
			}
		}
		continue;
	}
		
	CString sExePath;
	/************************************************************************/
	/*                                                       */
	/************************************************************************/
	HMODULE hModule;
	char szModuleName[2048];
	
	hModule = GetModuleHandle(NULL);
	if(hModule!=NULL)
	{
		if(GetModuleFileName(hModule, szModuleName, 2048)>0)
		{
			buf= szModuleName;
			sExePath = buf.Left(buf.ReverseFind('\\'));
		}
	}
	
	SaveToFile(&dict);
	
	return GenerateReport(&dict, &RParams, dot_file, report_file);
}

bool CaplExportTechDoc::GenTP(LPCTSTR dot_file, LPCTSTR report_file)
{
	if(inInst==0 || m_api==0) return false;
	CaplInstance* bp_type= NULL;
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_type, bp_type);
	CString  buf, tmp;
	if(bp_type)
		m_api->m_data.GetAttr(bp_type, m_api->m_bp_mgr.a_bp_type_name, buf);
	
	if(buf.CompareNoCase(" ")) return false;

	m_inst = inInst;
	
	CString sOrgName, sOrgId, sPrdId, sPrdName, sBPId, sBPName, sBPNum, 
		sAssortName, sZagotShap, sMaterName;
	
	// .
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_id, sBPId);
	
	/************************************************************************/
	/*                                              */
	/************************************************************************/
	aplExtent all_orgs, all_org_rels;		
	m_api->m_appr_mgr.GetAllSubOrganization(NULL,all_orgs);
	if(all_orgs.Size>0)
	{
		m_api->m_data.GetAttr(all_orgs[0], m_api->m_appr_mgr.a_org_id, sOrgId);
		m_api->m_data.GetAttr(all_orgs[0], m_api->m_appr_mgr.a_org_name, sOrgName);
	}
	int i=0;
	
	/************************************************************************/
	/*                                                */
	/************************************************************************/		
	
	FindPrd_and_Mater(inInst, m_api, sPrdId, sPrdName, sAssortName, sZagotShap, sMaterName);
	
	/************************************************************************/
	/*  -                                             */
	/************************************************************************/
	
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_id, sBPId);
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_name, sBPName);
	CaplInstance* bpVer= NULL;
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_act, bpVer);
	if(bpVer)
		m_api->m_data.GetAttr(bpVer, m_api->m_bp_mgr.a_bp_ver_num, sBPNum);	
	
	CRParamsArray RParams;
	RParams.Add("org_structure", sOrgName);
	RParams.Add("org_structure_id", sOrgId);
	RParams.Add("prd_id", sPrdId);
	RParams.Add("prd_name", sPrdName);
	RParams.Add("bp_id", sBPId);
	RParams.Add("bp_number", sBPNum);
	RParams.Add("bp_litera", m_sBpLit);
	RParams.Add("assort_name", sAssortName);
	RParams.Add("zagot_shap", sZagotShap);
	RParams.Add("prog_id","");
	RParams.Add("oper_descr","");
	RParams.Add("bp_name",sBPName);
	RParams.Add("mater_name", sMaterName);
	
	
	CaplReportMgr dict; dict.Init();
	CDataSource *data_source = &dict.m_data_source;
	dict.m_data_source.SetHeader(SetHeaderData());
	/************************************************************************/
	/*                                                      */
	/************************************************************************/
	aplExtent bp_opers, bp_oper_res, bp_pers, bp_per_res;
	
	INITIAL_PARAMS//   
		
		CTableRow* row= NULL;
	//		m_api->m_bp_mgr.GetAllSubBP(inExtent[0], bp_opers);
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_elements, bp_opers);
	m_api->m_bp_mgr.LoadBPInfo(bp_opers);
	
	CaplInstance* mk_ok_char= m_api->m_charact_mgr.GetCharacteristicById("_");
	CaplInstance* tp_char= m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* zeh_char= m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* rr_char= m_api->m_charact_mgr.GetCharacteristicById("");
	CaplInstance* zone_char = m_api->m_charact_mgr.GetCharacteristicById("");
	aplExtent chars_ext, chars_group_ext;
	m_api->m_charact_mgr.FindAssociatedCharacteristic(bp_opers, chars_ext, chars_group_ext);
	int OS_num = 1, STP_num = 1;
	int oper_num = 0;
	CaplInstance* bp_KP= NULL;	// 
	bp_KP = m_api->m_bp_mgr.GetBpTypeByName(" ");
	
	if(IsWindow(m_progress))
	{
		m_progress->SetPos(0);
		m_progress->SetRange32(0, bp_opers.GetSize());
		m_progress->SetStep(1);
	}	

	for(i= 0; i<bp_opers.GetSize(); i++)
	{
		if(IsWindow(m_progress))
			m_progress->StepIt();
		sBPOperName= ""; sBPOperId= ""; sBPOperResId= ""; sBPOperResName= ""; sBPOperResVer= "";
		sBPPerId= ""; sBPPerDscr= ""; sBPPerResId= ""; sBPPerResName= "";
		sBPPerResVer=sOborudList= "";
		sMK= ""; sTP= ""; iBPOperIdNum= -1; iBPRepIdNum= -1;
		sOperDocId= ""; sPerDocId = ""; sPerType="", sZech = sZone = "", sRR = "";
		iPerTypeNum = -1;
		sMaterial="";
		
		m_api->m_data.GetAttr(bp_opers[i], m_api->m_bp_mgr.a_bp_type, bp_type);
		if(!bp_type) continue;
		m_api->m_data.GetAttr(bp_type, m_api->m_bp_mgr.a_bp_type_name, buf);

		if(buf.CompareNoCase(""))// ,  
			continue;
		
		m_api->m_data.GetAttr(bp_opers[i], m_api->m_bp_mgr.a_bp_id, sBPOperId);
		m_api->m_data.GetAttr(bp_opers[i], m_api->m_bp_mgr.a_bp_name, sBPOperName);
		iBPOperIdNum= oper_num;
		oper_num++;
		
		for(int j= 0; j<chars_ext.GetSize(); j++)
		{
			CaplInstance* inst1= NULL, *inst2= NULL;
			m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_charact_val_item, inst1);
			m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_charact_val_charact, inst2);
			if(inst1==bp_opers[i] && mk_ok_char==inst2)
			{
				m_api->m_charact_mgr.PrintCharacteristicValue(chars_ext[j], NULL, sMK);
			}
			else if(inst1==bp_opers[i] && tp_char==inst2)
			{
				m_api->m_charact_mgr.PrintCharacteristicValue(chars_ext[j], NULL, sTP);					
			}
			else if(inst1==bp_opers[i] && zeh_char==inst2)
			{
				CaplInstance* inst;
				m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_reference_val, inst);
				m_api->m_categ_mgr.LoadCategoryInfo(inst);
				if(inst)
					m_api->m_data.GetAttr(inst, m_api->m_appr_mgr.a_org_descr, sZech);
			}
			else if(inst1==bp_opers[i] && rr_char==inst2)
			{
				m_api->m_charact_mgr.PrintCharacteristicValue(chars_ext[j], NULL, sRR);
			}
			else if(inst1==bp_opers[i] && zone_char==inst2)
			{
				CaplInstance* inst;
				m_api->m_data.GetAttr(chars_ext[j], m_api->m_charact_mgr.a_apl_reference_val, inst);
				m_api->m_categ_mgr.LoadCategoryInfo(inst);
				if(inst)
					m_api->m_data.GetAttr(inst, m_api->m_appr_mgr.a_org_descr, sZone);
			}
		}

		//  
		m_api->m_data.GetAttr(bp_opers[i], m_api->m_bp_mgr.a_bp_elements, bp_pers);
		m_api->m_bp_mgr.LoadBPInfo(bp_pers);
		int BpInd=0;
		for(int k=0; k<bp_pers.GetSize(); k++)
		{
			sBPPerId= ""; sBPPerDscr= ""; sBPPerResId= ""; sBPPerResName= ""; sBPPerResVer= "";
			iBPRepIdNum= -1;
			sPerDocId = ""; sPerType="";
			iPerTypeNum = 5;
			
			m_api->m_data.GetAttr(bp_pers[k], m_api->m_bp_mgr.a_bp_type, bp_type);
			if(!bp_type) continue;
			if(bp_type!=bp_KP) continue;
			BpInd++;
			iBPRepIdNum = BpInd;
			m_api->m_data.GetAttr(bp_pers[k], m_api->m_bp_mgr.a_bp_name, sBPPerDscr);
			m_api->m_data.GetAttr(bp_pers[k], m_api->m_bp_mgr.a_bp_descr, sBPPerId);
			ADD_ROW;
			data_source->AddRow(row);
		}
	}
		
	CString sExePath;
	/************************************************************************/
	/*                                                       */
	/************************************************************************/
	HMODULE hModule;
	char szModuleName[2048];
	
	hModule = GetModuleHandle(NULL);
	if(hModule!=NULL)
	{
		if(GetModuleFileName(hModule, szModuleName, 2048)>0)
		{
			buf= szModuleName;
			sExePath = buf.Left(buf.ReverseFind('\\'));
		}
	}
	
	SaveToFile(&dict);
	
	return GenerateReport(&dict, &RParams, dot_file, report_file);
}


bool CaplExportTechDoc::GenKK(LPCTSTR dot_file, LPCTSTR report_file)
{
	if(inInst==0 || m_api==0) return false;
	CaplInstance* bp_type= NULL;
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_type, bp_type);
	CString  buf, tmp;
	if(bp_type)
		m_api->m_data.GetAttr(bp_type, m_api->m_bp_mgr.a_bp_type_name, buf);
	
	if(buf.CompareNoCase(" ")) return false;

	m_inst = inInst;
	
	CString sOrgName, sOrgId, sPrdId, sPrdName, sBPId, sBPName, sBPNum, 
		sAssortName, sZagotShap, sMaterName;
	
	// .
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_id, sBPId);
	
	/************************************************************************/
	/*                                              */
	/************************************************************************/
	aplExtent all_orgs, all_org_rels;		
	m_api->m_appr_mgr.GetAllSubOrganization(NULL,all_orgs);
	if(all_orgs.Size>0)
	{
		m_api->m_data.GetAttr(all_orgs[0], m_api->m_appr_mgr.a_org_id, sOrgId);
		m_api->m_data.GetAttr(all_orgs[0], m_api->m_appr_mgr.a_org_name, sOrgName);
	}
	int i=0;
	
	/************************************************************************/
	/*                                                */
	/************************************************************************/		
	
	FindPrd_and_Mater(inInst, m_api, sPrdId, sPrdName, sAssortName, sZagotShap, sMaterName);
	
	/************************************************************************/
	/*  -                                             */
	/************************************************************************/
	
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_id, sBPId);
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_name, sBPName);
	CaplInstance* bpVer= NULL;
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_act, bpVer);
	if(bpVer)
		m_api->m_data.GetAttr(bpVer, m_api->m_bp_mgr.a_bp_ver_num, sBPNum);	
	
	CRParamsArray RParams;
	RParams.Add("org_structure", sOrgName);
	RParams.Add("org_structure_id", sOrgId);
	RParams.Add("prd_id", sPrdId);
	RParams.Add("prd_name", sPrdName);
	RParams.Add("bp_id", sBPId);
	RParams.Add("bp_number", sBPNum);
	RParams.Add("bp_litera", m_sBpLit);
	RParams.Add("assort_name", sAssortName);
	RParams.Add("zagot_shap", sZagotShap);
	RParams.Add("prog_id","");
	RParams.Add("oper_descr","");
	RParams.Add("bp_name",sBPName);
	RParams.Add("mater_name", sMaterName);

	CString pos, id, name, count, descr, type, stand, source, ver;
	double dCount;
	
	CaplReportMgr dict; dict.Init();
	CDataSource *data_source = &dict.m_data_source;
	data_source->SetHeader(SetKKHeaderData());

	CTableRow* row=NULL;
	if(IsWindow(m_progress))
	{
		m_progress->SetPos(0);
		m_progress->SetRange32(0, 1);
		m_progress->SetStep(1);
	}
	aplExtent ext, rels;
	m_api->m_prd_mgr.LoadAllSubProduct(NULL, NULL, m_pdf, rels, ext);
	CaplInstance *pdf, *prd;

 	CString sHardness, sSoj;
 	double dTo=0, dTv=0, dTpz=0, dTsht=0;

	for(i= 0; i<rels.GetSize(); i++)
	{	
		pos.Empty(); id.Empty(); name.Empty(); count.Empty(); descr.Empty(); type.Empty(); stand.Empty(); source.Empty(); ver.Empty();
		dCount=0;
		if(IsWindow(m_progress))
			m_progress->StepIt();
		if(rels[i]==NULL) continue;

		if(rels[i]->GetAccessmode()<=aplRO)
		{
			m_api->m_data.GetAttr(rels[i], m_api->m_prd_mgr.a_pdr_id, pos);
			m_api->m_data.GetAttrBN(rels[i], "value_component", dCount);
			count.Format("%f", dCount);
			if(count.Find(".")>-1)
			{
				count.TrimRight("0");
				count.TrimRight(".");
			}
			m_api->m_data.GetAttr(rels[i], m_api->m_prd_mgr.a_pdr_r_ted, pdf);
			if(pdf)
			{
				bool bStand;
				m_api->m_data.GetAttr(pdf, m_api->m_prd_mgr.a_pdf_id, ver);
				m_api->m_data.GetAttr(pdf, m_api->m_prd_mgr.a_apl_pdf_type, type);
				m_api->m_data.GetAttr(pdf, m_api->m_prd_mgr.a_apl_pdf_standard, bStand);
				if(bStand)
					stand = "yes";
				else
					stand = "no";
				m_api->m_data.GetAttr(pdf, m_api->m_prd_mgr.a_pdfwss_source, source);
				m_api->m_data.GetAttr(pdf, m_api->m_prd_mgr.a_pdf_prd, prd);
				if(prd && prd->GetAccessmode()<=aplRO)
				{
					m_api->m_data.GetAttr(prd, m_api->m_prd_mgr.a_prd_id, id);
					m_api->m_data.GetAttr(prd, m_api->m_prd_mgr.a_prd_name, name);
				}
			}
		}

		row = new CTableRow;
		row->AddColumn(pos);
		row->AddColumn(id);
		row->AddColumn(name);
		row->AddColumn(count);
		row->AddColumn(descr);
	
		row->AddColumn(type);
		row->AddColumn(stand);
		row->AddColumn(source);
		row->AddColumn(ver);
		
		data_source->AddRow(row);
	}
		
	CString sExePath;
	/************************************************************************/
	/*                                                       */
	/************************************************************************/
	HMODULE hModule;
	char szModuleName[2048];
	
	hModule = GetModuleHandle(NULL);
	if(hModule!=NULL)
	{
		if(GetModuleFileName(hModule, szModuleName, 2048)>0)
		{
			buf= szModuleName;
			sExePath = buf.Left(buf.ReverseFind('\\'));
		}
	}
	
	SaveToFile(&dict);
	
	return GenerateReport(&dict, &RParams, dot_file, report_file);
}

bool CaplExportTechDoc::GenKI(LPCTSTR dot_file, LPCTSTR report_file)
{
	if(!inInst || !m_api) return false;
	CaplInstance* bp_type= NULL;
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_type, bp_type);
	CString  buf, tmp;
	if(bp_type)
		m_api->m_data.GetAttr(bp_type, m_api->m_bp_mgr.a_bp_type_name, buf);
	
	if(buf.CompareNoCase("")) 
	{
		m_LastError = APL_LE_BADTYPE;
		return false;
	}
	
	CString sOrgName, sOrgId, sPrdId, sPrdName, sBPId, sBPName, sBPNum, 
		sAssortName, sZagotShap, sOperId, sOperName, sStanok, sMaterName, sOperDocuments;
	
	// .
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_id, sBPId);
	
	/************************************************************************/
	/*                                              */
	/************************************************************************/
	aplExtent all_orgs, all_org_rels;		
	m_api->m_appr_mgr.GetAllSubOrganization(NULL,all_orgs);
	if(all_orgs.Size>0)
	{
		m_api->m_data.GetAttr(all_orgs[0], m_api->m_appr_mgr.a_org_name, sOrgName);
		m_api->m_data.GetAttr(all_orgs[0], m_api->m_appr_mgr.a_org_id, sOrgId);
	}
	
	int i;
	
	/************************************************************************/
	/*                                                */
	/************************************************************************/		
	aplExtent prds, ext_bp_ref, ext_pear_bp;
	CaplInstance* pdf= NULL;		//   
	CaplInstance* pdf_mater= NULL;	//   
	CaplInstance* mf_rel= NULL;		// pdf & pdf_mater
	CaplInstance* p_bp= NULL;	// 
	CaplInstance* bp_KP= NULL;	// 
	bp_KP = m_api->m_bp_mgr.GetBpTypeByName(" ");
	
	if(m_inst==0)
	{
		m_api->m_bp_mgr.WhereUsedBP(inInst, ext_pear_bp);
		for(i= 0; i<ext_pear_bp.GetSize(); i++)
		{
			m_api->m_data.GetAttr(ext_pear_bp[i], m_api->m_bp_mgr.a_bp_type, bp_type);
			if(!bp_type) continue;
			m_api->m_data.GetAttr(bp_type, m_api->m_bp_mgr.a_bp_type_name, buf);
			if(!buf.CompareNoCase(" "))
			{
				p_bp= ext_pear_bp[i];
				break;
			}
		}
	}
	else
		p_bp = m_inst;
	
	FindPrd_and_Mater(p_bp, m_api, sPrdId, sPrdName, sAssortName, sZagotShap, sMaterName);
	
	/************************************************************************/
	/*  -                                             */
	/************************************************************************/
	m_api->m_bp_mgr.LoadBPInfo(p_bp);
	
	m_api->m_data.GetAttr(p_bp, m_api->m_bp_mgr.a_bp_id, sBPId);
	m_api->m_data.GetAttr(p_bp, m_api->m_bp_mgr.a_bp_name, sBPName);
	CaplInstance* bpVer= NULL;
	m_api->m_data.GetAttr(p_bp, m_api->m_bp_mgr.a_bp_act, bpVer);
	if(bpVer)
		m_api->m_data.GetAttr(bpVer, m_api->m_bp_mgr.a_bp_ver_num, sBPNum);	
	
	aplExtent bp_opers, bp_oper_res, bp_pers, bp_per_res;
	
	INITIAL_PARAMS;//   
	
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_name, sOperName);
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_id, sOperId);

	CRParamsArray RParams;
	RParams.Add("org_structure", sOrgName);
	RParams.Add("org_structure_id", sOrgId);
	RParams.Add("prd_id", sPrdId);
	RParams.Add("prd_name", sPrdName);
	RParams.Add("bp_id", sBPId);
	RParams.Add("bp_number", sBPNum);
	RParams.Add("bp_litera", m_sBpLit);
	RParams.Add("assort_name", sAssortName);
	RParams.Add("zagot_shap", sZagotShap);
	RParams.Add("bp_oper_id", sOperId);
	RParams.Add("bp_oper_name", sOperName);
	RParams.Add("oborud", sStanok);
	RParams.Add("mater_name", sMaterName);
	RParams.Add("oper_document",sOperDocuments);
	RParams.Add("bp_name",sBPName);

	CaplReportMgr dict; dict.Init();
	CDataSource *data_source = &dict.m_data_source;
	/************************************************************************/
	/*                                                      */
	/************************************************************************/	
	dict.m_data_source.SetHeader(SetHeaderData());
	CTableRow* row;
	
	//    
	m_api->m_data.GetAttr(inInst, m_api->m_bp_mgr.a_bp_elements, bp_pers);
	m_api->m_bp_mgr.LoadBPInfo(bp_pers);
	int BpInd=0;	

	for(i=0; i<bp_pers.GetSize(); i++)
	{
		sBPOperName= ""; sBPOperId= ""; sBPOperResId= ""; sBPOperResName= ""; sBPOperResVer= "";
		sBPPerId= ""; sBPPerDscr= ""; sBPPerResId= ""; sBPPerResName= ""; sBPPerResVer= "";
		sMK= ""; sTP= ""; iBPOperIdNum= -1; iBPRepIdNum= -1;
		sOperDocId= ""; sPerDocId = ""; sPerType="", sZone = "", sRR = "";
		iPerTypeNum = 5;

		m_api->m_data.GetAttr(bp_pers[i], m_api->m_bp_mgr.a_bp_type, bp_type);
		if(!bp_type) continue;
		if(bp_type!=bp_KP) continue;
		BpInd++;
		iBPRepIdNum = BpInd;
		m_api->m_data.GetAttr(bp_pers[i], m_api->m_bp_mgr.a_bp_name, sBPPerDscr);
		m_api->m_data.GetAttr(bp_pers[i], m_api->m_bp_mgr.a_bp_descr, sBPPerId);
		ADD_ROW;
		data_source->AddRow(row);
	}

	CString sExePath;
	/************************************************************************/
	/*                                                       */
	/************************************************************************/
	HMODULE hModule;
	char szModuleName[2048];
	
	hModule = GetModuleHandle(NULL);
	if(hModule!=NULL)
	{
		if(GetModuleFileName(hModule, szModuleName, 2048)>0)
		{
			buf= szModuleName;
			sExePath = buf.Left(buf.ReverseFind('\\'));
		}
	}
	
	SaveToFile(&dict);
	
	return GenerateReport(&dict, &RParams, dot_file, report_file);
}

CaplInstance*  CaplExportTechDoc::GetCharactValue(CaplInstance *item, CaplInstance *charact, aplExtent *ext, CString &val, bool bDelete)
{
	if(ext==NULL) return NULL;
	val.Empty();
	int cnt = ext->Size;
	CaplInstance* Ch;
	CaplInstance* ChVal, *ChItem;
	for(int i=0; i<cnt; i++)
	{
		ChVal = ext->GetAt(i);
		m_api->m_data.GetAttr(ChVal, m_api->m_charact_mgr.a_apl_charact_val_charact, Ch);
		if(Ch!=charact) continue;
		m_api->m_data.GetAttr(ChVal, m_api->m_charact_mgr.a_apl_charact_val_item, ChItem);
		if(ChItem!=item) continue;
		m_api->m_charact_mgr.PrintCharacteristicValue(ChVal, NULL, val);
		if(bDelete)
			ext->Remove(i);
		return ChVal;
	}

	return NULL;
}

CaplInstance*  CaplExportTechDoc::GetCharactValue(CaplInstance *item, CaplInstance *charact, aplExtent *ext, double &val, bool bDelete)
{
	if(ext==NULL) return NULL;
	val = 0;
	int cnt = ext->Size;
	CaplInstance* Ch;
	CaplInstance* ChVal, *ChItem;
	for(int i=0; i<cnt; i++)
	{
		ChVal = ext->GetAt(i);
		m_api->m_data.GetAttr(ChVal, m_api->m_charact_mgr.a_apl_charact_val_charact, Ch);
		if(Ch!=charact) continue;
		m_api->m_data.GetAttr(ChVal, m_api->m_charact_mgr.a_apl_charact_val_item, ChItem);
		if(ChItem!=item) continue;
		m_api->m_data.GetAttr(ChVal, m_api->m_charact_mgr.a_apl_charact_val_meas_val, val);		
		if(bDelete)
			ext->Remove(i);
		return ChVal;
	}

	return NULL;
}

bool CaplExportTechDoc::GenKP(LPCTSTR dot_file, LPCTSTR report_file)
{
	CaplReportMgr mgr;

	mgr.Init();

	mgr.m_data_source.SetHeader(new CHeader, true);
 	CString sHardness, sSoj;
 	double dTo=0, dTv=0, dTpz=0, dTsht=0;

	return GenerateReport(&mgr, dot_file, report_file);
}

bool CaplExportTechDoc::GenMaterialSpecification(LPCTSTR dot_file, LPCTSTR report_file)
{
	if(inInst==0 || m_api==0) return false;
	if(!m_api->m_data.IsConnected()) return false;

	if(!m_api->m_data.IsKindOf(inInst, m_api->m_prd_mgr.e_apl_pdf)) return false;

	m_api->m_categ_mgr.Load();

	//  .
	aplInstArray pdfs, units;
	aplRealArray counts;
	aplExtent Characts, gr, ext, rels;
	CaplInstance* DimensionsCharact = m_api->m_charact_mgr.GetCharacteristicById("");

	m_api->m_prd_mgr.DisassemblyProductEx(NULL, m_ContextFilter, inInst, pdfs, counts, units, &m_DateFilter, m_SNFilter);
	
	if(DimensionsCharact)
	{
		for(int i=0; i<pdfs.GetSize(); i++)
			ext.Add(pdfs[i]);
		m_api->m_charact_mgr.FindAssociatedCharacteristic(ext, Characts, gr);
	}

	CDataSource *pDataSource = NULL;
	CTableRow	*pRow = NULL;
	CaplReportMgr ReportMgr;
	ReportMgr.Init();
	pDataSource = &ReportMgr.m_data_source;
	pDataSource->SetHeader(SetMaterialSpecificationHeaderData());

	//     
	if(IsWindow(m_progress))
	{
		m_progress->SetPos(0);
		m_progress->SetRange32(0, pdfs.GetSize());
		m_progress->SetStep(1);
	}
	int cnt = pdfs.GetSize();

	CaplInstance *CurPdf = NULL, *CurPrd = NULL, *CurMaterial=NULL, *Profile = NULL;
	CaplInstance *Shape, *Unit;
	CaplInstance *Category, *SubCategory;

	CString PrdId, PrdName, PdfId, PrdDescr, PdfDescr;
	CString	Dimension, PdfType, PdfSource, PdfStand;
	CString	MaterialId, MaterialName, MaterialVerId, engineering_specification, MaterialDimensions;
	CString ProfileName, StandartName, BaseUnit, DeriveUnit, UnitName;
	double Amount, MaterialCountOnPrd, BaseAmount, DeriveAmount;
	CString CategoryId, CategoryName, SubCategoryId, SubCategoryName, buf;
	CString TypedSize;
	int Priority;
	bool	bStand;

	for(int i=0; i<cnt; i++)
	{
		PrdId.Empty(); PrdName.Empty(); PdfId.Empty(); PrdDescr.Empty(); PdfDescr.Empty();
		Dimension.Empty(); PdfType.Empty(); PdfSource.Empty(); UnitName.Empty();
		MaterialId.Empty(); MaterialName.Empty(); MaterialVerId.Empty(); engineering_specification.Empty();
		MaterialDimensions.Empty(); ProfileName.Empty(); StandartName.Empty(); PdfStand.Empty();
		CategoryId.Empty(); CategoryName.Empty(); SubCategoryId.Empty(); SubCategoryName.Empty();
		TypedSize.Empty();
		Priority = 0;
		Amount = 1;
		MaterialCountOnPrd = 1;
		BaseAmount = 1;
		DeriveAmount = 1;

		Category = NULL; SubCategory = NULL;

		CurPdf = pdfs[i];
		if(CurPdf==NULL)
		{
			if(IsWindow(m_progress))
				m_progress->StepIt();
			continue;
		}

		m_api->m_data.GetAttr(CurPdf, m_api->m_prd_mgr.a_pdf_prd, CurPrd);
		m_api->m_data.GetAttr(CurPdf, m_api->m_prd_mgr.a_pdf_id, PdfId);
		m_api->m_data.GetAttr(CurPdf, m_api->m_prd_mgr.a_pdf_descr, PdfDescr);
		m_api->m_data.GetAttr(CurPdf, m_api->m_prd_mgr.a_apl_pdf_type, PdfType);
		m_api->m_data.GetAttr(CurPdf, m_api->m_prd_mgr.a_pdfwss_source, PdfSource);
		m_api->m_data.GetAttr(CurPdf, m_api->m_prd_mgr.a_apl_pdf_standard, bStand);
		if(bStand)
			PdfStand = "yes";
		else
			PdfStand = "no";

		if(CurPrd)
		{
			m_api->m_data.GetAttr(CurPrd, m_api->m_prd_mgr.a_prd_id, PrdId);
			m_api->m_data.GetAttr(CurPrd, m_api->m_prd_mgr.a_prd_name, PrdName);
			m_api->m_data.GetAttr(CurPrd, m_api->m_prd_mgr.a_prd_descr, PrdDescr);
		}

		Amount = counts[i];

		// 
		if(DimensionsCharact)
		{
			CaplInstance *val, *charact, *item;
			for(int j=0; j<Characts.Size; j++)
			{
				val = Characts.GetAt(j);
				m_api->m_data.GetAttr(val, m_api->m_charact_mgr.a_apl_charact_val_charact, charact);
				if(charact!=DimensionsCharact) continue;
				m_api->m_data.GetAttr(val, m_api->m_charact_mgr.a_apl_charact_val_item, item);
				if(item!=CurPdf) continue;
				m_api->m_charact_mgr.PrintCharacteristicValue(val, NULL, Dimension);
				break;
			}
		}
		Unit = units[i];
		if(Unit)
			m_api->m_data.GetAttr(Unit, m_api->m_charact_mgr.a_apl_unit_id, UnitName);

		//  
		m_api->m_prd_mgr.LoadAllZagotov(CurPdf, rels, ext, false);
		for(int j=0; j<rels.Size; j++)
		{
			if(!m_api->m_data.IsKindOf(rels[j], m_api->m_prd_mgr.e_make_from)) continue;
			m_api->m_data.GetAttr(rels[j], m_api->m_prd_mgr.a_make_from_ranking, Priority);
			m_api->m_data.GetAttr(rels[j], m_api->m_prd_mgr.a_pdr_r_ted, CurMaterial);
			m_api->m_data.GetAttr(rels[j], m_api->m_prd_mgr.a_pdr_name, engineering_specification);
			m_api->m_data.GetAttr(rels[j], m_api->m_prd_mgr.a_pdr_id, MaterialDimensions);
			if(CurMaterial)
			{
				m_api->m_data.GetAttr(CurMaterial, m_api->m_prd_mgr.a_pdf_prd, CurPrd);
				m_api->m_data.GetAttr(CurMaterial, m_api->m_prd_mgr.a_pdf_id, MaterialVerId);
				m_api->m_data.GetAttr(CurPrd, m_api->m_prd_mgr.a_prd_id, MaterialId);
				m_api->m_data.GetAttr(CurPrd, m_api->m_prd_mgr.a_prd_name, MaterialName);

				//  
				aplExtent Categories;
				m_api->m_categ_mgr.GetProductCategories(CurPrd, Categories);
				// .   
				int z;
				for(z = 0; z<Categories.GetSize(); z++)
				{
					if(Categories[z]==NULL) continue;
					if(Categories[z]->GetAccessmode()>aplRO) continue;
					m_api->m_data.GetAttr(Categories[z], m_api->m_categ_mgr.a_categ_id, buf);
					if(buf.IsEmpty()) continue;
					if(buf[0]=='')
					{
						SubCategory = Categories[z];
						SubCategoryId = buf;
						m_api->m_data.GetAttr(Categories[z], m_api->m_categ_mgr.a_categ_name, SubCategoryName);
						break;
					}
				}
				Categories.Clear();
				//   .
				if(SubCategory)
				{
					m_api->m_categ_mgr.GetAllParentCategory(SubCategory, Categories);
					for(z = 0; z<Categories.GetSize(); z++)
					{
						if(Categories[z]==NULL) continue;
						if(Categories[z]->GetAccessmode()>aplRO) continue;
						m_api->m_data.GetAttr(Categories[z], m_api->m_categ_mgr.a_categ_id, buf);
						if(buf.IsEmpty()) continue;
						if(buf[0]=='')
						{
							SubCategory = Categories[z];
							SubCategoryId = buf;
							m_api->m_data.GetAttr(Categories[z], m_api->m_categ_mgr.a_categ_name, SubCategoryName);
							break;
						}
					}
				}
				Categories.Clear();
				if(SubCategory)
				{
					m_api->m_categ_mgr.GetAllParentCategory(SubCategory, Categories);
					for(z = 0; z<Categories.GetSize(); z++)
					{
						if(Categories[z]==NULL) continue;
						if(Categories[z]->GetAccessmode()>aplRO) continue;
						m_api->m_data.GetAttr(Categories[z], m_api->m_categ_mgr.a_categ_id, buf);
						if(buf.IsEmpty()) continue;
						if(buf[0]=='')
						{
							Category = Categories[z];
							CategoryId = buf;
							m_api->m_data.GetAttr(Categories[z], m_api->m_categ_mgr.a_categ_name, CategoryName);
							break;
						}
					}
				}
			}
			m_api->m_data.GetAttr(rels[j], m_api->m_prd_mgr.a_make_from_assortment, Profile);
			if(Profile)
			{
				m_api->m_data.GetAttr(Profile, m_api->m_prd_mgr.a_assortment_std, StandartName);
				m_api->m_data.GetAttr(Profile, m_api->m_prd_mgr.a_assortment_shape, Shape);
				if(Shape)
				{
					m_api->m_data.GetAttr(Shape, m_api->m_prd_mgr.a_assortment_shape_id, ProfileName);
				}
			}
			m_api->m_data.GetAttr(rels[j], m_api->m_prd_mgr.a_make_from_value, BaseAmount);
			m_api->m_data.GetAttr(rels[j], m_api->m_prd_mgr.a_make_from_derive_value, DeriveAmount);
			m_api->m_data.GetAttr(rels[j], m_api->m_prd_mgr.a_make_from_unit, Unit);
			if(Unit)
				m_api->m_data.GetAttr(Unit, m_api->m_charact_mgr.a_apl_unit_id, BaseUnit);
			m_api->m_data.GetAttr(rels[j], m_api->m_prd_mgr.a_make_from_derive_unit, Unit);
			if(Unit)
				m_api->m_data.GetAttr(Unit, m_api->m_charact_mgr.a_apl_unit_id, DeriveUnit);
			pRow = new CTableRow;
			
			pRow->AddColumn(PrdId);
			pRow->AddColumn(PrdName);
			pRow->AddColumn(PrdDescr);
			pRow->AddColumn(PdfId);
			pRow->AddColumn(PdfDescr);
			pRow->AddColumn(PdfType);
			pRow->AddColumn(PdfSource);
			pRow->AddColumn(PdfStand);
			pRow->AddColumn(Amount);
			pRow->AddColumn(UnitName);
			pRow->AddColumn(Dimension);
			pRow->AddColumn(Priority);
			pRow->AddColumn(MaterialId);
			pRow->AddColumn(MaterialName);
			pRow->AddColumn(MaterialVerId);
			pRow->AddColumn(engineering_specification);
			pRow->AddColumn(ProfileName);
			pRow->AddColumn(StandartName);
			pRow->AddColumn(MaterialDimensions);
			pRow->AddColumn(BaseAmount);
			pRow->AddColumn(BaseUnit);
			pRow->AddColumn(DeriveAmount);
			pRow->AddColumn(DeriveUnit);
			if(DeriveAmount!=0)
			{
				MaterialCountOnPrd = Amount/DeriveAmount*BaseAmount;
				pRow->AddColumn(MaterialCountOnPrd);
			}
			else
				pRow->AddColumn("!!!!!!!");
			
			pRow->AddColumn(CategoryId);
			pRow->AddColumn(CategoryName);
			pRow->AddColumn(SubCategoryId);
			pRow->AddColumn(SubCategoryName);
			TypedSize = MaterialDimensions;
			buf = TypedSize;
			if(buf.CompareNoCase("/")!=0)
			{
				int ind = buf.Find("/");
				TypedSize = buf.Left(ind>-1 ? ind : buf.GetLength());
			}
			pRow->AddColumn(TypedSize);
			
			if(pDataSource->AddRow(pRow)<0)
			{
				delete pRow;
				ASSERT(0);
			}
			pRow = NULL;
		}
		if(rels.GetSize()==0)
		{
			pRow = new CTableRow;
			
			pRow->AddColumn(PrdId);
			pRow->AddColumn(PrdName);
			pRow->AddColumn(PrdDescr);
			pRow->AddColumn(PdfId);
			pRow->AddColumn(PdfDescr);
			pRow->AddColumn(PdfType);
			pRow->AddColumn(PdfSource);
			pRow->AddColumn(PdfStand);
			pRow->AddColumn(Amount);
			pRow->AddColumn(UnitName);
			pRow->AddColumn(Dimension);
			pRow->AddColumn("");
			pRow->AddColumn("");
			pRow->AddColumn("");
			pRow->AddColumn("");
			pRow->AddColumn("");
			pRow->AddColumn("");
			pRow->AddColumn("");
			pRow->AddColumn("");
			pRow->AddColumn("");
			pRow->AddColumn("");
			pRow->AddColumn("");
			pRow->AddColumn("");
			pRow->AddColumn("");
			
			pRow->AddColumn(CategoryId);
			pRow->AddColumn(CategoryName);
			pRow->AddColumn(SubCategoryId);
			pRow->AddColumn(SubCategoryName);
			TypedSize = MaterialDimensions;
			buf = TypedSize;
			if(buf.CompareNoCase("/")!=0)
			{
				int ind = buf.Find("/");
				TypedSize = buf.Left(ind>-1 ? ind : buf.GetLength());
			}
			pRow->AddColumn(TypedSize);

			if(pDataSource->AddRow(pRow)<0)
			{
				delete pRow;
				ASSERT(0);
			}
			pRow = NULL;
		}


		if(IsWindow(m_progress))
			m_progress->StepIt();
	}

	CRParamsArray params;

	CaplInstance* prd;
	m_api->m_data.GetAttr(inInst, m_api->m_prd_mgr.a_pdf_prd, prd);
	if(prd)
	{
		CString code;
		m_api->m_data.GetAttr(prd, m_api->m_prd_mgr.a_prd_id, m_sPrdId);
		m_api->m_data.GetAttr(prd, m_api->m_prd_mgr.a_prd_name, m_sPrdName);
		m_api->m_data.GetAttr(prd, m_api->m_prd_mgr.a_prd_code, code);

		params.Add("prd_id", m_sPrdId);
		params.Add("prd_name", m_sPrdName);
		params.Add("prd_code", code);
	}
	
	return GenerateReport(&ReportMgr, &params, dot_file, report_file, &m_api->m_data);
}

CHeader* CaplExportTechDoc::SetMaterialSpecificationHeaderData(CHeader *hd)
{
	CHeader* header = hd;
	if(hd==0)
		header = new CHeader(NULL);
	
	header->AddColumn("prd_id",						aplSTRING);
	header->AddColumn("prd_name",					aplSTRING);
	header->AddColumn("prd_descr",					aplSTRING);
	header->AddColumn("pdf_id",						aplSTRING);
	header->AddColumn("pdf_descr",					aplSTRING);
	header->AddColumn("pdf_type",					aplSTRING);
	header->AddColumn("pdf_source",					aplSTRING);
	header->AddColumn("pdf_standart",				aplSTRING);
	header->AddColumn("count_on_prd",				aplREAL);
	header->AddColumn("unit",						aplSTRING);
	header->AddColumn("size",						aplSTRING);
	header->AddColumn("priority",					aplINTEGER);
	header->AddColumn("material_id",				aplSTRING);
	header->AddColumn("material_name",				aplSTRING);
	header->AddColumn("material_ver_id",			aplSTRING);
	header->AddColumn("engineering_specification",	aplSTRING);
	header->AddColumn("material_profile",			aplSTRING);
	header->AddColumn("material_standart",			aplSTRING);
	header->AddColumn("material_size",				aplSTRING);
	header->AddColumn("material_basis_amount",		aplREAL);
	header->AddColumn("material_basis_unit",		aplSTRING);
	header->AddColumn("material_derivable_amount",	aplREAL);
	header->AddColumn("material_derivable_unit",	aplSTRING);
	header->AddColumn("material_count_on_prd",		aplREAL);
	
	header->AddColumn("Category_Id",				aplSTRING);
	header->AddColumn("Category_Name",				aplSTRING);
	header->AddColumn("SubCategory_Id",				aplSTRING);
	header->AddColumn("SubCategory_Name",			aplSTRING);

	header->AddColumn("",		aplSTRING);

	return header;
}
