// aplExportTechDoc.h: interface for the CaplExportTechDoc class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_APLEXPORTTECHDOC_H__A92E2A18_27A2_4B99_A40F_910728C7E4EE__INCLUDED_)
#define AFX_APLEXPORTTECHDOC_H__A92E2A18_27A2_4B99_A40F_910728C7E4EE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "apl_api.h"
#include "ReportDict.h"

#define INITIAL_PARAMS \
	double	dRR_Tsht=0, dRR_Tpz=0, dRR_L=0, dRR_t=0, dRR_i=0, dRR_s=0, dRR_n=0,\
	dRR_v=0, dResPerCount=0;\
		CString sBPOperName, sBPOperId, sBPOperResId, sBPOperResName, sBPOperResVer, \
		sBPPerId, sBPPerDscr, sBPPerResId, sBPPerResName, sBPPerResVer, sMK, sTP, \
		sOperDocId, sPerDocId, sPerType, sZech, sZone, sRR, sMaterial, sOborudList, \
		sResPerUnit, sVPK, sResBPperPos, sSoj, sHardness;\
		int iBPOperIdNum=0, iBPRepIdNum=0, iPerTypeNum=5;\
		CString sObiem, sPI, sRm, sTo, sTv, sTpz, sTsht;\
		CString sDiametr, sDlina, sGlubina, sPerehodu, sPodacha, sShpindel, sSkorost, sTotv;\
		

#define ADD_ROW 	\
						row= new CTableRow;\
						row->AddColumn(sHardness);\
						row->AddColumn(sTo);\
						row->AddColumn(sTv);\
						row->AddColumn(sTpz);\
						row->AddColumn(sTsht);\
						row->AddColumn(sSoj);\
						row->AddColumn(sRm);\
						row->AddColumn(sBPOperId);\
						row->AddColumn(iBPOperIdNum);\
						row->AddColumn(sBPOperName);\
						row->AddColumn(sZech);\
						row->AddColumn(sZone);\
						row->AddColumn(sMaterial);\
						row->AddColumn(sOperDocId);\
						row->AddColumn(sBPOperResId);\
						row->AddColumn(sBPOperResName);\
						row->AddColumn(sBPOperResVer);\
						row->AddColumn(sRR);\
						row->AddColumn(sBPPerId);\
						row->AddColumn(iBPRepIdNum);\
						row->AddColumn(sBPPerDscr);\
						row->AddColumn(sResBPperPos);\
						row->AddColumn(sBPPerResId);\
						row->AddColumn(sBPPerResName);\
						row->AddColumn(sBPPerResVer);\
						row->AddColumn(dResPerCount);\
						row->AddColumn(sResPerUnit);\
						row->AddColumn(sPerDocId);\
						row->AddColumn(sPerType);\
						row->AddColumn(iPerTypeNum);\
						row->AddColumn(sOborudList);\
						row->AddColumn(sMK);\
						row->AddColumn(sTP);\
						row->AddColumn(dRR_Tpz);\
						row->AddColumn(dRR_Tsht);\
						row->AddColumn(dRR_L);\
						row->AddColumn(dRR_t);\
						row->AddColumn(dRR_i);\
						row->AddColumn(dRR_s);\
						row->AddColumn(dRR_n);\
						row->AddColumn(dRR_v);\
						row->AddColumn(sVPK);\
						row->AddColumn(sDiametr);\
						row->AddColumn(sDlina);\
						row->AddColumn(sGlubina);\
						row->AddColumn(sPerehodu);\
						row->AddColumn(sPodacha);\
						row->AddColumn(sShpindel);\
						row->AddColumn(sSkorost);\
						row->AddColumn(sObiem);\
						row->AddColumn(sPI);\
						row->AddColumn(sTotv);

#define APL_LE_BADTYPE	1
#define APL_LE_NOT_OK	2

typedef struct 
{
	BOOL ExMK;
	BOOL ExOK;
	BOOL ExVO;
	BOOL ExVOb;
	BOOL ExVM;
	BOOL ExTL;
	BOOL ExOS;
	BOOL ExTP;
	BOOL ExKI;
	BOOL ExKK;
	BOOL ExKP;
	CString TP_dot;
	CString TL_dot;
	CString MK_dot;
	CString OK_dot;
	CString OK_OGT_dot;
	CString VO_dot;
	CString VOb_dot;
	CString VM_dot;
	CString OS_dot;
	CString KI_dot;
	CString KK_dot;
	CString KP_dot;
} TDotsData;

class CaplExportTechDoc  
{
protected:
	CaplInstance*	m_inst;
	CaplInstance*	m_prd;
	CaplInstance*	m_pdf;
	CString m_sPrdId;
	CString m_sPrdName;
	CString m_sAssortName;
	CString m_sZagotShap;
	CString m_sMaterName;
	CString m_sBpLit;
	bool m_IsFindedPrdAndMater;
	int m_LastError;
	BOOL bGenIfOK;
	BOOL bIsOGT;

public:
	bool GenMaterialSpecification(LPCTSTR dot_file, LPCTSTR report_file);
	bool GenKP(LPCTSTR dot_file, LPCTSTR report_file);
	CaplInstance* GetCharactValue(CaplInstance *item, CaplInstance* charact, aplExtent *ext, CString &val, bool bDelete=false);
	CaplInstance*  GetCharactValue(CaplInstance *item, CaplInstance *charact, aplExtent *ext, double &val, bool bDelete=false);
	int GetLastError();
	bool FindString(CString str, CStringArray* array);
	bool GenTechDocs(LPCTSTR report_file, TDotsData data);

	static CHeader *SetHeaderData(CHeader* hd = NULL);
	static CHeader* SetKKHeaderData(CHeader* hd = NULL);
	static CHeader* SetMaterialSpecificationHeaderData(CHeader* hd = NULL);

	bool GetResourceName(CaplInstance* inst_item, CString &name, CString &id, CString &ver);
	int GetTypeNum(CaplInstance* inst, CString &sPerType);
	bool Perehod(CaplReportMgr* mgr, CaplInstance* oper, CaplAPI* api, CString sBPOperId, 
				 int iBPOperIdNum, CString sBPOperName, CString sBPOperResId, CString sBPOperResName,
				 CString sBPOperResVer, CString sMK, CString sTP, CString sOperDocId, CString sZone, 
				 CString sMaterial, CString sRR, CString sZech, CString sOborudList, CString sHardness, 
				 CString sTo, CString sTv, CString sTpz, CString sTsht, CString sSoj, CString sRm, CString RType="mk");

	bool GenKI(LPCTSTR dot_file, LPCTSTR report_file);
	bool GenVO(LPCTSTR dot_file, LPCTSTR report_file);
	bool GenMK(LPCTSTR dot_file, LPCTSTR report_file);
	bool GenOK(LPCTSTR dot_file, LPCTSTR report_file);
	bool GenVOb(LPCTSTR dot_file, LPCTSTR report_file);
	bool GenKK(LPCTSTR dot_file, LPCTSTR report_file);
	bool GenTP(LPCTSTR dot_file, LPCTSTR report_file);
	bool GenOS(LPCTSTR dot_file, LPCTSTR report_file);
	bool GenTL(LPCTSTR dot_file, LPCTSTR report_file);
	
	bool FindPrd_and_Mater(	CaplInstance* bp, CaplAPI* api, CString &sPrdId, CString &sPrdName, 
						CString &sAssortName, CString &sZagotShap, CString &sMaterName);
	CaplExportTechDoc(CaplAPI* api);
	virtual ~CaplExportTechDoc();

	CaplAPI* m_api;
	CaplInstance* inInst;
	
	CProgressCtrl*	m_progress;
	CEdit*			m_edit;
	
	COleDateTime	m_DateFilter;
	CaplInstance*	m_ContextFilter;
	CString			m_SNFilter;
};

#endif // !defined(AFX_APLEXPORTTECHDOC_H__A92E2A18_27A2_4B99_A40F_910728C7E4EE__INCLUDED_)
