// export2dlg.cpp : implementation file
//

#include "stdafx.h"
#include "export2dlg.h"
#include "ExportKTSDlg.h"
#include <math.h>
#include "ExportTDDlg.h"

#include "apl_api.h"
#include "ReportDict.h"
#include "CommonQuery.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExport2Dlg dialog
/*
Template_item templates2[] = { Template_item("1   2.104-68", "_1 __2.104-68.apldot"), 
								Template_item("2   2.104-68", "_2 __2.104-68.apldot"),
								Template_item(" 1", "_2.108-68__2_().apldot"),
								Template_item(" 2", "_2.108-68__2_()_2.apldot")
							};
*/
CExport2Dlg::CExport2Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExport2Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExport2Dlg)
	m_csContext = _T("");
	m_csDateTime = _T("");
	m_csPrdId = _T("");
	m_csPrdName = _T("");
	m_csSerNo = _T("");
	m_csVer = _T("");
	m_bUseAuxMats = FALSE;
	m_csOutPath = _T("");
	//}}AFX_DATA_INIT

	m_pdf		=NULL;
	m_ciContext	=NULL;
	m_Date.SetStatus(COleDateTime::invalid);
}


void CExport2Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExport2Dlg)
	DDX_Control(pDX, IDC_CB_TEMPLATES, m_cbTemplates);
	DDX_Control(pDX, IDCANCEL, m_Cancelbutton);
	DDX_Control(pDX, IDOK, m_OKbutton);
	DDX_Text(pDX, IDC_E_CONTEXT, m_csContext);
	DDX_Text(pDX, IDC_E_DATETIME, m_csDateTime);
	DDX_Text(pDX, IDC_E_PRD_ID, m_csPrdId);
	DDX_Text(pDX, IDC_E_PRD_NAME, m_csPrdName);
	DDX_Text(pDX, IDC_E_SERNO, m_csSerNo);
	DDX_Text(pDX, IDC_E_VER, m_csVer);
	DDX_Check(pDX, IDC_C_USE_AUX_MATS, m_bUseAuxMats);
	DDX_Text(pDX, IDC_E_OUT_FILE_PATH, m_csOutPath);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CExport2Dlg, CDialog)
	//{{AFX_MSG_MAP(CExport2Dlg)
	ON_BN_CLICKED(IDC_B_SET_FILTER, OnBSetFilter)
	ON_BN_CLICKED(IDC_B_SEL_REP_FILE, OnBSelRepFile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


bool CExport2Dlg::MakeTable(CaplInstance* ciPdf,CaplInstance* ciContext,aplInstArray& aiPdfs,
							aplRealArray& arCounts,aplInstArray& aiUnits,COleDateTime* dt,
							const char* sn)
{
	aplInstArray	ai_iPdfs,ai_iUnits;
	aplRealArray	ar_iCounts;

	aplInstArray	ai_iPdfsM,ai_iUnitsM;
	aplRealArray	ar_iCountsM;

	aplExtent		aeRels;

	CaplInstance*	cit					=NULL;
	CaplInstance*	cit2				=NULL;
	CaplInstance*	cit3				=NULL;
	CaplInstance*	cit4				=NULL;
	CaplInstance*	cit5				=NULL;

	CaplMap			cmMapInst2Units;
	CaplMap*		cmt					=NULL;

	CString			cst;

	int				i,j,it=0,it2=0;
	double			temp_d=0,temp_d2=0,val=0,der_val=0;
	double*			temp_dp				=NULL;

//	ai_iPdfs.AutoKillReference=true;
	ai_iPdfs.ListMode=true;
//	ai_iUnits.AutoKillReference=true;
	ai_iUnits.ListMode=true;

	if(false==m_api->m_prd_mgr.DisassemblyProductEx(NULL,ciContext,ciPdf,ai_iPdfs,ar_iCounts,ai_iUnits,dt,sn,false))
		return false;

	//	m_bUseAuxMats==TRUE		-	  -  -   . , 
	//								  -  LoadAllZagotov   .
	//	m_bUseAuxMats==FALSE	-	   LoadAllZagotov   .

	cmMapInst2Units.bAutoSort=true;

	TRACE("size i %d u %d c %d\n",ai_iPdfs.GetSize(),ai_iUnits.GetSize(),ar_iCounts.GetSize());

	if(TRUE==m_bUseAuxMats)
	{
		for(i=0;i<ai_iPdfs.GetSize();)
		{
			cit=ai_iPdfs.GetAt(i);
			m_api->m_data.GetAttr(cit,m_api->m_prd_mgr.a_apl_pdf_type,cst);
			if(cst=="material")
			{
				ai_iPdfsM.Add(cit);
				ai_iUnitsM.Add(ai_iUnits.GetAt(i));
				ar_iCountsM.Add(ar_iCounts.GetAt(i));

				ai_iPdfs.Remove(i);ai_iUnits.Remove(i);ar_iCounts.RemoveAt(i);
			}
			else
				i++;
		}

		//	   
		for(i=0;i<ai_iPdfsM.GetSize();i++)
		{
			cit=ai_iPdfsM.GetAt(i);
			//	 
			m_api->m_data.GetAttr(cit,m_api->m_prd_mgr.a_apl_pdf_type,cst);
			//	  -   . 
			if(cst=="material")
			{
				cit2=ai_iUnitsM.GetAt(i);
				temp_d=ar_iCountsM.GetAt(i);
				//	
				it=cmMapInst2Units.QFindByIn((long)cit);
				//	  - 
				if(-1==it)
				{
					cmt=new CaplMap;
					cmt->bAutoSort=true;

					temp_dp=new double;
					*temp_dp=temp_d;
					cmt->Add((long)cit2,(long)temp_dp);
					cmMapInst2Units.Add((long)cit,(long)cmt);
				}	
				//	 -  unit
				else
				{
					cmt=(CaplMap*)cmMapInst2Units[it].out;
					it2=cmt->QFindByIn((long)cit2);
					//	 unit-a  - 
					if(-1==it2)
					{
						temp_dp=new double;
						*temp_dp=temp_d;
						cmt->Add((long)cit2,(long)temp_dp);
					}
					//	 -  
					else
					{
						temp_dp=(double*)(((*cmt)[it2]).out);
						*temp_dp+=temp_d;
					}
				}
				cmt=NULL;
			}
		}
		TRACE("1st map size after mats copy %d\n",cmMapInst2Units.Size);
	}

	//	  - -
	//	    
	LoadAllZagotov(*m_api,ai_iPdfs);

	m_api->m_data.GetEntityExtent(m_api->m_prd_mgr.e_make_from,aeRels);

	//	   
	for(i=0;i<aeRels.GetSize();i++)
	{
		cit=NULL;cit2=NULL;cit3=NULL;cit4=NULL;
		cit=aeRels.GetAt(i);
		m_api->m_data.GetAttr(cit,m_api->m_prd_mgr.a_pdr_r_ting,cit2);
		if(NULL==cit2)
			continue;

		m_api->m_data.GetAttr(cit,m_api->m_prd_mgr.a_pdr_r_ted,cit3);
		if(NULL==cit3)
			continue;
		
		//	  -
		for(j=0;j<ai_iPdfs.GetSize();j++)
		{
			cit4=ai_iPdfs.GetAt(j);
			if(cit4==cit2)
			{
				it=0;it2=0;
				der_val=0;val=0;temp_d2=0;temp_d=0;
				cit5=NULL;
				cmt=NULL;

				m_api->m_data.GetAttr(cit,m_api->m_prd_mgr.a_make_from_unit,cit5);
				m_api->m_data.GetAttr(cit,m_api->m_prd_mgr.a_make_from_value,val);
				m_api->m_data.GetAttr(cit,m_api->m_prd_mgr.a_make_from_derive_value,der_val);
				temp_d=ar_iCounts.GetAt(j);

				if(der_val==0)
					der_val=1;
				temp_d2=temp_d/der_val;
				temp_d=ceil(temp_d2)*val;

				it=cmMapInst2Units.QFindByIn((long)cit3);
				//	  - 
				if(-1==it)
				{
					cmt=new CaplMap;
					cmt->bAutoSort=true;

					temp_dp=new double;
					*temp_dp=temp_d;
					cmt->Add((long)cit5,(long)temp_dp);
					cmMapInst2Units.Add((long)cit3,(long)cmt);
				}
				//	 -  unit
				else
				{
					cmt=(CaplMap*)cmMapInst2Units[it].out;
					it2=cmt->QFindByIn((long)cit5);
					//	 unit-a  - 
					if(-1==it2)
					{
						temp_dp=new double;
						*temp_dp=temp_d;
						cmt->Add((long)cit5,(long)temp_dp);
					}
					//	 -  
					else
					{
						temp_dp=(double*)(((*cmt)[it2]).out);
						*temp_dp+=temp_d;
					}
				}
			}
		}
	}

	TRACE("1st map size after non-mats processing %d\n",cmMapInst2Units.Size);

	//	   
	for(i=0;i<cmMapInst2Units.Size;i++)
	{
		cit=(CaplInstance*)cmMapInst2Units[i].in;
		cmt=(CaplMap*)cmMapInst2Units[i].out;
		for(j=0;j<cmt->Size;j++)
		{
			cit2=(CaplInstance*)(((*cmt)[j]).in);
			temp_dp=(double*)(((*cmt)[j]).out);

			aiPdfs.Add(cit);
			aiUnits.Add(cit2);
			arCounts.Add(*temp_dp);
		}
	}

	//	
	for(i=0;i<cmMapInst2Units.Size;i++)
	{
		cmt=(CaplMap*)cmMapInst2Units[i].out;
		for(j=0;j<cmt->Size;j++)
		{
			temp_dp=(double*)(((*cmt)[j]).out);
			delete temp_dp;temp_dp=NULL;
		}
		delete cmt;cmt=NULL;
	}

//	//   
//	aplExtent  ext0;
//	m_api->m_data.GetEntityExtent(m_api->m_prd_mgr.e_make_from,ext0);
//	for(i=0;i<ext0.Size;i++)
//	{
//		CaplInstance *inst0;
//		m_api->m_data.GetAttr(ext0[i],m_api->m_prd_mgr.a_pdr_r_ting,inst0);
//		if(inst0!=0)
//		{
//			/*if(inst0==pdf)
//			{
//				m_data->GetAttr(ext0[i],m_api->m_prd_mgr.a_pdr_r_ted,inst0);
//				if(inst0!=0)
//				{
//					ext_rel.Add(ext0[i]);
//					ext_pdf.Add(inst0);
//				}
//			}*/
//		}
//	}

	return true;
}

bool CExport2Dlg::LoadAllZagotov(CaplAPI &api,aplInstArray& ext_Arr)
{
	if(!api.m_data.IsConnected()) return true;
	
	//   
	CaplLoadData ld(&(api.m_data),DEF_SOURCE);
	int i,i1,i8,i12;

	for(i=0;i<ext_Arr.Size;i++)
	{
		if (ext_Arr[i]->GetId()==0) continue;
		if (ext_Arr[i]->GetType()==0) continue;
		ld.AddQuery(0,ext_Arr[i]);
	}

	if(ld.IsQueryNotEmpty())
	{
		i1=	ld.AddQuery('r', 0, api.m_prd_mgr.e_make_from, api.m_prd_mgr.a_pdr_r_ting, true);
			ld.AddQuery('d', i1, 0, api.m_prd_mgr.a_pdr_r_ting, true);
			ld.AddQuery('d', i1, 0, api.m_prd_mgr.a_pdr_id, true);
			ld.AddQuery('d', i1, 0, api.m_prd_mgr.a_pdr_name, true);
			ld.AddQuery('d', i1, 0, api.m_prd_mgr.a_pdr_descr, true);
			ld.AddQuery('d', i1, 0, api.m_prd_mgr.a_pdr_frames_of_reference, true);
			ld.AddQuery('d', i1, 0, api.m_prd_mgr.a_pdr_inner_id, true);

			ld.AddQuery('d', i1, 0, api.m_prd_mgr.a_make_from_ranking, true);
			ld.AddQuery('d', i1, 0, api.m_prd_mgr.a_make_from_ranking_rationale, true);
			ld.AddQuery('d', i1, 0, api.m_prd_mgr.a_make_from_value, true);
			ld.AddQuery('d', i1, 0, api.m_prd_mgr.a_make_from_unit, true);
			ld.AddQuery('d', i1, 0, api.m_prd_mgr.a_make_from_derive_value, true);
			ld.AddQuery('d', i1, 0, api.m_prd_mgr.a_make_from_derive_unit, true);
			ld.AddQuery('d', i1, 0, api.m_prd_mgr.a_make_from_assortment, true);
			ld.AddQuery('d', i1, 0, api.m_prd_mgr.a_make_from_param, true);

		i8=	ld.AddQuery('d', i1, 0, api.m_prd_mgr.a_pdr_r_ted, true);
			ld.AddQuery('d', i8, 0, api.m_prd_mgr.a_pdf_id, true);
			ld.AddQuery('d', i8, 0, api.m_prd_mgr.a_pdf_descr, true);
			ld.AddQuery('d', i8, 0, api.m_prd_mgr.a_apl_pdf_unit, true);
			ld.AddQuery('d', i8, 0, api.m_prd_mgr.a_pdf_code, true);
			ld.AddQuery('d', i8, 0, api.m_prd_mgr.a_pdf_code1, true);
			ld.AddQuery('d', i8, 0, api.m_prd_mgr.a_pdf_code2, true);
			ld.AddQuery('d', i8, 0, api.m_prd_mgr.a_apl_pdf_type, true);
			ld.AddQuery('d', i8, 0, api.m_prd_mgr.a_apl_pdf_standard, true);
		i12=ld.AddQuery('d', i8, 0, api.m_prd_mgr.a_pdf_prd, true);
			ld.AddQuery('d', i12, 0, api.m_prd_mgr.a_prd_id, true);
			ld.AddQuery('d', i12, 0, api.m_prd_mgr.a_prd_name, true);
			ld.AddQuery('d', i12, 0, api.m_prd_mgr.a_prd_descr, true);
			ld.AddQuery('d', i12, 0, api.m_prd_mgr.a_prd_code, true);
		
			/*int i14=ld.AddQuery('r', i1, e_pd_eff, a_pde_usage, true);
					ld.AddQuery('d', i14, 0, a_pde_usage, true);
					ld.AddQuery('d', i14, 0, a_pde_id, true);
					ld.AddQuery('d', i14, 0, a_pde_prev, true);
					ld.AddQuery('d', i14, 0, a_pde_not_active, true);
					ld.AddQuery('d', i14, 0, a_sn_eff_start, true);
					ld.AddQuery('d', i14, 0, a_sn_eff_end, true);
					ld.AddQuery('d', i14, 0, a_dat_eff_start_s, true);
					ld.AddQuery('d', i14, 0, a_dat_eff_end_s, true);*/

		if (!ld.LoadEx()) return false;	
	}


	return true;
}

void CExport2Dlg::SetPaths(void)
{
	CString SetupFile = GetExePath()+"ExportKTS.dots";
	CExportTDDlg::ReadDots(SetupFile, "ExportKTS_M", &m_cbTemplates);

	CWinApp* app = AfxGetApp();
	if(app!=NULL)
		m_csOutPath=app->GetProfileString("ExportKTS_plugin","OutReportPath");

	CString cst;
	if(m_csOutPath=="")
	{
		//   
		//  Temp
		GetTempPath(2048,cst.GetBuffer(2048));
		cst.ReleaseBuffer();
		m_csOutPath.Format("%s%s.aplrep",cst,m_csPrdId);
	}
	else
		m_csOutPath.Format("%s\\%s.aplrep",cst,m_csPrdId);


}


/////////////////////////////////////////////////////////////////////////////
// CExport2Dlg message handlers
BOOL CExport2Dlg::OnInitDialog() 
{
	CaplInstance*	cit	=NULL;

	CDialog::OnInitDialog();

	m_OKbutton.SetIcon(GetAplStdIco16(APLSTDICO_OK));
	m_OKbutton.SetFlat(FALSE);
	m_Cancelbutton.SetIcon(GetAplStdIco16(APLSTDICO_CANCEL));
	m_Cancelbutton.SetFlat(FALSE);

	m_api->m_data.GetAttr(m_pdf,m_api->m_prd_mgr.a_pdf_prd,cit);
	m_api->m_data.GetAttr(cit,m_api->m_prd_mgr.a_prd_id,m_csPrdId);
	m_api->m_data.GetAttr(cit,m_api->m_prd_mgr.a_prd_name,m_csPrdName);
	m_api->m_data.GetAttr(m_pdf,m_api->m_prd_mgr.a_pdf_id,m_csVer);

	m_csDateTime=" ";
	m_csSerNo=" ";
	m_csContext=" ";

	SetPaths();

	UpdateData(FALSE);
	
	return TRUE;
}

void CExport2Dlg::OnOK() 
{
	UpdateData(TRUE);

	aplInstArray	aiOutPdfs,aiOutUnits;
	aplRealArray	arOutCounts;

	aplExtent		aet;

	CaplInstance*	cit1					=NULL;
	CaplInstance*	cit2					=NULL;
	CString			cst,cst2;

	double			d;

	int				i;

	MakeTable(m_pdf,m_ciContext,aiOutPdfs,arOutCounts,aiOutUnits,&m_Date,m_csSerNo);
	TRACE("sizes i %d u %d c %d\n",aiOutPdfs.GetSize(),aiOutUnits.GetSize(),arOutCounts.GetSize());

	CaplReportMgr m_dict;
	m_dict.Init();
	CDataSource *m_data_source = &m_dict.m_data_source;
	//
	CHeader* header = new CHeader(NULL);

	header->AddColumn("prd_id",		aplSTRING);
	header->AddColumn("prd_name",	aplSTRING);
	header->AddColumn("pdf_id",		aplSTRING);
	header->AddColumn("unit_name",	aplSTRING);
	header->AddColumn("d_val",		aplREAL);


	m_data_source->SetHeader(header);

	for(i=0;i<aiOutPdfs.GetSize();i++)
	{
		cit1=aiOutPdfs.GetAt(i);
		aet.Add(cit1);
	}

	m_api->m_prd_mgr.LoadPrdInfo(aet);

	for(i=0;i<aiOutPdfs.GetSize();i++)
	{
		CTableRow* p_row =new CTableRow;

		cit1=aiOutPdfs.GetAt(i);
		m_api->m_data.GetAttr(cit1,m_api->m_prd_mgr.a_pdf_prd,cit2);

		m_api->m_data.GetAttr(cit2,m_api->m_prd_mgr.a_prd_id,cst);
		p_row->AddColumn(cst);

		m_api->m_data.GetAttr(cit2,m_api->m_prd_mgr.a_prd_name,cst);
		p_row->AddColumn(cst);

		m_api->m_data.GetAttr(cit1,m_api->m_prd_mgr.a_pdf_id,cst);
		p_row->AddColumn(cst);

		cit1=aiOutUnits.GetAt(i);
		m_api->m_data.GetAttr(cit1,m_api->m_charact_mgr.a_apl_unit_name,cst);
		p_row->AddColumn(cst);

		d=arOutCounts.GetAt(i);
		p_row->AddColumn(d);

		m_data_source->AddRow(p_row);
	}

	SaveToFile(&m_dict);

	CString csPath;
	m_cbTemplates.GetWindowText(csPath);

	CRParamsArray RParams;

	if(GenerateReport(&m_dict, &RParams, m_csDictPath+csPath, m_csOutPath)) 
	{
		cst.Format("  !\n    %s.\n    ?", m_csOutPath);

		if(AfxMessageBox(cst,MB_YESNO)==IDYES)
		{	
/*			if(m_preview)
			{
				cst2.Format("\"%s\" \"%s\" /preview",
					exe_full_path, m_sOutFilename);
			}
*/
//			else
			{
				m_csExePath+="\\ReportConstructor.exe";
				cst2.Format("\"%s\" \"%s\"",
					m_csExePath, m_csOutPath);
			}
			
			if(aplCreateProcess(0, LPCSTR(cst2), false)==-1)
			{
				cst.Format("   \n%s",LPCSTR(cst2));
				AfxMessageBox(cst);
			}			
		}
	}


/*
	CRParamsArray RParams;

	if(GenerateReport(&m_dict, &RParams, m_sDotPath, m_sOutFilename)) 
	{
		buf.Format("  !\n    %s.\n    ?", out_file_path);

		if(AfxMessageBox(buf,MB_YESNO)==IDYES)
		{	
			if(m_preview)
			{
				tmp.Format("\"%s\" \"%s\" /preview",
					exe_full_path, m_sOutFilename);
			}
			else
			{
				tmp.Format("\"%s\" \"%s\"",
					exe_full_path, m_sOutFilename);
			}
			
			if(aplCreateProcess(0, LPCSTR(tmp), false)==-1)
			{
				CString buf; 
				buf.Format("   \n%s",LPCSTR(tmp));
				AfxMessageBox(buf);
			}			
		}
	}
*/


	
	CDialog::OnOK();
}

void CExport2Dlg::OnBSetFilter() 
{
	CString			csSN;
	COleDateTime	cdt;
	CaplInstance*	ciContext=NULL;
	CaplInstance*	ciNewContext=NULL;

	UpdateData(TRUE);

	if(m_csDateTime==" ")
		cdt.SetStatus(COleDateTime::invalid);
	else
		cdt=m_Date;

	if(m_csSerNo==" ")
		csSN="";
	else
		csSN=m_csSerNo;

	if(m_csContext==" ")
		ciContext=NULL;
	else
		ciContext=m_ciContext;

	if(m_api->m_prd_mgr.SelectDateSN(csSN,cdt,ciContext,&ciNewContext))
	{
		if(csSN.IsEmpty())
			m_csSerNo=" ";
		else
			m_csSerNo=csSN;

		if(cdt.GetStatus()!=COleDateTime::valid)
		{
			m_Date.SetStatus(COleDateTime::invalid);
			m_csDateTime=" ";
		}
		else
		{
			m_Date=cdt;
			m_csDateTime=m_Date.Format("%d.%m.%Y  %H:%M:%S");
		}

		m_ciContext=ciNewContext;
		if(NULL!=m_ciContext)
		{
			aplExtent aet;
			aet.Add(m_ciContext);
			m_api->m_prd_mgr.PrintItemContextInString(aet,m_csContext);
		}
		else
			m_csContext=" ";

		UpdateData(FALSE);
	}

	UpdateData(TRUE);
}

void CExport2Dlg::OnBSelRepFile() 
{
	CString cst,cst2;
	UpdateData(TRUE);
	CFileDialog dlg(FALSE,"aplrep",m_csOutPath,OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT,
		"ReportFiles (*.aplrep)|*.aplrep|All Files (*.*)|*.*||");

	if(dlg.DoModal()==IDOK)
	{
		//- 
		cst=dlg.GetPathName();
		cst2=cst.Right(7);
		if(cst2!=".aplrep")
			cst+=".aplrep";
		m_csOutPath=cst;
		UpdateData(FALSE);
		UpdateData(TRUE);
//		SetDlgItemText(IDC_E_OUT_FILE_PATH,m_csOutPath);
	}
}
